* Code generator for TURBO SuperBASIC compiler
*
*  Altered for GWASS -  11th April 2006
	low_ea
	data	$19000
*
*  Set TAB points (Editor) 9,17,25,33,41,49   OR	TAB Step (Hisoft) to 8
*
*	 (c) 1986 G.W.Jackson
*
*	Version 4.10
*	    -   5th March 2014: Add TURBO_CH
*
*	Version 4.09
*	    -   22nd May 2007: Allow up to 8 _INS files
*
*	Version 4.08
*	    -   16th February 2007: Some corrections for INS file
*
*	Version 4.07
*	    -   21st May 2006: Install an INS file if needed
*
*	Version 4.06
*	    -   11th April 2006: Open a primary window to define total outline
*			     (needed for a revised QPC2)
*
*	Version 4.05
*	    -  23rd July 2005: Reference string allowed (via str_ref)
*			   Dataspace increased from $10000 to $19000
*
*	Version 4.04
*	    -  27th April 2005: Prog's stack size taken from comms area
*
*	Version 3.11
*	    -  28th August 2002: Use callib2_asm & hed1
*
*	Version 3.10
*	    -  26th August 2002: Alter swin to give shallower windows
*
*	Version 3.09
*	   -   7th April 2002: Concat LF excised (it stopped TO working)
*
*	Version 3.08
*	   -   19th February 2002: String comparison <> type 2 inplace of 3
*			      ( in liboff9e2 )
*
*	Version 3.07
*	   -   17th February 2002: Version number taken from intercom
*
*	Version 3.06
*	   -  6th February 2002: Altered title -> v4.13
*
*	Version 3.05
*	   -  10th November 2001: Altered liboff9d2
*
*	Version 3.04
*	   -  26 Oct 2001: Altered liboff9c2 & Turbo v4.11
*
*	Version 3.03
*	   -   1 Aug 2001: Altered liboff9b2 & Turbo v4.10
*
*	Version 3.02
*	  -   16 Apr 2001: Improver added
*
*	Version 3.01
*	  -    8 Apr 2001: Added sr37 & sr38
*	  -    2 Mar 2001: Altered liboff9a
*	  -   29 Nov 2000: Altered liboff8k
*	  -   22 Oct 2000: Altered liboff8j & Copyright Indication
*	  -    9 Aug 2000: Altered liboff8i
*	  -    2 Aug 2000: Altered loboff8h
*	  -   25 Jul 2000: Altered liboff8g
*	  -    2 Jul 2000: Altered liboff8f
*	  -   18 Jun 2000: Altered liboff8e
*	  -   13 Jun 2000: Altered liboff8d
*	  -   26 May 2000: Altered liboff8c
*	  -    5 May 2000: Altered liboff8b
*	  -    1 May 2000: Set jmp 0(a6) @ s242 to ljmp
*	  -   12 Apr 2000: Set a window if PE
*	  -   10 Apr 2000: print ALL lines/min
*	  -   29 Mar 2000: sys_vars set from trap #1
*	  -   27 Mar 2000: data $10000
*	  -   25 Feb 2000: "sp" no longer defined

*	 2.15 16 Jun 1988: Parser comms area made 'indirect' - CTJD
*	 2.14 6  Aug 1987: Task name now passed in comms area from
*		         parser, for Turbo version 2.0
*	 2.13 28 Jan 1987: Code shuffled for MAKE_RESIDENT and orderly
*		         exit.
*	 2.12 26 Jan 1987: Patch field & checks for user ID included.
*	 2.11 24 Jan 1987: Yet another mod for ROM_FN in native mode to
*		         avoid a phase error.
*	 2.10 23 Jan 1987: Phase check conditionally carried out at every
*		         label occurrence in pass 1.
*		         Output file name left without _temp appendage
*		         on completion.
*	 2.09 20 Jan 1987: Pseudo_op POSSIBLE_LABEL added for FOR loops.
*		         In-line inner interpreter only added when
*		         'small_code' optimisation requested.
*		         Additional ROM_FN change for native mode. New
*		         S/R 36 added, because ROM_FN has an extra 2 bytes
*		         of parameters compared to ROM_PROC.
*	 2.08 15 Jan 1987: 16  bit IF jumps now test (A1), not (A1,A6)!
*	 2.07 14 Jan 1987: ROM_FN fix now works with input from a file.
*	 2.06 11 Jan 1987: Messages re-worded, GOTO expunged
*		         & ROM_FN special-case code corrected.
*	 2.05 31 Dec 1986: Bad_ink changed to white to agree with manual.
*		         File compacted using Chas Dillon's Editor.
*	      30 Dec 1986: Changed to read values of vect_tab_ad and nat_to_p
*		         from start of template library.
*	      22 Dec 1986: Backward jumps corrected for a loopstop:
*		         p to p back, test changed to ble
*		         p to n back, test changed to bgt
*
*
*	 2.04 19 Dec 1986: Option to put inner interpreter in-line instead of
*		         a jump to the interpreter.
*		         Lines per minute calculation only done if >50 lines.
*	       5 Dec 1986: Task name saved in template 999.
*		         Initial 999 cleared to detect erroneous restart.
*	       4 Dec 1986: Simon's magic number mods in 2.03 added.
*	       3 Dec 1986: Close channels in reverse order of opening.
*		         Try to avoid garbage in input data.
*		         Short addressing option added.
*	 2.03  6 Nov 1986: Error messages tidied up.
*	       3 Nov 1986: Lines per minute calculated.
*		         "CODED" or "FAULT" printed.
*	 2.02 31 Oct 1986: New parser interface.
*		         Sent to Simon on 31 October 1986.
*	 2.01 Modified by SNG 10 September 1986; mods marked: **
*		        Now assembles with DEVPAC QL & matches library!
*	 1.00 18 Aug 1986: Sent to Simon.
*
*
*
on		equ -1	Assembly switch values
off		equ 0
*
* one_error = "on"	 for code generator to abort after one non fatal error
*		= "off"  the code generator carries on ( for debugging )
*
one_error 	equ	on
*
* debug = "on" to insert literal identification strings to assist code
* identification when using a monitor program for debugging. Also to do
*  a phase check at every label occurrence in pass 1.
*
debug		equ off
impr_debug	equ	off
*
* del_int_file = "on" to delete the intermediate code file, useful sometimes
* to keep it for further testing.
*
del_int_file	equ on
*
* check_user_id = "on" if the user ID patch area must be checked. ** 2.12
*
check_user_id	equ on
*
*
*
*		** 2.15 "param_ad" changed to explicit location from "equ"
object_list	equ $160	Rel. addr. of "objects" list
data_space	equ 2	Offset from param_ad, holds size in K
ins		equ 4	ls bit set if INS extension
misc_flags	equ 5	ls bit set if code to be <64K
int_code_base	equ 6	Address of intermediate code stream
report_file	equ 10	Report file name
version		equ 110	version number from Parser
stack_size	equ 114	default override from Parser (348 - 9998)
*
myself		equ -1	Job ID
suspend_time	equ 20	Number of ticks for suspension
*
init_lab_inc	equ $8008
for_offset	equ 22
init_obj		equ 0
init_mode 	equ	0
row		equ	0	Row number for line display
col		equ	31	and column
size_int_buf	equ	32	Size of buffer for int code from file
if_p_to_n_offset	equ	14	Offset in p_code if_true, if_false code
s_if_p_to_n_offset	equ	12	Short offset in p code if's ** 2.08
p_to_p_offset	equ	8	Offset to short p to p jump in entry routine
next_offset	equ	12	Offset to interpreter in entry routine
p_to_n_offset	equ	18	Offset to p to n change in entry routine
sweet_16		equ	24	Offset to short n to p code
max_par_type	equ	38	Highest parameter type number * 8.4.01
overhead		equ	16000	Represents the maximum library overhead
t999_par_bytes	equ	2	Number of parameter bytes in template 999
max_write 	equ	$7FFE	maximum for io.sstrg
min_stk		equ	350	minimum stack size for a compiled prog
max_stk		equ	9998	maximum stack size for a compiled prog
*
pars		equ	1	Parameter flag for library index
*
* More parameters
white		equ	7	White paper
black		equ	0	Black ink
happy_paper	equ	4	Green paper for good reports
happy_ink 	equ	0	Black ink
bad_paper 	equ	2	Red paper for error reports
bad_ink		equ	7	White ink
back_paper	equ	0	Black paper for background reporting
good_back_ink	equ	4	Green ink for "CODED"
bad_back_ink	equ	2	Red ink for "FAULT"
*
* Screen positions for various messages
*
pe_head_x 	equ	208
pe_head_y 	equ	1
pass_x		equ	96
pass_y		equ	12
line_x		equ	184
line_y		equ	12
error_x		equ	304
error_y		equ	12
message_x 	equ	48	Messages relative to big window
message_y 	equ	35
err_scr_x 	equ	2	Messages relative to error window
err_scr_y 	equ	2
chars_per_line	equ	71
fat_turbo_x	equ	220
fat_turbo_y	equ	35
back_x		equ	444
back_y		equ	12
char_height	equ	0
msge_ch_width	equ	0
upper_ch_width	equ	1
fat_turbo_width	equ	3
back_ch_width	equ	1
*
*
* some template numbers
const_int 	equ	106
fch_int_var	equ	109
fch_float_var	equ	141
print_string	equ	186
fast		equ	254
slow		equ	255
line_temp 	equ	248
rom_name		equ	261
rom_proc		equ	227
rom_fn		equ	224
goto		equ	235
jump		equ	242
if_true		equ	245
if_false		equ	239
qinc_int		equ	337
qdec_int		equ	338
label_op		equ	378
ext_str		equ	385	** v 4.03 **
*
* Register names
*
pass		equr	d6	ls part = 0 or 1
p_flag		equr	d6	ms part = 0 for native, -1 for pseudo
st_size		equr	d7	Symbol table size
int_code		equr	a2	Points to intermediate code source
obj_code		equr	d5	Points to object code
symbol_table	equr	a4
lib_index 	equr	a5	Points to library index
pcode		equr	a5
base		equr	a6	For object code
*
* Constants needed		QDOS trap and vector numbers
*
sys_com		equ	8+sys_base   Address of address of comms area
sv.ramt		equ	$20	Relative to sys_vars start
ut.windw		equ	$C4
ut.scr		equ	$C8
ut.err		equ	$CC
ut.mtext		equ	$D0
cn.itod		equ	$F2
io.open		equ	1
io.close		equ	2
io.fstrg		equ	3
io.delet		equ	4
io.sbyte		equ	5
io.sstrg		equ	7
sd.pos		equ	$10
sd.nl		equ	$12
sd.pixp		equ	$17
sd.clear		equ	$20
sd.clrrt		equ	$24
sd.setpa		equ	$27
sd.setst		equ	$28
sd.setin		equ	$29
sd.setsz		equ	$2D
sd.wdef		equ	$D
sd.setmd		equ	$2C
fs.heads		equ	$46
fs.headr		equ	$47
mt.frjob		equ	5
mt.susjb		equ	8
mt.ipcom		equ	$11
mt.rclck		equ	$13
mt.alchp		equ	$18
mt.rechp		equ	$19
fs.posab		equ	$42
fs.posre		equ	$43
iop.pinf		equ	$70
*
job_marker	equ	$4AFB
end_spec		equ	$80
*
low_name		equ	2000	Tokens > 1999 are names or labels
lib_rec_size	equ	8	Size of entry in library index
*
st_rec_size	equ	6	Now accommodates a 32 bit address
p_ind_offset	equ	5	Offset to ls byte of label address in
*				symbol table, indicates label in p mode
*
max_sym_recs	equ	$FFFF	Maximum number of symbol table entries
*
* max_st		equ	393210	Maximum size of symbol table in bytes
*
*
* Macros
*
		in	win1_lib_hed1	 ** A string macro **
*
tp3	macro  which
		moveq	#sd.\1,d0
		bra	tp_3
		endm
*
* To set 3D windows
*
modwin	macro
		bsr	wdef1	black window
		moveq	#0,d1
		bsr	paper
		bsr	cls
		moveq	#4,d1
		moveq	#1,d2
		bsr	wdef	white window with green border
		moveq	#7,d1
		bsr	paper
		bsr	cls
		bsr	wdef1	set printing window
		endm
*
ljsr	macro
		dc.w	$4EAE,0	"jsr  0(base)" with a word = 0!!
		endm
*
ljmp	macro
		dc.w	$4EEE,0	"jmp  0(base)" with a word = 0!!
		endm
*
*string	 macro
*		 dc.w	 strg_end\@-strg_start\@
*strg_start\@	 dc.b	 '\1'
*strg_end\@	 equ	 *
*		 ds.w	 0
*		 endm
*
*
after_error macro			Either aborts or carries on
		ifeq	one_error Depending on state of one_error flag
		  \1
		endc
		ifne	one_error
		bra	fatal2
		endc
		endm
*
ident	macro				Inserts literal identification
		ifne	debug		strings for debugging only
		  bra.s over\@
		  dc.b	'\1'
		  ds.w	  0
over\@
		endc
		endm
*
lib_rec	macro			Library index record
		dc.w	\1		Template number
		dc.w	\3-\2+\4	Template length + parameter flag
		dc.w	\2-library_area-10	Offset to start of code v 4.10
		dc.w	-1		For compilation address
		endm
*
par_words macro		Number of parameter words
		dc.b	\1*2		Number of bytes
		endm
*
par_spec	macro			Parameter specification
		dc.b	\2*2		Type*2
		dc.w	\3		Offset into code
		dc.b	\1*2		Parameter number *2
		endm
*
end_par_spec	macro			Terminates parameter spec list
		dc.b	end_spec
		endm
*
********************************************************
* Code starts here
*
entry_point	bra.s   start
		dc.l	patch_area-entry_point+897343 ** 2.12: patch ptr
		dc.w	job_marker
		hed1     <'Codegen ',vers>
*
param_ad		dc.l	0	** 2.15
		dc.l	0
*				Absolute address of start of parameters
*				from the parser (obj. list ptr on THOR)
* watermk 	  string	  <D.P.:TURBO:INTER-COM>
		hed1	<'D.P.:TURBO:INTER-COM'>,watermk
*
*

start		moveq	#mt_inf,d0
		trap	#1
		lea	sys_base,a1
		move.l	a0,(a1)+
		move.l	sv.ramt(a0),(a1)+
		lea	object_list(a0),a0
		move.l	a0,(a1)
		bsr	set_erch	      To set an error channel & pe_flag
		lea	vital_regs,a0   To save registers for restart
		movem.l	a4-a7,(a0)
*
restart
*		move.l	#param_ad,a3		** 2.15 - line deleted
wait_a_bit	moveq	#mt.susjb,d0		Suspend myself for 20 ticks
		moveq	#myself,d1
		moveq	#suspend_time,d3
		suba.l	a1,a1
		trap	#1
		bsr	inter_com       ** 2.15
		move.l	param_ad,a1
		move.w	(a1),d0	Is error count zero yet?
		bne.s	wait_a_bit
		moveq	#mt.rclck,d0	Read the clock for lines per
		trap	#1		minute calculation
		lea	start_time,a0
		move.l	d1,(a0)
*
		suba.l	a4,a5		Size of symbol table = a5-a4-500
		suba.l	#500,a5	500 bytes for the stack
		lea	size_sym_tab,a0
		move.l	a5,d0
		cmpi.l	#max_sym_recs*st_rec_size,d0
		ble.s	st_not_too_big
		move.l	#max_sym_recs,d0
		bra.s	save_st_size
st_not_too_big
		moveq	#st_rec_size,d1	Get number of symbol table records
		divu	d1,d0			into d0
		andi.l	#$FFFF,d0 Ensure d0 < 64K
save_st_size	move.l	d0,(a0)		This value gets checked later
		lea	0(a6,a4.l),symbol_table Symbol table goes on end
*
* Now clear the symbol table area since QDOS doesn't
*
		movea.l	symbol_table,a0
		mulu	#st_rec_size,d0
clear_next	clr.l	(a0)+
		subq.l	#4,d0
		bge.s	clear_next
*
		lea	10+library_area,a5	v 4.10 (was 8)
		move.l	a5,d1
		lea	lib_address,a5  Set up absolute library pointer
		move.l	d1,(a5)
*
		ident	< Open error window >
*
* Open a separate window for error reports on screen, it will just fit insise
* the copyright window, it is done like this otherwise it is such a pain
* changing window colours, character sizes, deleting the fat TURBO etc
*
		movea.l	error_scr_chan,a0
*
		lea	err_chan,a1     Save here temporarily,
		move.l	a0,(a1)		overwritten later
*
		moveq	#happy_ink,d1		Set ink colour
		moveq	#-1,d3
		moveq	#sd.setin,d0		A0 is correct
		trap	#3
		tst.l	d0
		bne	fatal1
*
		moveq	#happy_paper,d1	Set paper colour
		moveq	#sd.setpa,d0		A0,D3 are correct
		trap	#3
		tst.l	d0
		bne	fatal1
*
		moveq	#happy_paper,d1	Set strip colour
		moveq	#sd.setst,d0		A0,D3 are correct
		trap	#3
		tst.l	d0
		bne	fatal1
*
		moveq	#msge_ch_width,d1	Character size 0,0
		moveq	#char_height,d2
		moveq	#sd.setsz,d0
		trap	#3
		tst.l	d0
		bne	fatal1
*
		ident	< Open message window >
*
		moveq	#myself,d1	Open window for messages, line numbers etc
		moveq	#0,d3		Use io.open to avoid screen being cleared
		lea	win,a0
		moveq	#io.open,d0
		trap	#2
		tst.l	d0
		bne	fatal1

**************************************
* Set an extra window for PE primary *
**************************************

		lea	win,a0
		moveq	#io.open,d0
		trap	#2
		tst.l	d0
		bne	fatal1


*
		lea	line_chan,a1
		move.l	a0,(a1)		Save for line number etc.
*
		moveq	#-1,d3
		moveq	#white,d1 	Set paper colour
		moveq	#sd.setpa,d0	A0,D3 are correct
		trap	#3
		tst.l	d0
		bne	fatal1
*
		moveq	#upper_ch_width,d1	Character size 1,0
		moveq	#char_height,d2
		moveq	#sd.setsz,d0
		trap	#3
		tst.l	d0
		bne	fatal1
*
		moveq	#white,d1 	Set strip colour
		moveq	#sd.setst,d0	A0,D3 are correct
		trap	#3
		tst.l	d0
		bne	fatal1
*
* If PE we want to set up the screen since Parser's has gone!
*
		move.b	pe_flag,d0
		bne	non_pe
		bsr	pe_win		set up heading for PE
non_pe		moveq	#black,d1 	Set ink colour
		moveq	#sd.setin,d0	A0 is correct
		trap	#3
		tst.l	d0
		bne	fatal1
*
		move.l	size_sym_tab,d1
		cmp.l	#375,d1		Check symtab is substantial
		bgt	check_rep
		lea	mess4,a0		      "Dataspace too small"
		bsr	error
		bra	fatal2
*
* To set headings for PE version
*
pe_win		lea	swin,a2		Set of window blocks
		bsr	wdef1		Set whole window
		move.w	#228,d1
		bsr	paper
		bsr	cls
		moveq	#7,d1
		bsr	paper
		moveq	#7,d1
		bsr	strip
		moveq	#0,d1
		bsr	ink
		modwin
		moveq	#0,d1
		bsr	csize
		lea	phead1,a1 	copyright
		bsr	sstrg
		movea.l	param_ad,a1
		moveq	#4,d2
		lea	version(a1),a1	point to version number . .
		bsr	sstrg1		. . and print it
		bsr	wdef1		window for "TURBO"
		moveq	#2,d1
		bsr	ink
		moveq	#3,d1
		bsr	csize
		move.w	#182,d1
		moveq	#1,d2
		bsr	cursor
		moveq	#1,d1
		bsr	over
		lea	phead2,a1 	TURBO first time
		bsr	sstrg
		move.w	#182,d1
		moveq	#2,d2
		bsr	cursor
		lea	phead2,a1 	TURBO second time
		bsr	sstrg
		moveq	#0,d1
		bsr	ink
		moveq	#0,d1
		bsr	over
		moveq	#1,d1
		bsr	csize
		modwin
		lea	phead3,a1 	"Pass: 0"
		bsr	sstrg
		modwin
		lea	phead4,a1 	"Line: 0"
		bsr	sstrg
		modwin
		lea	phead5,a1 	"Errors: 0"
		bsr	sstrg
		modwin
		lea	phead6,a1 	"Warnings: 0"
		bsr	sstrg
		bsr	wdef1		replace pass/line window
		rts
*
inter_com
*	** 2.15	New routine to find Parser intercom area
*			Written by novice assembler writer
*
*			Object list pointed to by 164192 (long)
*			Each element in list has +0 (long) ptr to next (0=end)
*						 +4 (long) ptr ident string
*						 +8 data starts
*
*
		lea.l	param_ad,a0
		movem.l	a1-a2,(a0)	  Save a1/a2 values
		movea.l	sys_com,a2
i_c_loop		move.l	(a2),a2
		move.l	a2,a0
		bsr	rng_chk
		move.l	4(a2),a0	Ident string for list element
		bsr	rng_chk
		moveq	#21,d0
		lea.l	watermk,a1
w_mk_loop 	cmpm.b	(a1)+,(a0)+ Compare watermark
		bne.s	i_c_loop
		dbra	d0,w_mk_loop
		adda.l	#30,a2
		tst.w	(a2)
		bmi	suicide3
		lea.l	param_ad,a0
		move.l	(a0),a1	Restore a1 value
		move.l	a2,(a0)
		move.l	4(a0),a2
		rts
*
rng_chk
		cmpa.l	sys_base,a0
		bls	fatal_cd	      Bad address - too low
		cmpa.l	sys_base+4,a0
		bhi	fatal_cd	      Bad address - too high
		rts
*
fatal_cd		moveq.l	#-7,d0	"not found" error code
		move.l	param_ad,a1 Restore a1 value
		move.l	param_ad+4,a2	Restore a2 value
		addq.l	#8,sp		Pop the return stack
		bra	fatal1
*
** 2.15 addition ends
*
*
* Check report file
*
		ident	< Check report file >
*
check_rep 	move.l	param_ad,a6	** 2.15 Amended
		adda.l	#report_file,a6	** 2.15 Amended
		move.w	(a6),d0		** 2.15 Amended
		beq.s	no_report_file
		cmpi.w	#41,d0		Test for garbage for the idiots
*					who start codegen without valid data
		bls.s	open_rep_file	OK (maybe) if in range 1 to 41
		moveq	#-1,d0		"Not complete"
		bra	fatal1		      Complain and stop
*
open_rep_file	moveq	#-1,d1		Try to open the report file
		movea.l	a6,a0
		moveq	#0,d3
		moveq	#io.open,d0
		trap	#2
		tst.l	d0		Exists if d0 = 0
		beq.s	save_id
*
		moveq	#-7,d1		Not found if d0 = 7
		cmp.l	d1,d0
		bne	fatal1		else fatal error
*
		moveq	#-1,d1		So open new report file
		moveq	#2,d3
		movea.l	a6,a0
		moveq	#io.open,d0	Open the report
		trap	#2
		tst.l	d0
		bne	fatal1
save_id		lea	err_chan,a1
		move.l	a0,(a1)	Save channel ID
		lea	report_flag,a1
		move.b	#-1,(a1)	Set report file flag
*
		move.l	#1000000,d1 Move to end of report file
		moveq	#-1,d3		by using an impossibly big
		moveq	#fs.posab,d0	number
		trap	#3
no_report_file
* No error check here so that report to printer does not fail
*
* Set various flag bytes for reporting progress and messages. All flags were
* cleared above.
*
		moveq	#-1,d1
		move.b	misc_flags-report_file(a6),d0
		btst	#0,d0			ls bit = 1 means <64K code
		beq.s	big_code
		lea	small_code,a0
		move.b	d1,(a0)
big_code
		lea	ins_flag,a0
		move.b	ins-report_file(a6),d0
		beq	transitory		no INS extension
		move.b	d0,(a0)			set ins_flag
*		 lea	 back_flag,a0
*		 move.b	 residence-report_file(a6),d0  d0 := residence permit
*		 bge.s	 transitory		 ms bit = 1 for resident
*		 move.b	 d1,(a0)		 Set background flag
*		 move.b	 report_flag,d0		 Is report flag set?
*		 bne.s	 flags_done		 No, so screen messages
transitory	move.b	d1,-(a0)		Set screen message flag
		move.b	d1,-(a0)		Set progress flag
flags_done
*
* Check input file
*
		ident	< Check input file >
*
		move.l	int_code_base-report_file(a6),d0 Get code address
		bclr	#0,d0			Just in case it is odd garbage
		lea	int_start,a0
		move.l	d0,(a0)
		addq.l	#4,(a0)		Hide entry_routine
*
* Calculate address of output file name
*
		move.w	(a6),d1	D1 is length of report name
		addq.w	#3,d1		Allow for length word
		bclr	#0,d1		and round up to even
		movea.w	d1,a0		  and put into A0
		adda.l	a6,a0		A0 -> input file name (if any)
		movea.l	a0,a6
		lea	op_file_addr,a1
		move.l	a0,(a1)	Keep tabs on the name
		tst.l	d0
		bne.s	int_code_ram
*
		moveq	#-1,d1		Open intermediate code stream
		moveq	#0,d3
		moveq	#io.open,d0
		trap	#2
		tst.l	d0
		bne	fatal1
		lea	int_id,a1
		move.l	a0,(a1)
		lea	from_file,a1    Set flag
		moveq	#-1,d0
		move.w	d0,(a1)
*
		ident	< Open output file >
*
int_code_ram	subq.w	#5,(a6)	Lose '_temp' appendage
		movea.l	a6,a0
		moveq	#-1,d1		Ensure output file deleted
		moveq	#io.delet,d0
		trap	#2		Ignore errors
		movea.l	a6,a0
		moveq	#-1,d1		Open output file
		moveq	#2,d3
		moveq	#io.open,d0
		trap	#2
		addq.w	#5,(a6)	Restore '_temp' appendage
		tst.l	d0
		bne	fatal1
		lea	obj_chan,a1 Save channel ID
		move.l	a0,(a1)
*
* 2.14	Remember address of task name, now separate from output file
* name which it follows in the comms area
*
		moveq	#0,d0
		move.w	(a6),d0	d0 := length of output file_temp
		addq.w	#3,d0		Allow for length word of string
		bclr	#0,d0		Ensure even
		add.l	a6,d0		d0 --> task name
		lea	task_name_addr,a1
		move.l	d0,(a1)	Save address of task name for later
*
* End of 2.14 code
*
		moveq	#0,d0		Set up size of data space
		lea	max_stack,a2	** 4.04
		move.l	param_ad,a1	** 2.15
		move.w	stack_size(a1),d0	** 4.04
		bclr	#0,d0		** 4.05 str_ref?
		sne	2(a2)		** 4.05
		cmpi.w	#min_stk,d0	** 4.04
		blt	no_stk		** 4.04
		cmpi.w	#max_stk,d0	** 4.04
		bgt	no_stk		** 4.04
		move.w	d0,(a2)		** 4.04	override the default
no_stk		addq.w	#1,(a2)		** 4.04	round up
		bclr	#0,1(a2)		** 4.04
		move.w	data_space(a1),d0	** 2.15
		lsl.l	#5,d0		Convert K to bytes
		lsl.l	#5,d0
		lea	io_buf,a1
		move.b	#1,5(a1)		File type = 1
		move.l	d0,6(a1)		Save in header
		moveq	#fs.heads,d0
		moveq	#-1,d3			Make output file EXECable
		trap	#3
		tst.l	d0
		bne	fatal1
*
************************************************
* New code added - 13th April 2001	       *
*				       *
* This alters the input stream to "improve" it *
************************************************
*
		movea.l	lib_address,lib_index
		lea	hide_a4,a2
		move.l	a4,(a2)
		movea.l	int_start,int_code
		subq.l	#4,int_code
g_next		bsr	g_token		Get the next token
g_n1		beq	done		End of input stream
klim		cmpi.w	#fch_int_var,d4
		beq	fch_int
		cmpi.w	#fch_float_var,d4
		beq	fch_flt
		cmpi.w	#if_false,d4
		beq	ifsa
		cmpi.w	#if_true,d4
		beq	ifsb
		cmpi.w	#const_int,d4
		beq	coerc
*
* Now skip parameters, if needed
*
		move.w	2(a0),d2		length of code
		bclr	#0,d2
		beq	g_next		No parameters
		bsr	get_par1		D1 = no of par bytes
		tst.b	d1
		bmi	g_str		String parameters
		andi.w	#$1F,d1		Keep true bytes
		adda.w	d1,int_code	(no effect on file)
		move.w	from_file,d0
		bne	posre		Not ram
		bra	g_next
*
g_str		cmpi.w	#rom_proc,d4
		beq	r_proc
		cmpi.w	#rom_name,d4
		beq	r_proc
		cmpi.w	#rom_fn,d4
		beq	r_fn
		cmpi.w	#ext_str,d4
		beq	ex_str
		bsr	get_its
		move.w	(int_code)+,d1	String length
		addq.w	#1,d1
g_str1		bclr	#0,d1		Round
		adda.l	d1,int_code	(no effect on file) (was .w)
		move.w	from_file,d0
		beq	g_next		ram finished
posre		bsr	set_posre
		bra	g_next
*
r_fn		moveq	#6,d2
		bra	r_proc1
r_proc		moveq	#4,d2
r_proc1		bsr	get_its1
		adda.w	d2,int_code
		moveq	#0,d1
		move.b	-2(int_code),d1	string length
		bra	g_str1

ex_str		bsr	get_its4
		move.l	(int_code)+,d1	long string length
		addq.l	#1,d1		for rounding
		bra	g_str1
*
**********************************************************
* Print string : Print slash -> Concat LF : Print string *
*    (186)         (203)	    (206)        (186)     *
**********************************************************
prt_3		pea	g_n1
		bra	g_t3		Another token
*************************************************************
* if_true | jump -> if false | no jump			*
* ____________________________________________________	*
* | 239 |  K  | / / / / | 242 |  L  | <- . . K . .-> |	*
*	      becomes				*
* ___________________________________			*
* | 245 |  L  | / / / / |  2	|  2  |			*
*						*
* (Similarly 245 etc -> 239 etc )			*
*						*
* <- . . K . .> means "The label K appears before any token *
*************************************************************
ifsa		move.w	#245,d5
		bra	ifsb_1
ifsb		move.w	#239,d5
ifsb_1		swap	d5
		lea	old_pos,a4
		move.l	int_code,(a4)
		move.w	from_file,d0
		beq	ifsb_2
		bsr	save_pos
		moveq	#2,d2
		bsr	get_int
		lea	int_buf,int_code
ifsb_2		move.w	(int_code)+,d7	K
		bsr	g_token		get next token
		beq	done		Ended
		cmpi.w	#jump,d4
		bne	klim		No - go back
		lea	old_pos2,a4
		move.l	int_code,(a4)	No effect on file
		move.w	from_file,d0
		beq	ifsb_3
		bsr	save_pos
		moveq	#2,d2
		bsr	get_int
		lea	int_buf,int_code
ifsb_3		move.w	(int_code)+,d6	L
ifsb_4		bsr	get_its
		move.w	(int_code)+,d0
		cmp.w	d0,d7		K found? . .
		beq	ifsb_5		. . yes
		cmpi.w	#low_name,d0	token? . .
		bcc	ifsb_4		. . no
		move.w	d0,d4		set token
		pea	g_n1
		bra	g_t4
*
ifsb_5		move.w	d6,d5		L
		moveq	#2,d7
		swap	d7
		addq.w	#2,d7
		move.w	from_file,d0
		beq	ifsb_6		ram
		lea	curr_pos,a4
		bsr	save_pos
		move.l	old_pos,d1
		subq.l	#2,d1
		bsr	set_pos
		lea	int_buf,a1
		move.l	d5,(a1)
		moveq	#4,d2
		bsr	send_fl
		move.l	old_pos2,d1
		subq.l	#2,d1
		bsr	set_pos
		lea	int_buf,a1
		move.l	d7,(a1)
		moveq	#4,d2
		bsr	send_fl
		move.l	curr_pos,d1
		bsr	set_pos
		bra	g_next
*
ifsb_6		movea.l	old_pos,a0
		move.l	d5,-2(a0)
		movea.l	old_pos2,a0
		move.l	d7,-2(a0)
		bra	g_next
***********************************************************
* Case A: 				        *
* x = x + 1, 2 or 4 -> increment float 1, 2 or 4	        *
*					        *
* Case B: 				        *
* fch_float | fch_float -> fch_float | duplicate float    *
*					        *
* Case A: 				        *
* _____________________________________ 	        *
* | 141 |  K  | 377 | Exp | Mant | 37 | 	        *
*					        *
*  Becomes				        *
* _____________________________________ 	        *
* | 141 |  K  | 363 |  2  |  2   |  2 | 	        *
*					        *
* 363 is for increment by 1. This becomes 335 for 2 and   *
* 336 for 4				        *
*					        *
* Case B: 				        *
* _________________________			        *
* | 141 |  K  | 141 |  K  |			        *
*					        *
* Becomes 				        *
* ________________________			        *
* | 141 |  K  | 283 |  2  |			        *
***********************************************************

fch_flt		bsr	get_its4
		move.w	(int_code)+,d7	K
fch_flt2		move.w	(int_code)+,d4	next token?
		beq	done		Ended
		cmpi.w	#377,d4
		beq	fch_a		Case A
		cmpi.w	#141,d4
		bne	prt_3		Go back
		bsr	get_its4
		move.w	(int_code)+,d0
		exg	d0,d7		Set another K?
		cmp.w	d0,d7
		bne	fch_flt2		No match
		move.w	#283,d5		Duplicate_float
		swap	d5
		move.w	#2,d5
		move.w	from_file,d0
		beq	fch_flt3
		moveq	#-6,d1
		bsr	set_posre
		lea	int_buf,a1
		move.l	d5,(a1)
		moveq	#4,d2
		bsr	send_fl
		bra	g_next
fch_flt3		move.l	d5,-4(int_code)
		bra	g_next
*
* Case A
*
fch_a		moveq	#6,d2
		bsr	get_its1
		move.w	(int_code)+,d6	exponent
		cmpi.w	#$4000,(int_code)+
		beq	fch_a2		could be 1, 2 or 4
fch_a4		pea	g_n1
		bra	g_t1		not found
fch_a2		move.w	#363,d5		increment 1
		subi.w	#$801,d6
		beq	fch_a3		1
		bmi	fch_a4		not found
		subq.w	#2,d6
		beq	fch_a5		4
		bpl	fch_a4		not found
		subq.w	#1,d5
fch_a5		subi.w	#27,d5
fch_a3		move.w	(int_code)+,d4
		beq	done		Ended
		cmpi.w	#37,d4
		bne	prt_3		not fond
		lea	-8(int_code),int_code        step back
		move.w	from_file,d0
		beq	fch_a10		ram
		moveq	#-8,d1
		bsr	set_posre
		lea	int_buf,int_code
fch_a10		move.w	d5,(int_code)+
		moveq	#2,d0
fch_a11		move.w	#2,(int_code)+
		dbf	d0,fch_a11
		move.w	from_file,d0
		beq	g_next		ram
		moveq	#8,d2
		lea	int_buf,a1
		bsr	send_fl
		bra	g_next
******************************************************
* Case A: 				   *
* x% = x% + K -> inc_int or qinc_int		   *
* x% = x% - K -> dec_int or qdec int		   *
* ___________________________________________	   *
* | 109 |  K  | 106 |  L  | 5/6 | 118 |  K  |	   *
*					   *
* Becomes 				   *
* ___________________________________________	   *
* |  x  |  K  |  L	|  2  |  2  |  2  |  2  |	   *
*					   *
* where x = qinc/qdec if L is 1 to 8 : else inc/dec  *
*					   *
* Cae B:					   *
* fch_int | fch_int -> fch_int | duplicate_int	   *
* _________________________			   *
* | 109 |  K  | 109 |  K  |			   *
*					   *
* Becomes 				   *
* _________________________			   *
* | 109 |  K  | 268 |  2  |			   *
******************************************************
fch_int		bsr	get_its4
		move.w	(int_code)+,d7	K
fch_i2		move.w	(int_code)+,d4
		beq	done		Ended
		cmpi.w	#106,d4
		beq	fch_i_a		Case A
		cmpi.w	#109,d4
		bne	prt_3		not found
		bsr	get_its4
		move.w	(int_code)+,d0
		exg	d0,d7		Possible new K
		cmp.w	d0,d7
		bne	fch_i2
		subq.l	#4,int_code
		move.w	from_file,d0
		beq	fch_i4
		moveq	#-6,d1
		bsr	set_posre
		lea	int_buf,int_code
fch_i4		move.w	#268,(int_code)+
		move.w	#2,(int_code)+
		move.w	from_file,d0
		beq	g_next
		moveq	#4,d1
		lea	int_buf,a1
		bsr	send_fl
		bra	g_next
*
fch_i_a		bsr	get_its4
		move.w	(int_code)+,d6	L
		move.w	(int_code)+,d4
		beq	done		Ended
		move.w	#339,d5
		cmpi.w	#5,d4		add? . .
		beq	fch_add		. . yes
		cmpi.w	#6,d4		sub? . .
		bne	prt_3		. . no
		addq.w	#1,d5		dec - inc
fch_add		bsr	get_its
		move.w	(int_code)+,d4
		beq	done		Ended
		cmpi.w	#118,d4
		bne	prt_3		not found
		bsr	get_its
		cmp.w	(int_code)+,d7
		bne	g_next		not found
		cmpi.w	#1,d6
		blt	fch_add3
		cmpi.w	#8,d6
		bgt	fch_add3
		subq.w	#2,d5		qinc - inc
fch_add3		lea	-14(int_code),int_code  step back
		move.w	from_file,d0
		beq	fch_add4
		moveq	#-14,d1
		bsr	set_posre
		lea	int_buf,int_code
fch_add4		move.w	d5,(int_code)+
		move.w	d7,(int_code)+
		move.w	d6,(int_code)+
		moveq	#3,d0
fch_add5		move.w	#2,(int_code)+
		dbf	d0,fch_add5
		move.w	from_file,d0
		beq	g_next
		moveq	#14,d2
		lea	int_buf,a1
		bsr	send_fl
		bra	g_next
**************************************************
* 1+v -> set 1 as fp ab initio	         *
*				         *
* ___________________________________________    *
* | 106 |  K  |<- float ->| 155 | 320 | 156 |    *
*				         *
* Becomes 			         *
* ___________________________________________    *
* | 377 |  K1 |  K2 |<- float ->|  2  |  2  |    *
*				         *
* Here "float" is one of const_float, long_float *
* or fch_float_var			         *
* and K1, K2 are exponent and mantissa of K      *
**************************************************
coerc		bsr	get_its4
		move.w	(int_code)+,d7	K
		move.w	(int_code)+,d4
		beq	done
		moveq	#8,d2		prepare for const_float
		cmpi.w	#138,d4
		beq	coerc8		it is const_float
		cmpi.w	#377,d4		long_float? . .
		beq	coerc6		. . yes
		cmpi.w	#141,d4		fch_float_var? . .
		bne	prt_3		. . no
		subq.w	#2,d2
coerc6		subq.w	#2,d2
coerc8		bsr	get_its1		 get 4, 6 or 8
		lea	int_buf+16,a0	prepare to put "float" . .
		move.w	d2,(a0)+		. . to buffer
		subq.w	#2,d2
		move.w	d4,(a0)+		set the token
coerc1		move.w	(int_code)+,(a0)+
		subq.w	#2,d2
		bne	coerc1
		move.w	(int_code)+,d4	next token
		beq	done
		cmpi.w	#155,d4
		bne	prt_3		not found
		bsr	get_its
		move.w	(int_code)+,d4
		beq	done
		cmpi.w	#320,d4
		bne	prt_3		not found
		bsr	get_its
		move.w	(int_code)+,d4
		beq	done
		cmpi.w	#156,d4
		bne	prt_3		not found
		moveq	#10,d2
		add.w	16+int_buf,d2
		suba.w	d2,int_code
		move.w	from_file,d0
		beq	coerc2
		move.l	d2,d1
		neg.l	d1
		bsr	set_posre
		lea	int_buf,int_code	set for new input
coerc2		move.w	#377,(int_code)+
*
* Now set K -> fp
*
		move.w	d7,d6
		beq	coerc3		already converted
		move.w	#14,d6
coerc5		lsl.w	#1,d7
		dbmi	d6,coerc5
		lsr.w	#1,d7
		addi.w	#$801,d6
coerc3		move.w	d6,(int_code)+
		move.w	d7,(int_code)+
		lea	16+int_buf,a0
		move.w	(a0)+,d2		4, 6 or 8
coerc7		move.w	(a0)+,(int_code)+	set token + d2-2 bytes
		subq.w	#2,d2
		bne	coerc7
		move.w	#2,(int_code)+
		move.w	#2,(int_code)+
		move.w	from_file,d0
		beq	g_next
		lea	int_buf,a1	start of insert
		move.l	int_code,d2
		sub.l	a1,d2		no. of bytes to send
		bsr	send_fl
		bra	g_next
*
g_token		bsr	get_its
g_t1		move.w	(int_code)+,d4
		beq	g_exit		Ended
g_t3		cmpi.w	#low_name,d4
		bcc	g_token		Not token
g_t4		cmpi.w	#1000,d4
		blt	g_t2
		subi.w	#1000,d4
g_t2		cmpi.w	#label_op,d4
		beq	g_token
		bsr	srch_user_lib
		bne	g_exit
		addi.w	#1000,d4
		bsr	srch_user_lib
		beq	not_found 	---->
		subi.w	#1000,d4
g_exit		rts
*
* Sends d2.w bytes to file from (a1)
*
send_fl		moveq	#io_sstrg,d0
		bra	set_posre1
*
get_its4		moveq	#4,d2
		bra	get_its1
get_its		moveq	#2,d2
get_its1		move.w	from_file,d0
		beq	get_its2		ram
		bsr	get_int
		lea	int_buf,int_code
get_its2		rts
*
save_pos		moveq	#0,d1
		bsr	set_posre
		move.l	d1,(a4)
		rts
*
set_posre 	moveq	#fs_posre,d0
set_posre1	movea.l	int_id,a0
		moveq	#-1,d3
		trap	#3
		tst.l	d0
		bne	fatal1	---->
		rts
*
set_pos		moveq	#fs_posab,d0
		bra	set_posre1
*
done

		if impr_debug = on
		bra	suicide1
		endif

		movea.l	hide_a4,a4
		move.w	from_file,d0
		beq	done_1
		moveq	#0,d1
		bsr	set_pos
done_1		moveq	#$33,d1		Show pass 3
		bsr	show_pass
*
		bsr	show_line0
*
		move.w	vect_tab_ad+2,d0	d0 := global address,
*						nat_to_p at (vect_tab_ad+2)
		lea	p_next+2,a0     Save global address in jump to
		move.w	d0,(a0)		interpreter template
		addi.w	#next_offset,(a0)
		lea	s_n_to_p_temp+2,a0	      Save global address in short
		move.w	d0,(a0)		n to p template
		addi.w	#sweet_16,(a0)		+offset
		lea	n_to_p_temp+2,a0	      Save global address in
		move.w	d0,(a0)		special jump template
		lea	p_to_n_temp,a0	      Save global address in p to n
		move.w	d0,(a0)		template
		addi.w	#p_to_n_offset,(a0)
		lea	p_to_p_short,a0	      Save global address in short
		move.w	d0,(a0)		p to p template
		addi.w	#p_to_p_offset,(a0)
*
		moveq	#init_mode,p_flag	Initial mode selected by flag
		clr.w	pass			Start with pass 0
		moveq	#0,st_size		Symbol table initially empty
		moveq	#0,obj_code	Initially 0
		movea.l	lib_address,lib_index
*
		ident	< Process template 999 >
*
		move.w	from_file,d0
		beq.s	ram_input
		moveq	#2,d2
		bsr	get_int
		lea	int_buf,int_code
		bra.s	get_first
ram_input 	movea.l	int_start,int_code	Special code for template 999
		subq.l	#4,int_code
get_first 	move.w	(int_code),d4
		move.w	#0,(int_code)+		Zap 999 for erroneous restart
		cmpi.w	#999,d4		Check first is entry_routine
		beq.s	is_999
		lea	not_999_mess,a0	      First instruction not 999
		bsr	error
		bsr	rep_new_line
		bra	fatal2			      A fatal error
is_999		bsr	srch_user_lib
		beq	not_found
*						Save task name in template 999
		moveq	#0,d0
		move.w	4(a0),d0
		lea	8(lib_index,d0.w),a3      a3 --> length word in 999
		move.l	task_name_addr,a1	** 2.14  a1 --> task name
		move.w	(a1)+,d0		** 2.14  d0 := length of name
		cmpi.w	#12,d0			Ensure d0 in range 0..12
		bls.s	insert_length
*
* If length > 12, assume garbage eg use with earlier version than Parser 2.0
* so use output file name as in earlier versions of TURBO
*
		movea.l	op_file_addr,a1	  a1 --> output file name
		move.w	(a1),d0		d0 := length
		subq.l	#5,d0			for mdv1_
		subq.l	#5,d0			for _temp
		addq.l	#7,a1			move past mdv1_
		cmpi.w	#12,d0
		bls.s	insert_length		Limit length to 12
		moveq	#12,d0
*
insert_length	move.w	d0,(a3)+		Save name length
		move.l	#$20202020,d1		Fill space in 999 with blanks
		move.l	d1,(a3)+
		move.l	d1,(a3)+
		move.l	d1,(a3)
		subq.l	#8,a3			a3 back to name start
		bra.s	dec_name_len
next_byte 	move.b	(a1)+,(a3)+	Save up to 12 bytes of task name
dec_name_len	dbra	d0,next_byte
*
		move.w	from_file,d0
		beq.s	ram1
		moveq	#t999_par_bytes,d2	Get parameters for 999
		bsr	get_int
		lea	int_buf,int_code
ram1		moveq	#0,d2
		addq.w	#1,pass		To fool code into saving template
		bsr	process_pars
		move.w	2(a0),d0		d0 := size_999
		subq.w	#1,d0
		lea	lab_inc,a1
		add.w	(a1),d0
		add.w	obj_code,(a1)
		lea	max_2byte_dest,a0	      Subtract obj_code
		sub.l	obj_code,(a0)		(= size_999 + vector_table)
*						from max address in range of base
		lea	entry_ad,a0
		move.w	d0,(a0)		To calculate offset
		moveq	#init_obj,obj_code
		adda.l	d1,int_code
		clr.w	pass
*
*
* start of main loop
*
		ident	< Next token >
*
next_token	move.w	from_file,d2
		beq.s	not_file
		moveq	#2,d2
		bsr	get_int
		lea	int_buf,int_code
not_file		move.w	(int_code)+,d4		Get token
		beq	end_int		      End if token is 0
		cmp.w	#low_name,d4
		bcs	int_ins	      ( bcs = blo ) instruction if < 2000
*
		ident	< Label or name >
*
		tst.w	pass			Is label or name
		ifeq	debug
		  bne.s	next_token	  No action in pass 1
		endc
		ifne	debug
		  bne	phase_check	** 2.10
		endc
		bsr	srch_sym_tab	      Search symbol table
		bgt	label_err       In pass 0 it should not be found
*
test_st_fullness
		subq.l	#st_rec_size,d2
		cmp.l	d2,st_size
		blt.s	st_not_full
		lea	mess4,a0		      "Dataspace too small"
		bsr	error
		bra	fatal2
*
st_not_full	move.w	d4,(a0)+
		move.l	obj_code,(a0)		Insert label location
		tst.l	p_flag
		bge.s	no_add_p
		ori.l	#1,(a0)		add p_flag to mark type of code
*
no_add_p		addq.l	#st_rec_size,st_size
		bra.s	next_token
*
label_err 	lea	mess5,a0		"Duplicated label"
report_error	bsr	error
		bsr	print_num
		bsr	rep_new_line
		after_error <bra	next_token>
*
phase_check	bsr	srch_sym_tab	    ** 2.10
		move.l	2(a0),d0		Debug check on phase in pass 1
		bclr	#0,d0
		cmp.l	d0,obj_code
		beq	next_token
		lea	lab_phase_mess,a0	      "Codegen phase error at label"
		bsr	error
		bsr	print_num
		bsr	rep_new_line
		bra	fatal2
*
		ident	< End of intermediate code stream >
*
end_int		tst.w	pass
		bne	end_pass1
		moveq	#init_mode,p_flag
		clr.w	pass
		addq.w	#1,pass		pass:=1
* now adjust label and name locations in the symbol table to account for
* the p code templates that have already been written to the object file
		move.l	size_sym_tab,d0
		moveq	#0,d1
		move.w	lab_inc,d1		d1 := increment
		ext.l	d1
		movea.l	symbol_table,a0
		subq.l	#4,a0		Point a0 to symbol table base - 4
		bra.s	dec_no_recs
next_symbol	addq.l	#st_rec_size,a0	Point to next location value
		add.l	d1,(a0)		Add on increment
dec_no_recs	dbra	d0,next_symbol
*
		lea	max_2byte_dest,a1	      Update maximum address in range
		add.l	d1,(a1)		with lab_inc for pass 1 jump tests
*
		add.l	d1,obj_code	Save code size for phase check at
		lea	code_size,a1	      end of pass 1
*
* This nasty code looks through PATCH_AREA bytes 3-50 and ensures that they
* add up to 2 (MOD 65536). It's         easily spotted by anyone who looks through
* the code "by hand", but should be trickier for machines to find. Maybe we
* can smarten it up for later versions of TURBO? Code introduced for ** 2.12
*
		ifne	check_user_id
crimewatch	moveq	#24,d2			A giveaway? DBRA 50 bytes
		move.l	a1,a0			Pointer needed
sum_up		add.w	patch_area-code_size+2(a0),d0 Initially -1 from DBRA
		addq.l	#2,a0			Conspicuously inefficient?!
		dbra	d2,sum_up
		add.w	d2,d0			Is 16-bit total=1?
		beq.s	not_cheating
punishment	moveq	#2,d2
		bsr	inc_write_obj	      A guaranteed phase error!
		endc
*
not_cheating	move.l	obj_code,(a1)
		move.b	small_code,d0		<64K code size specified?
		beq.s	init_obj_code		Yes, check code size
		cmpi.l	#$7FFF,obj_code
		ble.s	init_obj_code
		lea	toobig_mess,a0	      Fatal error if too big
		bsr	error
		bsr	rep_new_line
		bra	fatal2
*
* Initialise obj_code to lab_inc for pass 1
init_obj_code	move.l	d1,obj_code
* Indicate the pass
		moveq	#$34,d1		Show pass 4
		bsr	show_pass
*
		lea	line,a0		      Clear the latest line number
		move.w	#0,(a0)
		bsr	show_line0	      Clear the line display
		lea	num_lines,a0	      and the line count
		move.w	#0,(a0)
*
		movea.l	int_start,int_code	  Reset to start of input
		move.w	from_file,d2
		beq	not_file
		moveq	#-1,d3			Reset int code file to near start
		moveq	#4,d1
		movea.l	int_id,a0
		moveq	#fs.posab,d0
		trap	#3
		tst.w	d0
		bne	fatal1
		bra	next_token
*
		ident	< End of pass 1 >
*
end_pass1 	move.w	entry_ad,d0 Save offset at end of object code
		moveq	#2,d2		for the entry routine
		lea	lab_inc,a1
		sub.w	d0,(a1)
		bsr	write_obj
*
		cmp.l	code_size,obj_code	Check code size is same
		beq.s	no_phase_error		in both passes
		lea	phase_mess,a0	      Report if not
		bsr	error
		bsr	rep_new_line
		bra	fatal2
*
no_phase_error	move.w	error_flag,d0
		bne	fatal2
		bra	terminate
*
*
label_pseudo_op	move.w	from_file,d2	Label that may be redefined for
		beq.s	is_in_ram FOR loops
		moveq	#2,d2
		bsr	get_int
		lea	int_buf,int_code
is_in_ram 	move.w	(int_code)+,d4
		cmpi.w	#low_name,d4
		bcc.s	is_a_label
		lea	low_label_mess,a0	      "FOR loop label too low"
		bra	report_error
is_a_label	tst.w	pass
		bne	next_token      Ignore in pass 1
		bsr	srch_sym_tab
		bgt	st_not_full Enter into symbol table whether already
		bra	test_st_fullness	      there or not
*
*
		ident	< Process intermediate instruction >
*
int_ins		cmpi.w	#2,d4
		beq	next_token		ignore int_plus
		cmpi.w	#34,d4
		beq	next_token		ignore plus_float
		cmp.w	#1000,d4	Ensure < 1000
		blt.s	less_1k
		sub.w	#1000,d4
*
* Firstly test for pseudo_ops
*
less_1k		cmpi.w	#label_op,d4
		beq.s	label_pseudo_op
		cmpi.w	#qinc_int,d4
		beq	alt_qinc
		cmpi.w	#qdec_int,d4
		bne	no_alt
alt_qinc		tst.l	p_flag
		bge	no_alt
		addq	#2,d4		alter qinc/dec -> inc/dec
no_alt		bsr	srch_user_lib
		bne.s	temp_found
*
		tst.l	p_flag		If we're in P_mode, all may not
		bpl.s	not_found be lost	...
		add.w	#1000,d4	Try looking for the p equivalent
		bsr	srch_user_lib
		bne.s	got_p_only
*
not_found 	lea	no_temp_mess,a0	"Template not found"
		bsr	error
		bsr	print_num
		lea	not_found_mess,a1
		bsr	rest_of_mess
		bsr	rep_new_line
		after_error <bra	next_token>
*
temp_found	moveq	#0,d2
		move.w	2(a0),d2		d2 := length of code
		bclr	#0,d2			Set if parameterised code
		beq	no_pars
		tst.l	p_flag
		bge.s	has_pars
		add.w	#1000,d4		For pseudo template search again
		bsr	srch_user_lib
		beq.s	not_found
got_p_only	sub.w	#1000,d4		For tests below
		moveq	#0,d2
		move.w	2(a0),d2
		bclr	#0,d2
*
* Test if 16 bit label addresses are being processed, ie <64K code is
* being generated, if so we must point a0 to the internal library templates
* if a jump is being processed.
*
		ident	< Test for jumps >
*
has_pars		move.b	small_code,d0		<64K program specified?
		beq.s	get_params
		cmp.w	#goto,d4		A quick test to speed most
		blt.s	get_params		non-jumps on their way
		cmp.w	#if_true,d4
		bgt.s	get_params
		moveq	#0,d0
		cmp.w	#if_true,d4
		bne.s	not_if_true
		addq.w	#lib_rec_size,d0
offset_16 	addq.w	#lib_rec_size,d0
offset_8		addq.w	#lib_rec_size,d0
offset_0		lea	cg_lib_index,a0	      a0 --> internal templates
		adda.l	d0,a0			+ offset for jump type
		tst.l	p_flag
		bge.s	offset_ok
		adda.l	#4*lib_rec_size,a0	a0 --> p jump template
offset_ok 	move.w	2(a0),d2		d2 := template length
		bclr	#0,d2
		bra.s	get_params
*
not_if_true	cmp.w	#jump,d4
		beq.s	offset_16
		cmp.w	#if_false,d4
		beq.s	offset_8
		cmp.w	#goto,d4
		beq.s	offset_0
*
* The next bit of code gets all parameters (except strings) from int code file
*
		ident	< Get parameters >
*
get_params	move.w	from_file,d0
		beq	from_ram
		move.l	d2,-(sp)		** v 4.03 - was .w **
		bsr	get_par1	      Returns with d1.l = no. parameter bytes
		blt.s	string_par
*
		move.l	d1,d2
		cmpi.w	#32,d2		Check not allocates etc
		blt.s	size_ok
		subi.w	#64,d2
		bge.s	size_ok
		addi.w	#32,d2
size_ok
		bsr	get_int	      Get all parameters for non-strings
save_par_bytes	lea	num_par_bytes,a1
		move.l	d2,(a1)		** v 4.03 - was .w **
		lea	int_buf,int_code
		move.l	(sp)+,d2		** v 4.03 - was .w **
		bra.s	from_ram
*
string_par	cmpi.w	#rom_fn,d4
		beq.s	byte_len2
		cmpi.w	#rom_proc,d4
		beq.s	byte_len
		cmpi.w	#rom_name,d4
		beq.s	byte_len
		cmpi.w	#ext_str,d4
		beq	long_len
*
		moveq	#2,d2		String length in word
		bsr	get_int	      Get length+2 ( = num par bytes )
		add.w	int_buf,d2	into d2
		moveq	#2,d1		d1:=no. bytes already fetched
even_out_d2	addq.l	#1,d2
		bclr	#0,d2
		lea	bytes_got,a1
		move.w	d1,(a1)
		bra.s	save_par_bytes
*
byte_len2 	moveq	#6,d2		    ** 2.06 fix **
		bsr	get_int
		move.b	int_buf+4,d2	d2 := string length
		moveq	#6,d1		d1 := bytes already fetched
		addq.w	#5,d2		** 2.07 fix **
		bra.s	even_out_d2
*
byte_len		moveq	#4,d2		Get 4 parameter bytes
		bsr	get_int
		move.b	int_buf+2,d2	d2 := string length
		moveq	#4,d1		d1 := bytes already fetched
		addq.w	#3,d2
		bra.s	even_out_d2
*
long_len		moveq	#4,d2
		bsr	get_int
		add.l	int_buf,d2	d2.l = string length + 4
		moveq	#4,d1		d1.l = bytes already fetched
		bra	even_out_d2

*
* Now test for templates needing action in pass 0
from_ram		cmpi.w	#jump,d4
		bne	not_jump
*
		ident	< Unconditional jumps >
*
jump_ins		move.b	small_code,d0
		bne	short_jumps
*
		movem.l	d2/d4/a0,-(sp)
		move.w	(int_code),d4	d4:=label
		bsr	srch_sym_tab
		lea	lab_address,a3  For label address
		movea.l	a0,a1		  a1:=address of label
		movem.l	(sp)+,d2/d4/a0
		beq	fwd_or_error    Forward jump or error if not found
		move.l	a1,(a3)	Save for later
		tst.l	p_flag
		blt.s	p_jump
		btst	#0,p_ind_offset(a1) 0 if dest in native code
		beq.s	n_to_n
		moveq	#10,d2			n to p jump needs 10 bytes
		tst.w	pass
		bne.s	n_to_p_1		Special action in pass 1
		bra.s	jump_done
*
n_to_p_1		lea	n_to_p_temp,a3  Write special template away
		move.l	2(a1),4(a3) Put label address in template
		bclr	#0,7(a3)	Clear p marker
		movea.l	a3,a1		  a1-->template
		bsr	write_obj Save special template
		bra.s	jump_done To increment obj and int code
*
n_to_p_temp	ljsr
*			Special n to p template
		dc.l	0
*
n_to_n		tst.w	pass
		beq.s	jump_done No special action for pass 0
		bra	n_par_1	      or pass 1 for n to n
*
p_jump		btst	#0,p_ind_offset(a1)
		bne.s	p_to_p		Bit 0 = 1 for p destination
		moveq	#6,d2		p to n only needs 2 bytes
		tst.w	pass
		beq.s	jump_done End for	pass 0
		lea	p_to_n_temp,a3  a3 --> special p jump template
		move.l	2(a1),2(a3) Load label address
		movea.l	a3,a1
		bsr	write_obj Save label address for pass 1
jump_done 	moveq	#2,d1		    2 bytes of parameter
		bra	inc_obj_1
*
p_to_n_temp	dc.w	0		Loaded during initialise with
*					address of code in entry routine
		dc.l	0		For label address
*
p_to_p		move.l	2(a1),d0		d0 := destination address
		subq.l	#1,d0		Bit 0 must have been set
		tst.w	pass
		bne	p_to_p_pass1
*						Pass 0
		cmp.l	max_2byte_dest,d0	Is destination in range of base?
		bge	p_pass0_par     No, take no special action
		moveq	#4,d2			Yes, only need 4 bytes for call
		bra.s	jump_done
*
*						Pass 1
p_to_p_pass1	cmp.l	max_2byte_dest,d0	Is destination in range of base?
		bge	pass1_par       No, take no special action
		moveq	#4,d2			Yes, save 4 bytes
		cmp.l	obj_code,d0	Is jump forward or back?
		ble.s	p_jump_back	** 22/12/86
		moveq	#6,d2			Forward so save 6 bytes
p_jump_back	lea	p_to_p_short,a1	    (2 bytes of garbage)
		move.w	d0,2(a1)		Save 2 bytes of address
		bsr	write_obj
		bra.s	jump_done
*
p_to_p_short	dc.w	0		For call to code in entry routine
		dc.w	0		For short address
*
fwd_or_error	tst.w	pass		Error if pass 1, else forward jump
		beq.s	fwd_jump
		bsr	lab_error
		bsr	show_num
		bsr	not_def
		after_error <bra.s	jump_done>
*
fwd_jump		tst.l	p_flag
		blt	p_pass0_par d2 ok if in p mode
		moveq	#10,d2
		bra.s	jump_done
*
* Code for processing jumps with 16 bit labels
*
short_jumps	movem.l	d2/d4/a0,-(sp)
		move.w	(int_code),d4		d4:=label
		bsr	srch_sym_tab
		lea	lab_address,a3	      For label address
		movea.l	a0,a1			  a1:=address of label
		movem.l	(sp)+,d2/d4/a0
		beq.s	s_fwd_or_error		Forward jump or error if not found
		move.l	a1,(a3)		Save for later
		tst.l	p_flag
		blt.s	s_p_jump
		btst	#0,p_ind_offset(a1) 0 if dest in native code
		beq.s	s_n_to_n
		moveq	#6,d2			n to p jump needs 6 bytes
		tst.w	pass
		bne.s	s_n_to_p_1		Special action in pass 1
s_jump_done	moveq	#2,d1			2 bytes of parameter
		bra	inc_obj_1
*
s_n_to_p_1	lea	s_n_to_p_temp,a3	      Write special template away
		move.w	4(a1),4(a3)	Put label address in template
		bclr	#0,5(a3)		Clear p marker
		movea.l	a3,a1			  a1-->template
		moveq	#6,d2
		bsr	write_obj       Save special template
		bra	s_jump_done     To increment obj and int code
*
s_n_to_p_temp	ljsr
*			Special n to p template
		dc.w	0
*
s_n_to_n		tst.w	pass
		beq.s	s_jump_done	No special action for pass 0
		bra	n_par_1		      or pass 1 for n to n
*
s_p_jump		btst	#0,p_ind_offset(a1)
		bne.s	s_p_to_p		Bit 0 = 1 for p destination
		moveq	#2,d2			p to n only needs 2 bytes
		tst.w	pass
		beq.s	s_jump_done	End for pass 0
		addq.l	#4,a1		a1 --> 16 bit label address, bit 0 = 0
		cmp.l	-2(a1),obj_code	Forward or back ?
		bgt.s	s_back_p_to_n		** 22/12/86
		moveq	#4,d2			Forward save 4 bytes
s_back_p_to_n	bsr	write_obj       Save label address for pass 1
		bra.s	s_jump_done
*
s_p_to_p		tst.w	pass
		beq	p_pass0_par     No special action for p to p
		bra	pass1_par
*
s_fwd_or_error	tst.w	pass		Error if pass 1, else forward jump
		beq.s	s_fwd_jump
		bsr	lab_error
		bsr	show_num
		bsr	not_def
		after_error <bra.s	s_jump_done>
*
s_fwd_jump	tst.l	p_flag
		blt	p_pass0_par     d2 ok if in p mode
		moveq	#6,d2
		bra.s	s_jump_done
*
*
not_jump		cmpi.w	#line_temp,d4
		bne.s	not_line
*
		ident	< Line >
*
		lea	num_lines,a3	      Increment line count
		addq.w	#1,(a3)
		lea	line,a3		      Now print line no to display
		move.w	(a2),(a3) Save line number
		move.b	progress_flag,d0	Display line number ?
		beq.s	not_line
		movem.l	d2/a0/a1/a2/a3,-(sp)
		move.w	#line_x,d1		Position the cursor (sigh)
		moveq	#line_y,d2
		moveq	#-1,d3
		movea.l	line_chan,a0
		suba.l	a6,a6
		moveq	#sd.pixp,d0
		trap	#3
		move.w	line,-(sp)		Output line number by
		movea.l	sp,a1
		lea	io_buf,a0
		movea.w	cn.itod,a2	  Converting to string
		jsr	(a2)
		movea.l	a1,sp
		move.l	a0,d2
		lea	io_buf,a1
		sub.l	a1,d2
		moveq	#-1,d3			and writing it
		moveq	#io.sstrg,d0
		movea.l	line_chan,a0
		trap	#3
		tst.l	d0
		bne	fatal2
		movem.l	(sp)+,d2/a0/a1/a2/a3
*
not_line		tst.l	p_flag		To handle templates with parameters
		bge	nat_par
		tst.w	pass
		bne.s	pass1_par
*					cases 8,9
		ident	< P mode pass 0 with parameters >
*
p_pass0_par	move.w	6(a0),d0		d0:=template compilation address
		cmpi.w	#-1,d0			not yet copied if d0=-1
		bne.s	add_pars_obj
*						case 8
		bsr	copy_p_template
		bra.s	add_pars_obj
*						case 10
		ident	< P mode pass 1 with parameters >
*
pass1_par 	lea	6(a0),a1		a1 --> template compilation addr
		cmpi.w	#if_true,d4	Special action for conditionals
		beq.s	if_p_mode
		cmpi.w	#if_false,d4
		bne.s	not_if
if_p_mode 	movem.l	d4/a0/a1,-(sp)
		move.w	(int_code),d4		Search symbol table for label
		bsr	srch_sym_tab
		btst	#0,p_ind_offset(a0) ls bit = 1 for p mode destination
		movem.l	(sp)+,d4/a0/a1
		bne.s	not_if		Nothing special for p to p
		lea	io_buf,a1 p to n enter template at offset
		move.w	6(a0),(a1)	Save and add offset to start address
		move.b	small_code,d2
		bne.s	add_s_offset
		addi.w	#if_p_to_n_offset,(a1)
		bra.s	not_if
add_s_offset	addi.w	#s_if_p_to_n_offset,(a1)
*
not_if		moveq	#2,d2			d2:= no. bytes
		bsr	write_obj Save compilation address
do_pars		bsr	process_pars	        Leaves d1 = no. par bytes
*					d2 = template length
		tst.l	d2		If d2 = 0 the parameters have
		beq.s	add_pars_obj	already been saved
		move.l	d1,d2
		movea.l	int_code,a1 a1 --> processed parameters
		bsr	write_obj
*
add_pars_obj	bsr	calc_par_bytes
inc_obj_1 	add.l	d2,obj_code
inc_int_code	adda.l	d1,int_code
		bra	next_token
*
nat_par		tst.w	pass			Native code parameterised template
		beq.s	n_par_0
*
		ident	< Native pass 1 with parameters >
*					Case 7
n_par_1		bsr	process_pars
		tst.w	d2		If d2 = 0 the template (or string)
		beq.s	inc_obj_1 has already been saved
		bsr	copy_n_template
		bra.s	inc_obj_1
*
		ident	< Native pass 0 with parameters >
*
n_par_0		bsr	nat0_get_bytes  Case 6
		cmpi.w	#if_true,d4
		beq.s	if_nat		Special action for conditionals
		cmpi.w	#if_false,d4
		bne.s	inc_obj_1
if_nat		move.b	small_code,d0
		bne.s	s_if_nat
		addi.w	#10,d2		Add 10 for appendage to template
		bra.s	inc_obj_1
s_if_nat		addi.w	#6,d2		Add 6 for appendage to template
		bra.s	inc_obj_1
*
*
no_pars		cmpi.w	#fast,d4
		bne.s	not_fast
		tst.l	p_flag
		bge	next_token      Ignore if already fast
		ext.l	p_flag		Make it fast
		bra.s	p_no_pars Save p template fo fast, which
*					should be "jmp (pcode)"
*
not_fast		cmpi.w	#slow,d4
		bne.s	not_slow
		tst.l	p_flag
		blt	next_token
		ori.l	#$FFFF0000,p_flag
		bra.s	native
*
not_slow		tst.l	p_flag		To handle templates without parameters
		bge.s	native
p_no_pars 	tst.w	pass
		bne.s	p_pass_1
*
		ident	< P mode no parameters >
*					Cases 3,4
		move.w	6(a0),d0
		cmpi.w	#-1,d0		Not yet copied if -1
		bne.s	inc_obj_code_ptr
*					Case 3
		bsr	copy_p_template
		bra.s	inc_obj_code_ptr
*					Case 5
p_pass_1		lea	6(a0),a1	      a1-->data to be saved
		moveq	#2,d2		d2=no. bytes
		bsr	write_obj
inc_obj_code_ptr
		moveq	#2,d2
inc_obj_2 	add.l	d2,obj_code
		bra	next_token
*
		ident	< Native no parameters >
*
native		tst.w	pass
		beq.s	inc_obj_2
		move.w	4(a0),d0
		lea	0(lib_index,d0.w),a1      a1 --> template code
		bsr	write_obj
		bra.s	inc_obj_2
*
*
*
* Subroutines
*
*
		ident	< Subroutines >
*
*
rep_new_line	move.b	report_flag,d1	Sends a line feed to report file
		beq.s	what_report
		moveq	#10,d1
		movea.l	err_chan,a0
		moveq	#-1,d3
		moveq	#io.sbyte,d0
		trap	#3
		tst.l	d0
		bne	fatal2
what_report	rts
*
*
lab_error 	lea	mess2,a0		"Label not defined"
		bsr	error
		rts
*
not_def		lea	not_def_mess,a1	      "not defined"
		bsr	rest_of_mess
		bsr.s	rep_new_line
		rts
*
rest_of_mess	move.w	(a1)+,d2		Prints rest of a message
		move.l	a1,-(sp)
		move.b	report_flag,d0
		beq.s	not_f_to_scr
		movea.l	err_chan,a0	  Message to report file
		moveq	#io.sstrg,d0
		trap	#3
		tst.l	d0
		bne	fatal2
not_f_to_scr	movea.l	(sp)+,a1		  Message to screen
		move.b	screen_flag,d0
		beq.s	end_rest_mess
		movea.l	error_scr_chan,a0
		moveq	#io.sstrg,d0		d2,d3 are correct
		trap	#3
		tst.l	d0
		bne	fatal2
end_rest_mess	rts
*
*
* Line 0 subroutine
*
show_line0	move.b	progress_flag,d0
		beq.s	end_show_line0
		move.w	#line_x,d1		Position the cursor (sigh)
		moveq	#line_y,d2
		moveq	#-1,d3
		movea.l	line_chan,a0
		suba.l	a6,a6
		moveq	#sd.pixp,d0
		trap	#3
		lea	line0_mess,a1
		move.w	(a1)+,d2
		moveq	#io.sstrg,d0		A0,D3 are correct
		trap	#3
end_show_line0	rts
*
* Indicate the pass
show_pass 	move.b	progress_flag,d0
		beq.s	end_show_pass
		move.w	d1,-(sp)
		moveq	#pass_x,d1		Move to correct position
		moveq	#pass_y,d2
		moveq	#-1,d3
		suba.l	a6,a6
		movea.l	line_chan,a0
		moveq	#sd.pixp,d0
		trap	#3			Ignore any errors
		move.w	(sp)+,d1		Print a single digit
		moveq	#io.sbyte,d0		A0,D3 are correct
		trap	#3
end_show_pass	rts
*
*
get_int		movem.l	d0/d1/a0/a1,-(sp)
		moveq	#-1,d3
		movea.l	int_id,a0
		lea	int_buf,a1
		moveq	#io.fstrg,d0
		trap	#3
		tst.l	d0
		bne	fatal1
		movem.l	(sp)+,d0/d1/a0/a1
		rts
*
*
srch_user_lib	movea.l	lib_index,a0
		move.l	-4(a0),d2
		moveq	#lib_rec_size,d3
		bsr	bin_search
		rts
*
		ident	< inc_write_obj >
*
*inc_write_obj	 add.l	 d2,obj_code
*write_obj	 move.l	 a0,-(sp)
*		 movea.l	 obj_chan,a0
*		 moveq	 #-1,d3
*		 moveq	 #io.sstrg,d0
*		 trap	 #3
*		 movea.l	 (sp)+,a0
*		 tst.l	 d0
*		 bne	 fatal1
*		 rts
*
* New write_obj because of long strings v 4.03
*
inc_write_obj	add.l	d2,obj_code
write_obj 	movem.l	d2/d4/a0,-(sp)
		moveq	#-1,d3
		movea.l	obj_chan,a0
		cmpi.l	#max_write,d2
		ble	wr_obj1		small enough
		move.l	d2,d4
		move.w	#max_write,d2
		divs.w	d2,d4		d4 = rest | no of maxes
		bra	wr_obj2
wr_obj3		bsr	wr_obj
wr_obj2		dbf	d4,wr_obj3
		swap	d4
		move.w	d4,d2		rest
		beq	wr_obj4		no rest!
wr_obj1		bsr	wr_obj
wr_obj4		movem.l	(sp)+,d2/d4/a0
		rts
*
wr_obj		moveq	#io.sstrg,d0
		trap	#3
		tst.l	d0
		bne	fatal1	---->
		rts
*
save_obj		move.w	from_file,d3
		beq.s	inc_write_obj
		move.w	d2,-(sp)
		move.w	bytes_got,d2
		subq.w	#2,d2
		beq.s	is_word_strg
		moveq	#2,d2			** 2.11 save 2 bytes
		bsr.s	inc_write_obj
		subq.w	#2,(sp)
is_word_strg	move.w	(sp)+,d2
save_strg 	beq.s	none_to_save
next_part 	move.w	d2,-(sp)
		cmpi.w	#size_int_buf,d2	Else get max of one buffer
		bls.s	get_rest
		moveq	#size_int_buf,d2
get_rest		bsr	get_int
		lea	int_buf,a1	      and save it
		bsr.s	inc_write_obj
		move.w	(sp)+,d2
		subi.w	#size_int_buf,d2
		bhi.s	next_part
none_to_save	rts
*
*
place_csor	movem.l	d2/a0/a1/a6,-(sp)
		suba.l	a6,a6
		movea.l	line_chan,a0
		moveq	#col,d1
		moveq	#row,d2
		moveq	#-1,d3
		moveq	#sd.pos,d0
		trap	#3			Ignore any errors
		movem.l	(sp)+,d2/a0/a1/a6
		rts
*
*
p_next		ljmp
*				Template for jump to interpreter
*				Displacement loaded in set up
*
interpreter	move.w	(pcode)+,d0 An in-line p-code interpreter for faster
		jmp	0(base,d0.w)    execution
*
copy_p_template
		lea	lab_inc,a1
		move.w	(a1),6(a0)
		add.w	d2,(a1)
		move.b	small_code,d0
		beq.s	in_line_inter
		addq.w	#4,(a1)	For jump to p code interpreter
		bsr.s	copy_temp
		moveq	#4,d2		Now save jump to interpreter
		lea	p_next,a1
		bra.s	inter_copied
in_line_inter
		addq.w	#6,(a1)	For p code interpreter
		bsr.s	copy_temp
		moveq	#6,d2		Now save the interpreter
		lea	interpreter,a1
inter_copied
		bsr	write_obj
		rts
*
*
copy_temp 	move.w	4(a0),d0
		lea	0(lib_index,d0.w),a1
		bsr	write_obj
		rts
*
*
copy_n_template
		move.w	d1,-(sp)
		bsr.s	copy_temp
		move.w	(sp)+,d1
		rts
*
		ident	< calc_par_bytes >
*
* next is used in p mode only passes 0 and 1
calc_par_bytes	bsr.s	get_bytes d1 := no parameter bytes
		moveq	#0,d2
		tst.b	d1
		bsr.s	get_par2
		addq.l	#2,d2		d2 := length of p template call
		add.l	d1,d2
		rts
*
*
get_bytes 	move.w	2(a0),d2	d2 := template length
		bclr	#0,d2
get_par1		move.w	4(a0),d0	d0 := template relative address
		add.w	d2,d0		d0 := rel address of par bytes
		moveq	#0,d1
		lea 0(lib_index,d0.w),a1     a1   := absolute address
		move.b	(a1)+,d1	         d1.l := no.parameter bytes
		rts
*
nat0_get_bytes	bsr.s	get_bytes 	D1.L is no. par bytes
		bge.s	get_par3
		moveq	#0,d0		** 2.11 See below
		bsr.s	strg_get_bytes
		add.l	d1,d2		d1 gets added to int_code
		subq.l	#2,d2		d2 := d2+d1-d0-2 gets added to obj_code
		sub.l	d0,d2		** 2.11 Only ROM_FN puts a value in D0
*					for the extra 2 bytes of parameter
		rts		( D2=LEN(template + string only ))
*
get_par_bytes	bsr.s	get_bytes
get_par2		blt.s	strg_get_bytes	String if negative
get_par3		cmpi.w	#32,d1		Allocate bytes if >= 32
		blt.s	known
		cmpi.w	#64,d1
		bgt.s	type18_22
		subi.w	#32,d1
		bsr	get_alloc_bytes Find no of bytes to allocate
known		rts
*
type18_22 	subi.w	#64,d1
		tst.l	p_flag
		bge.s	known
		cmpi.w	#4,d1
		beq.s	lw_type
		subq.l	#2,d2
lw_type		subq.l	  #2,d2
		rts
*
*
strg_get_bytes	cmpi.w	#rom_proc,d4
		beq.s	str_get1
		cmpi.w	#rom_name,d4	Treat differently for rom_name
		beq.s	str_get1
		cmpi.w	#rom_fn,d4
		beq.s	str_get3
		cmpi.w	#ext_str,d4
		beq	str_get4		for long length string
		move.w	(int_code),d1	d1 := no. of bytes in string
		addq.w	#3,d1		Add 2 for number and 1 to
str_get2		bclr	#0,d1		ensure even no. of bytes
		move.w	from_file,d3
		beq.s	strg_done
		tst.w	pass			Need to move file pointer in
		bne.s	strg_pass1		pass 0 only to skip over the
		movem.l	d0/d1/a0/a1,-(sp)	  string
		move.l	num_par_bytes,d1		** v 4.03 - was .w **
		moveq	#0,d3			**
		move.w	bytes_got,d3		**
		sub.l	d3,d1			**
		moveq	#-1,d3
		movea.l	int_id,a0
		moveq	#fs.posre,d0
		trap	#3
		tst.w	d0
		bne	fatal1
		movem.l	(sp)+,d0/d1/a0/a1
strg_done 	rts
*
strg_pass1	move.l	num_par_bytes,d1	In pass 1 must read from ram
*					** v 4.03 - was  .w **

		rts
*
str_get1		moveq	#0,d1			String length in byte
		move.b	2(int_code),d1		at int_code+2
		addq.w	#4,d1			( +4 to allow for later -2 )
		bra.s	str_get2
*
str_get3		moveq	#0,d1			Byte string length 1 too low
		move.b	4(int_code),d1
		addq.w	#6,d1			** 2.06 fix **
		moveq	#2,d0			To be subtracted from d2 in
		bra.s	str_get2		'nat0_get_bytes' only
*
str_get4		move.l	(int_code),d1
		addq.l	#5,d1
		bra	str_get2
*
* next leaves	d1 = number of bytes to be added to int_code
*		d2 =  ............................. obj_code
* it is used in both nat and p modes pass 0 only
* In the >64 version of Supercharge this is also used for any subroutines
* that handle 32 bit labels in p mode only, ie sr's 29,33,34,35, because
* the label reference is 2 bytes but we save 4 bytes of address.
* We must detect this in pass 0 only and add 2 onto d2 to get
* obj_code correct. In native mode the address is patched into the template
* and so is ok.
* Therefore this subroutine here is misnamed and really ought to be renamed.
get_alloc_bytes
		tst.w	pass		Pass 0 only
		bne	known		Naughty ! uses same rts twice
		movem.l	d1/a1,-(sp)
alloc_next	move.b	(a1),d0		d0 := par type
		cmpi.b	#end_spec,d0
		beq	alloc_done
		moveq	#0,d1
		move.b	3(a1),d1		d1 := par no.
		move.w	-2(int_code,d1.w),d1	d1 := parameter
		cmpi.b	#29*2,d0		Test for label subroutine
		bge	maybe_label
		cmpi.b	#12*2,d0		Types 12 and 17 are allocate
		bne.s	alloc_17
		lsl.l	#2,d1			d1 := (d1 * 4) + 4
		addq.l	#4,d1
alloc_inc 	add.l	d1,d2		    Add to    template length ( nat )
*						or p_code call ( p_mode )
all_nxt_spec	addq.l	#4,a1
		bra	alloc_next
alloc_17		cmpi.b	#17*2,d0
		bne	alloc_20
		subq.l	#2,d1		Type 17 is (par-2) bytes
		bra.s	alloc_inc
alloc_done	movem.l	(sp)+,d1/a1
		rts
*
alloc_20		cmpi.b	#20*2,d0
		bne.s	all_nxt_spec
		addq.l	#2,d1		Type 20 is word + 2 bytes
		bra.s	alloc_inc
*
maybe_label	tst.l	p_flag		Ignore if native mode
		bge.s	all_nxt_spec
		cmpi.b	#29*2,d0	Is it 29 ?
		beq.s	is_label_ref
		cmpi.b	#35*2,d0	Is it > 35 ?
		bgt.s	all_nxt_spec
		cmpi.b	#33,d0		Is it < 33 ?
		blt.s	all_nxt_spec
is_label_ref	addq.l	#2,d2		A lotta hassle just for this!
		bra.s	all_nxt_spec
*
		ident	< process_pars >
*
process_pars	bsr	get_par_bytes   Leaves    a0 --> template index
*						a1 --> 1st parameter spec
*						d1 = no. parameter bytes
*						d2 = template length
		movem.l	d1/d2,-(sp)
next_par		clr.w	d0
		move.b	(a1)+,d0		d0 := parameter type
		cmpi.b	#end_spec,d0
		beq.s	pars_done
		cmpi.b	#max_par_type*2,d0
		bhi.s	par_type_error
* ** Change to allow DEVPAC to assemble this (avoids a bug, I think)
		move.w	sr_vecs(d0.w),d2
*		 lea	 sr_vecs,a3
*		 move.w	 0(a3,d0.w),d2
*
		bsr.s	get_par_spec
here		jsr	here(d2.w)
		bra.s	next_par
pars_done 	movem.l	(sp)+,d1/d2
		rts
*
*
par_type_error	bsr.s	get_par_spec		Ensure a1 ok
		bsr	sr_type_error	      Report the error
		bra.s	next_par		And continue
*
*
get_par_spec	move.w	4(a0),d0		d0 := relative template address
		lea	(lib_index,d0.w),a3      a3 := abs template address
		move.w	(a1)+,d3		d3 := byte offset
		moveq	#0,d0
		move.b	(a1)+,d0		d0 := parameter no * 2
		move.w	-2(int_code,d0.w),d0	d0 := parameter
		rts
*
* Patch area for user identification. This must be filled with even numbers
* superficially similar to SR vectors, so that attempts to patch it out
* cause CODEGEN to fail! Vector-like data should fill the whole area.
*
patch_area	dc.w	0,2 ** 2.12 - Dummy word & initial checksum
		dcb.w	24,0	  ** 2.12 - User ID field
*
		ident	< Vector table >
*
*	vector table for below parameter handling subroutines
*
* Notes for >64K version of Supercharge
*(1)	An error routine has been provided to detect invalid subroutine type
*	numbers.	Some of the subroutine numbers
*	used in the <64K Supercharge and Lightning are now detected as errors,
*	these are easily spotted in the table below. S/R's 4 and 25 have been
*	left in as 16 bit versions on the offchance they may be useful. 32 bit
*	equivalents (in brackets) of the label S/R's 4 (29), 24 (34),
*	25 (35), 28 (33). No equivalent of S/R 18 has been provided since FOR
*	loops are being reworked by Simon and an equivalent will not be
*	needed. (Simon, over the phone on 14 Aug 1986). The special case
*	S/R 21 is no longer needed since forward and backward jumps occupy
*	the same amount of space in native to native code jumps.
*(2)	If a p code library template has a label reference and other
*	parameters, the label must be the last in both the
*	intermediate code stream and the parameter spec list in the
*	library (Simon agreed over the phone on 14 Aug 1986). This does not
*	apply to native code templates.
*(3)	A new requirement, by me, is that in a similar way to the space
*	allocation S/R's, all the 32 label subroutines (in p mode templates
*	only) must have 16 added onto the number of parameter words in the
*	first byte of the parameter spec, (ie +32 parameter bytes). This
*	applies to S/R's 29,33,34,35.
*(4)	If any more S/R's are added, increase the constant "max_par_type"
*	accordingly.
*
sr_vecs		dc.w	sr_type_error-here	Error
		dc.w	sr1-here	Word * 4
		dc.w	sr2-here	Byte
		dc.w	sr3-here	Word
		dc.w	sr4-here	Label (16 bit version)
		dc.w	sr5-here	(Word * 4) + vector_table
		dc.w	sr6-here	(Word * 2) + 8
		dc.w	sr7-here	Byte - 1
		dc.w	sr8-here	(Byte * 2) + 8
		dc.w	sr9-here	- Word
		dc.w	sr10-here String
		dc.w	sr11-here (Word *	4) + 4
		dc.w	sr12-here Allocate ((word * 4) + 4) bytes
		dc.w	sr13-here String (byte length) for rom_name
		dc.w	sr14-here (Word *	40) + 4
		dc.w	sr15-here Word * 2
		dc.w	sr16-here Byte - 2
		dc.w	sr17-here Allocate word - 2 bytes
		dc.w	sr18-here (Word * 40) + channel _table - WAS sr_type_error-here  No 32 bit equivalent
		dc.w	sr19-here (Word *	2) + 2
		dc.w	sr20-here Allocate (word + 2) bytes
		dc.w	sr21-here Short native mode jumps
		dc.w	sr22-here Init_window, p mode only
		dc.w	sr_type_error-here	Supercharge only (ROM_FN)
		dc.w	sr24-here Short native conditional jumps
		dc.w	sr25-here Typed_address (16 bit version)
		dc.w	sr26-here Byte * 2 + 14
		dc.w	sr27-here Byte * 2 + 12
		dc.w	sr_type_error-here	Use sr33 instead
		dc.w	sr29-here 32 bit label, equivalent to sr4
		dc.w	sr_type_error-here	30 for Lightning only
		dc.w	sr_type_error-here	31 for Lightning only
		dc.w	sr_type_error-here	32 for Lightning only
		dc.w	sr33-here 32 bit label + for_offset
		dc.w	sr34-here 32 bit label, conditional jump
		dc.w	sr35-here 32 bit typed address
		dc.w	sr36-here ROM_FN (TURBO), byte length string
		dc.w	sr37-here ADDQ, insert byte
		dc.w	sr38-here SUBQ, insert byte
*
*
sr_type_error
		movem.l a0/a1/a3,-(sp)
		moveq	#0,d2
		move.b	-4(a1),d2 d2 := faulty parameter type number
		lsr.w	#1,d2
		move.w	d2,-(sp)		Save for later
		lea	sr_error_mess,a0
		bsr	error		      Report the error ...
		move.w	(sp)+,d2
		bsr.s	show_par_type		... and the type number
		lea	template_mess,a1
		bsr	rest_of_mess
		bsr	print_num       Prints template number
		bsr	rep_new_line
		after_error <movem.l	(sp)+,a0/a1/a3>
		rts
*
*
show_par_type
		move.l	a2,-(sp)
		move.w	d2,-(sp)
		bra	conv1
*
*
sr15		lsl.w	#1,d0		Inserts (2*word)
		bra	sr3
*
*
sr26		addq.w	#1,d0		Byte * 2 + 14
sr27		addq.w	#2,d0		Byte * 2 + 12
sr8		addq.w	#4,d0		Byte * 2 + 8
		lsl.w	#1,d0
		bra.s	sr2
*
*
sr9		neg.w	d0		Inserts (- word)
		bra.s	sr3
*
*
sr14		mulu	#40,d0		Insert (word*40)+4
		addq.w	#4,d0
		bra.s	sr3
*
sr1		lsl.w	#2,d0		Insert (word*4)
		bra.s	sr3
*
*
sr7		subq.w	#1,d0		Inserts (byte-1)
sr2		andi.w	#$FF,d0
		tst.l	p_flag
		blt.s	sr4a
		move.b	d0,0(a3,d3.w)	Insert byte
sr0		rts
*
*
sr16		subq.w	#2,d0		Inserts (byte-2)
		bra.s	sr2
*
*
sr11		lsl.w	#2,d0		Insert (word * 4) + 4
		addq.w	#4,d0
		bra.s	sr3
*
sr6		lsl.w	#1,d0		(word * 2) + 8
		addq.w	#8,d0
		bra.s	sr3
*
ins_word		move.w	d0,0(a3,d3.w)	Inserts a word
		rts
*
*
sr19		lsl.w	#1,d0		(word * 2) + 2
		addq.w	#2,d0
		bra.s	sr3
*
*
sr4		bsr.s	sr_lab		Insert ref to label
		bclr	#0,d0		Clear possible p mode marker
sr3		tst.l	p_flag
		bge.s	ins_word
sr4a		moveq	#0,d2		p mode, patch label address into
		move.b	-1(a1),d2 int code stream, d2 := par no*2
		lea	-2(int_code,d2.w),a3      a3 --> label
		move.w	d0,(a3)	Patch label address
		rts
*
*
sr25		bsr.s	sr_lab		Typed_address leaves label address
		bra.s	sr3	unchanged ie bit 0 gives dest. mode
*
* conditional	jump extra template for native to native
if_n_to_n 	ljmp
		nop
*
*
sr24		bsr.s	sr_lab		Conditional native mode jumps
		movem.l	d0/a1,-(sp) Label address in d0
		moveq	#0,d0		To use common code
		bsr	save_temp Save the template
		move.l	(sp)+,d0	Restore label address
		clr.l	12(sp)		Clear stacked template length
		bclr	#0,d0		Bit 0 =1 for p mode destination
		beq.s	if_n_dest
		lea	s_n_to_p_temp,a1	      a1 --> n to p appendage
		move.w	d0,4(a1)		Patch in label address
		bra.s	save_if_temp
if_n_dest 	lea	if_n_to_n,a1	a1 --> n to n appendage
		move.w	d0,2(a1)	Patch in label address
save_if_temp	moveq	#6,d2		Save 6 bytes
		bsr	inc_write_obj
		movea.l	(sp)+,a1
		rts
*
		ident	< Label s/r >
*
sr_lab		movem.l	a0/a1/a3,-(sp)	  Leave 16 bit address of label in d0
		move.w	d0,d4		Searching for label in d0
		bsr	srch_sym_tab
		bne.s	lab_found
		bsr	lab_error
		bsr	print_num
		bsr	not_def
		after_error <bra.s	lab_pop>
*
lab_found
		move.l	2(a0),d0	d0 := location of label or name
*					.l because the address is long
lab_pop		movem.l	(sp)+,a0/a1/a3
		rts
*
*
;sr18		 bsr.s	 sr_lab		 Simon's   type LW
;		 add.w	 2(int_code),d0
;		 addq.w	 #6,d0		 Simon's   changes
;		 bclr	 #0,d0
;		 bne.s	 plug_on
;		 addi.w	 #for_offset-6,d0
;		 bra	 ins_word
;plug_on		 subq.l	 #2,4(sp)  *** This looks wrong to me ***
;		 moveq	 #2,d1
;		 move.l	 d1,8(sp)
;		 bra	 sr4a
*
*
sr28		bsr.s	sr_lab
		addq.w	#6,d0
		bclr	#0,d0
		bne	sr4a
		addi.w	#for_offset-6,d0
		bra	ins_word
*
*
sr21		bsr.s	sr_lab		For native mode jumps
		bclr	#0,d0
		cmp.l	d0,obj_code Forward or backward jump ?
		bge	ins_word	      Insert label if back
		addq.l	#2,8(sp)	Increase stored d2 if forward
		bra	ins_word
*
		ident	< 32 bit label addresses >
*
sr35		bsr.s	sr_lab32	32 bit version of sr25
		bra.s	sr29a
*
*
sr29		bsr.s	sr_lab32	32 bit label, like sr4
		bclr	#0,d0
sr29a		tst.l	p_flag
		bge.s	ins_long_word
sr29b		move.l	a1,-(sp)
		lea	io_buf,a1 p mode,	      cannot patch 32 bit
*					address over 16 bit parameter
		move.l	d0,(a1)	so save it elsewhere
		move.l	8(sp),d2	Save any parameters before label
		subq.l	#2,d2
		ble.s	no_pars_to_save
		movea.l	int_code,a1
		bsr	write_obj Save the preceding parameters
*					Note that parameter bytes are
*					added on to obj_code later,
*					after call to "calc_par_bytes"
no_pars_to_save
		clr.l	12(sp)		Mark fact parameters are saved
		moveq	#4,d2
		lea	io_buf,a1 Now save long address
		bsr	write_obj
		addq.l	#2,obj_code For the extra 2 bytes in the long
		movea.l	(sp)+,a1	  address
		rts
*
ins_long_word	move.l	d0,0(a3,d3.w)	Native code, patch long label address
		rts
*
*
sr_lab32		movem.l	a0/a1/a3,-(sp)	  Search symbol table for 32 bit label
		move.w	d0,d4		Searching for label in d0
		bsr	srch_sym_tab
		bne.s	lab_found32
		bsr	lab_error
		bsr	print_num
		bsr	not_def
		after_error <bra.s	lab_pop32>
*
lab_found32
		move.l	2(a0),d0	d0 := location of label or name
*
lab_pop32 	movem.l	(sp)+,a0/a1/a3
		rts
*
*
sr33		bsr.s	sr_lab32	32 bit version of sr28
		addq.l	#6,d0
		bclr	#0,d0
		bne.s	sr33_p_dest
		tst.l	p_flag		Error check, p to n not allowed
		blt.s	sr33_error
		addi.l	#for_offset-6,d0
		bra.s	ins_long_word
*
sr33_p_dest	tst.l	p_flag		Error check, n to p not allowed
		blt.s	sr29b
sr33_error
		movem.l	a0/a1/a3,-(sp)
		lea	sr33_mess,a0
		bsr	error
		bsr	rep_new_line
		after_error <movem.l	(sp)+,a0/a1/a3>
		rts
*
*
sr34		tst.l	p_flag		32 bit version of sr 24
		blt	sr_type_error   Error in p mode
		bsr.s	sr_lab32
		movem.l	d0/a1,-(sp) Native mode conditional jumps
		moveq	#0,d0
		bsr	save_temp
		move.l	(sp)+,d0
		clr.l	12(sp)		Mark as template already saved
		bclr	#0,d0
		beq.s	if_n_dest32
		lea	n_to_p_temp,a1  Destination in p mode
		move.l	d0,4(a1)	Patch in address
		bra.s	save_if_temp32
if_n_dest32	lea	if_n_to_n32,a1	    Destination in native mode
		move.l	d0,2(a1)	Patch in address
save_if_temp32	moveq	#10,d2
		bsr	inc_write_obj
		movea.l	(sp)+,a1
		rts
*
if_n_to_n32	move.l	#0,d0		Conditional n to n template appendage
		jmp	(base,d0.l)
*
*
sr5		lsl.w	#2,d0		Inserts (vector*4) + vector_table
		add.w	vect_tab_ad,d0	Add vector table address
		bra	sr3

sr18		mulu.w	#40,d0		Inserts (channel*40) + channel_table
		add.w	4+library_area,d0	Add relative channel table address
		bra	sr3
*
*
sr22		tst.l	p_flag		Init_window, p mode only
		bge	sr_type_error   Error in native mode
		movea.l	int_code,a3
		move.w	(a3)+,d1
		muls	#40,d1
		addq.w	#4,d1
		move.w	d1,(int_code)
		move.b	1(a3),(a3)+
		move.b	2(a3),(a3)+
		move.b	3(a3),(a3)+
		move.b	4(a3),(a3)+
		move.l	4(a3),(a3)+
		move.l	4(a3),(a3)
		subq.l	#4,4(sp)
		moveq	#2,d1
		move.l	d1,8(sp)
get_out		rts
*
*
sr38		moveq	#$51,d2
		bra	sr37_1
sr37		moveq	#$50,d2
sr37_1		andi.b	#7,d0
		add.b	d0,d0
		add.b	d2,d0
		bra	sr2
*
		ident	< Strings >
*
p_save_strg	move.w	from_file,d3
		beq.s	get_out
		move.l	a1,-(sp)
		lea	int_buf,a1
		move.w	bytes_got,d2
		ext.l	d2
		bsr	inc_write_obj	only D2.W preserved!!
		ext.l	d2
		sub.l	num_par_bytes,d2
		neg.l	d2
		sub.l	num_par_bytes,obj_code
		bsr	save_strg
		move.l	(sp)+,a1
		clr.l	8(sp)
		rts

sr36		tst.l	p_flag		Turbo ROM_FN
		bmi.s	p_save_strg
		lsr.w	#8,d0		String length in ms byte of parameter
		addq.w	#2,d0
		addq.l	#4,int_code ROM_FN has 4 parameter bytes before
		bra.s	sr10a		the string
*
*
sr13		tst.l	p_flag
		bmi.s	p_save_strg
		lsr.w	#8,d0		String with length in byte
		addq.w	#2,d0
		addq.l	#2,int_code
		bra.s	sr10a
*
*
sr10		tst.l	p_flag
		bmi.s	p_save_strg
		clr.w	d0
		move.b	-1(a1),d0 d0 := par no.
		lea	-4(int_code,d0.w),int_code	        int_code --> length word
		move.w	(int_code)+,d0		d0 := length, int_code -->string
		addq.w	#1,d0			String
sr10a		bclr	#0,d0			Ensure length even
		move.l	d0,4(sp)		For d1 later
		clr.l	8(sp)			For d2 later
		movem.l	d0/a1,-(sp)
		move.w	2(a0),d2		d2 = template length
		ext.l	d2
		bclr	#0,d2
		movea.l	a3,a1			  a1 --> template
		bsr	inc_write_obj	      Save template
		move.l	(sp)+,d2		d2 = string length + 2
		movea.l	int_code,a1	  a1 --> string ( assumes int_code
*						has been previously adjusted )
		bsr	save_obj		      Save string
		movea.l	(sp)+,a1
		rts
*
		ident	< Allocate space >
*
sr20		addq.l	#2,d0			Allocate word + 2 bytes
		bra.s	alloc_bytes
*
*
p_alloc		movem.l	a1/d7,-(sp)
		move.l	d0,d7			Save any parameters
		move.l	12(sp),d2 d2 := no. parameter bytes
		ble.s	save_zeroes	If no parameters to save
		movea.l	int_code,a1	  a1 --> parameters
		bsr	write_obj       Save them (obj_code incremented
*						later on return to main prog)
		bra.s	save_zeroes	Jump to allocate zeroes
*
sr12		lsl.l	#2,d0			Allocates (word*4+4) bytes
		addq.l	#4,d0
alloc_bytes	clr.l	8(sp)			Clear saved d2
		tst.l	p_flag
		blt.s	p_alloc
save_temp 	movem.l	a1/d7,-(sp)
		move.l	d0,d7
		move.w	2(a0),d2		Now save template plus
		ext.l	d2
		bclr	#0,d2			bytes to be allocated
		movea.l	a3,a1
		bsr	inc_write_obj
*
save_zeroes	move.l	d7,d2			Save required no. bytes, all
		andi.l	#$FF,d2		zero, 256 bytes at a time
		beq	save_blocks
		lea	zeroes,a1       Save (d7 MOD 256) bytes first
		bsr	inc_write_obj
save_blocks	lsr.l	#8,d7			Now save (d7 DIV 256) blocks
		move.w	#256,d2		top of D2 is zero
		bra.s	test_d7
next_block	lea	zeroes,a1
		bsr	inc_write_obj
test_d7		dbra	d7,next_block
		movem.l	(sp)+,a1/d7	  All done
		rts
*
*
sr17		subq.l	#2,d0			Allocate (S-2) bytes
		bra.s	alloc_bytes
*
*
		ident	< Number output >
*
print_num 	move.l	a2,-(sp)
		move.w	d4,-(sp)
		bra.s	conv1
*
show_num		move.l	a2,-(sp)
		move.w	(int_code),-(sp)
		bra.s	conv1
*
*
conv_to_string	move.l	a2,-(sp)
		move.w	line,-(sp)		Output line number by
conv1		movea.l	sp,a1
		lea	io_buf,a0
		movea.w	cn.itod,a2	  converting to string
		suba.l	a6,a6			Accesses a1, a0 relative to a6
		jsr	(a2)
		movea.l	a1,sp
		move.l	a0,d2
		lea	io_buf,a1
		sub.l	a1,d2
		moveq	#-1,d3			and writing it
		move.b	report_flag,d0		A report file?
		beq.s	num_to_screen
		moveq	#io.sstrg,d0		Yes, so write there
		movea.l	err_chan,a0
		trap	#3
		tst.l	d0
		bne	fatal2
num_to_screen	move.b	screen_flag,d0
		beq.s	end_conv
		lea	io_buf,a1       d2,d3 are correct
		movea.l	error_scr_chan,a0
		moveq	#io.sstrg,d0
		trap	#3
		tst.l	d0
		bne	fatal2
end_conv		movea.l	(sp)+,a2
		rts
*
*
* Binary search enter with		Exit with
*	a0.l base of table		Found d0.w = 1
*	d2.w size of table ( bytes )		a0.l points to found record
*	d3.w record size ( bytes )	Not found d0.w = 0
*	d4.w target			a0.l points to record above
*						condition code set to d0
*
bin_search	move.l	d5,-(sp)	Save, restore at end
		clr.w	d0		For not found flag
		sub.w	d3,d2		d2 points to last entry
		blt.s	exit1		Exit if table empty
		cmp.w	(a0),d4
		bcs.s	exit1	( bcs = blo ) exit if target below table
		cmp.w	(a0,d2.w),d4
		bhi.s	exit2		Exit if target above table top
		divu	d3,d2		d2 := no. records - 1
bin_loop		move.w	d0,d1
		add.w	d2,d1
		lsr.w	#1,d1		Mid := ( first + last ) / 2
		move.w	d1,d5
		mulu	d3,d5		Index := mid * record size
		cmp.w	d2,d0
		bgt.s	exit3		Exit if lower > upper
		cmp.w	(a0,d5.w),d4       Compare table[mid] with target
		beq.s	exit4		Found
		bhi.s	u_half
		move.w	d1,d2		In lower half so upper := mid - 1
		subq.w	#1,d2
		bra.s	bin_loop
*
u_half		move.w	d1,d0			In upper half so lower := mid + 1
		addq.w	#1,d0
		bra.s	bin_loop
*
exit4		moveq	#1,d0		Found, flag := 1
exit5		lea	(a0,d5.w),a0   Point a0 to found record
exit1		move.l	(sp)+,d5	Restore
		tst.w	d0
		rts
*
exit2		add.w	d3,d2
		move.w	d2,d5		Point d2 above last record
		bra.s	exit5
*
exit3		clr.w	d0		Record may not be found
		cmp.w	(a0,d5.w),d4
		beq.s	exit4		Found
		bcs.s	exit5		( bcs = blo ) not found but d2 ok
		add.w	d3,d5		Point d5 to next record
		bra.s	exit5
*
*
*	Error routine ** 2.06 Messages re-worded to suit user-view.
*
*		 hed	 <'Codegen v 3.1',10,'      Pass      Line'>,head1
mess0		dc.b	34,'**** Code generation failed, line '
qdos_mess 	dc.b	37,'**** Code generation failed, reason: '
mess2		dc.b	8,': Label '
not_def_mess	dc.w	13
		dc.b	' not defined.'
not_999_mess	dc.b	30,': no parsed code for analysis.'
no_temp_mess	dc.b	11,': Template '
not_found_mess	dc.w	11
		dc.b	' not found.'
toobig_mess	dc.b	28,': too long to optimise SIZE.'
mess4		dc.b	30,': Codegen dataspace too small.'
mess5		dc.b	20,': Duplicated label: '
low_label_mess	dc.b	25,':FOR loop label too low: '
line0_mess	dc.w	5
		dc.b	'0    '
done_mess1	dc.w	35
		dc.b	'TURBO Code generation completed at '
done_mess2	dc.w	18
		dc.b	' lines per minute.'
done_mess3	dc.w	45
		dc.b	'TURBO Code generation completed successfully.'
coded_mess	dc.b	'CODED'
fault_mess	dc.b	'FAULT'
*
phase_mess	dc.b	22,': Codegen phase error.'
lab_phase_mess	dc.b	24,': Phase error at label: '
sr_error_mess	dc.b	13,': Patch type '
template_mess	dc.w	13
		dc.b	' in template '
sr33_mess 	dc.b	26,': Mixed modes not allowed.'
ins_mess		dc.b	17,' Faulty _INS file'
*
		ds.w	0
*
show_error	move.b	progress_flag,d0
		beq.s	end_show_error
		movea.l	line_chan,a0	Show one error for now. Later
		move.w	#error_x,d1	the error count
		moveq	#error_y,d2	Position the cursor
		moveq	#-1,d3
		moveq	#sd.pixp,d0
		trap	#3
		tst.l	d0
		bne	fatal1
		moveq	#$31,d1		Print a "1"
		moveq	#io.sbyte,d0
		trap	#3
		tst.l	d0
		bne	fatal1
end_show_error	rts
*
*
error		movem.l	d1/d2/d5/d7/a1-a6,-(sp)
		move.l	a0,-(sp)		Save address error message
		bsr	make_noise	      Audible fault indicator
		lea	error_flag,a0	      Increment the error count
		addq.w	#1,(a0)
*
		bsr.s	show_error		Show error on screen
*
		move.b	report_flag,d0		Are we reporting to a file?
		beq.s	errors_to_screen
		movea.l	err_chan,a0	  Yes, write to report file
		moveq	#-1,d3
		suba.l	a6,a6
		lea	mess0,a1		      Output message 0
		moveq	#0,d2			to report file
		move.b	(a1)+,d2
		moveq	#io.sstrg,d0
		trap	#3
		tst.l	d0
		bne	fatal1
errors_to_screen
		move.b	screen_flag,d0
		beq.s	do_line_num
		movea.l	error_scr_chan,a0	  and to screen
*
		moveq	#bad_ink,d1	Set ink colour
		moveq	#sd.setin,d0
		trap	#3
		tst.l	d0
		bne	fatal1
*
		moveq	#bad_paper,d1		Set paper colour
		moveq	#sd.setpa,d0		A0,D3 are correct
		trap	#3
		tst.l	d0
		bne	fatal1
*
		moveq	#bad_paper,d1		Set strip colour
		moveq	#sd.setst,d0		A0,D3 are correct
		trap	#3
		tst.l	d0
		bne	fatal1
*
		moveq	#sd.clear,d0		Clear this window
		trap	#3			A0,D3 are correct
		tst.l	d0
		bne	fatal1
*
		moveq	#err_scr_x,d1		Position the cursor
		moveq	#err_scr_y,d2
		moveq	#sd.pixp,d0
		trap	#3
		tst.l	d0
		bne	fatal1
*
		lea	mess0,a1		      Output message 0
		moveq	#0,d2
		move.b	(a1)+,d2
		moveq	#io.sstrg,d0
		trap	#3
		tst.l	d0
		bne	fatal1
*
do_line_num bsr conv_to_string		Convert line no to string
		tst.l	d0
		bne	fatal1
		move.b	report_flag,d0
		beq.s	err2_to_screen
		movea.l	(sp),a1		  Point a1 to appropriate
		moveq	#0,d2			error message
		move.b	(a1)+,d2
		movea.l	err_chan,a0
		moveq	#io.sstrg,d0		and write it
		trap	#3
		tst.l	d0
		bne	fatal1
*
err2_to_screen
		movea.l	(sp)+,a1		  Point a1 to appropriate
		move.b	screen_flag,d0		error message
		beq.s	end_error
		moveq	#0,d2
		move.b	(a1)+,d2
		movea.l	error_scr_chan,a0
		moveq	#io.sstrg,d0		and write it
		trap	#3
		tst.l	d0
		bne	fatal1
end_error 	movem.l	(sp)+,d1/d2/d5/d7/a1-a6
		rts
*
*
*
		ident	< Search symbol table >
*
srch_sym_tab	moveq	#0,d1
		move.w	d4,d1		d1 := target
		move.l	size_sym_tab,d2
		divu	d2,d1
		clr.w	d1		To ensure d1 is long below
		swap	d1		d1 := rem (target/max_entries)
*
		moveq	#st_rec_size,d0
		mulu	d0,d1		Make byte offsets
		mulu	d0,d2		by multiplication
*
		lea	(symbol_table,d1.l),a0 a0 --> hashed location
		lea	(symbol_table,d2.l),a3 a3 --> top symbol table + 1
		moveq	#0,d0			The found flag
try_again 	tst.w	(a0)
		beq.s	empty_loc Done if	empty
		cmp.w	(a0),d4
		beq.s	got_it		Exit if found
		addq.l	#st_rec_size,a0 Move to next entry
		cmpa.l	a3,a0		Reached end of table ?
		blt.s	try_again
		movea.l	symbol_table,a0 Yes, return to start
		bra.s	try_again
*
got_it		moveq	#1,d0
empty_loc 	rts			Condition code is correct
*
make_noise	lea	noise,a3	      Makes a noise on errors
		moveq	#mt.ipcom,d0
		trap	#1
		rts
*
		ident	< Fatal errors >
*
error_set_cols	movea.l	error_scr_chan,a0	S/R to set window colours for
*						error reporting
		moveq	#bad_ink,d1	Set ink colour
		moveq	#sd.setin,d0
		trap	#3		No error check avoids infinite loop
*
		moveq	#bad_paper,d1		Set paper colour
		moveq	#sd.setpa,d0		A0,D3 are correct
		trap	#3
*
		moveq	#bad_paper,d1		Set strip colour
		moveq	#sd.setst,d0		A0,D3 are correct
		trap	#3
*
		moveq	#sd.clear,d0		Clear this window
		trap	#3			A0,D3 are correct
*
		moveq	#err_scr_x,d1		Position the cursor
		moveq	#err_scr_y,d2
		moveq	#sd.pixp,d0
		trap	#3
*
		rts
*
fatal1		move.l	d0,-(sp)		Entry point for QDOS errors,
		bsr.s	error_set_cols		d0 holds error code
		move.b	report_flag,d1
		beq.s	QDOS_to_screen
		lea	qdos_mess,a1
		moveq	#0,d2
		move.b	(a1)+,d2
		moveq	#-1,d3
		movea.l	err_chan,a0
		moveq	#io.sstrg,d0
		trap	#3
		move.l	(sp),d0		Restore error code
		move.w	ut.err,a1
		jsr	(a1)
		bsr	rep_new_line
QDOS_to_screen	move.l	(sp)+,d0
		move.b	screen_flag,d1
		beq.s	end_qdos_err
		move.l	d0,-(sp)		All this pratting around with d0
		lea	qdos_mess,a1	      is inelegant !
		moveq	#0,d2
		move.b	(a1)+,d2
		moveq	#-1,d3
		movea.l	error_scr_chan,a0
		moveq	#io.sstrg,d0
		trap	#3
		move.l	(sp)+,d0		Restore error code
		movea.l	error_scr_chan,a0
		move.w	ut.err,a1
		jsr	(a1)
end_qdos_err	bsr	make_noise
fatal2		lea	error_flag,a0	      Check errors have been flagged
		move.w	(a0),d0
		bne.s	errors_present
		moveq	#1,d0			No, so set error count to 1
		move.w	d0,(a0)
errors_present
		bsr	show_error	      Ensure error count shows
		movea.l	obj_chan,a0	  Errors occurred so close and
		moveq	#io.close,d0		delete the output file
		trap	#2
		movea.l	op_file_addr,a0
		movea.l	a0,a6
		cmpa.l	#$1000,a6
		ble	close_all
		subq.w	#5,(a0)		Hide the "_temp"
		moveq	#-1,d1
		moveq	#io.delet,d0
		trap	#2
		addq.w	#5,(a6)		See the "_temp" again
		bra	close_all
*
* To open an error window
*
set_erch		moveq	#myself,d1	Open window for messages & errors
		moveq	#0,d3		Use io.open to avoid screen being cleared
		lea	error_win,a0
		moveq	#io.open,d0
		trap	#2
		lea	error_scr_chan,a1
		move.l	a0,(a1)
		move.l	d0,d3
		bne	suicide1		End with error message in D3
		moveq	#-1,d3
		moveq	#iop.pinf,d0
		trap	#3
		lea	pe_flag,a1
		move.b	d0,(a1)		set pe_flag (0=pe else not pe)
		rts
*
		ident	< Final message >
*
final_mess	move.l	a1,-(sp)		S/R to report success or failure
		moveq	#-1,d3
		move.b	report_flag,d0		Any report file?
		beq.s	final_to_screen
		move.w	(a1)+,d2		Yes, so report to it
		movea.l	err_chan,a0
		moveq	#io.sstrg,d0
		trap	#3
final_to_screen
		movea.l	(sp)+,a1		  Write the message
		move.b	screen_flag,d0
		beq.s	end_final
		movea.l	error_scr_chan,a0
		move.w	(a1)+,d2
		moveq	#io.sstrg,d0		d3 is correct
		trap	#3
end_final 	rts
*
terminate
		move.b	ins_flag,d0
		beq	no_ins

**********************************************************************************
*		  New code added for v4.07				 *
* This allows an "extension" with a0=1 to be used to insert an _INS file.	 *
* First the markers "$`#*" (for the INS positions) and "((TZ>>" are found.	 *
* If these are there, the INS file name from the correct "extension" is loaded	 *
* to RAM. If this is a correct file the contents are placed at the INS position. *
*		  There may be up to 8 _INS files			 *
**********************************************************************************

* D5 is a state marker. We look for n A's "$`#*" and  one B "((TZ>>".
* State -1 = only B found
*        0 = neither B nor n A's found
*        1 = n A's found but no B
* D3 = -1
* D4 = "TZ>>"
* D6 = "#*$`"
* D7 = "(("

* The following are offsets into "zeroes" which is used as working space.

		rsset	0
cb_pos		rs.l	8		8 pointers to #*$` markers
inc_pos		rs.l	1		start of inclusions ((TZ>>
ins_spac		rs.l	1		address of _INS file space
ins_id		rs.l	1		ID of _INS file
ins_hdr		rs.b	64		space for headerof _INS file
ins_name		rs.b	10		copy of 10-byte _INS name
ins_fln		rs.b	44		_INS filename
ins_nam		rs.b	12		restricted _INS name
ins_num		rs.w	1		space for number of _INSs


		lea	zeroes,a0
		subq.b	#1,d0		n - 1 to . .
		move.b	d0,ins_num+1(a0)	. . ins_num (Word)
		movea.l	obj_chan,a0
		moveq	#0,d1		-> start of file
		moveq	#fs_posab,d0
		trap	#3
		moveq	#0,d5		mark state 0
		move.l	#"TZ>>",d4
		move.l	#"#*$`",d6
		move.w	ins_num+zeroes,d7
		swap	d7
		move.w	#"((",d7		D7 = n-1 | "(("
		moveq	#-1,d3
		subq.l	#4,sp

lk		bsr	get_wd		set a word to stack
lk_4		tst.b	d5		label added v4.08
		beq	lk_1		state 0
		bmi	lk_3		state -1
		cmp.w	(sp),d7
		bne	lk

* We have found the first word of B - now check the next long word

lk_1b		bsr	get_lwd		set a long word to stack
		cmp.l	(sp),d4
		beq	lk_4a		B found
		bsr	do_pos3		wind back 2 bytes
		bra	lk_4

lk_4a		bsr	do_pos		find the current position . .
		move.l	d1,inc_pos(a1)	. . and store it
		tst.w	d5
		beq	lk_4b		still A to finish
		bra	lk_end

lk_4b		moveq	#-1,d5		mark B found but not A
		bra	lk

lk_1		cmp.w	(sp),d6		could it be A? . .
		beq	lk_1a		. . yes
		cmp.w	(sp),d7		 if not A could it be B? . . alt v4.08
		beq	lk_1b		. . yes
		bra	lk

lk_1a		bsr	get_wd		get 2nd word of A?
		swap	d6
		cmp.w	(sp),d6
		beq	lk_1c		A found
		swap	d6		restore D6 for another day
		bra	lk_4		altered v4.08

* Altered section v4.09 *

lk_1c		bsr	do_pos
		swap	d7		D7.W = count down of n-1
		swap	d6		reset D6 for further tests on A
		move.w	d7,d2
		lsl.w	#2,d2
		move.l	d1,(a1,d2.w)	store rth _INS place
		dbf	d7,lk1d
		tst.w	d5		0 = just B left:-1 = real end
		beq	lk_1d
		bra	lk_end

lk_1d		moveq	#1,d5		set to state 1
lk1d		swap	d7
		bra	lk_4

* End of altered section v4.09 *

;lk_1b		 bsr	 get_lwd
;		 cmp.l	 (sp),d4
;		 bne	 lk
;		 pea	 lk_4				Altered . .
;		 bra	 do_pos3		 move back 2 bytes
;		 moveq	 #-1,d5		 set to state -1	. . v4.08
;		 bsr	 do_pos
;		 move.l	 d1,4(a1)
;		 bra	 lk
lk_3		cmp.w	(sp),d6
		bne	lk
		bra	lk_1a
;		 swap	 d6
;		 bsr	 get_wd		 get 2nd word of A?
;		 cmp.w	 (sp),d6
;		 beq	 lk_3a
;		 swap	 d6
;		 bra	 lk_4		 Altered v4.08

do_pos3		moveq	#-2,d1		move back 2 bytes
		bra	do_pos2

do_pos1		subq.l	#6,d1
		bra	do_pos2
do_pos		moveq	#0,d1
do_pos2		moveq	#fs_posre,d0
		trap	#3
		lea	zeroes,a1
		rts

get_six		moveq	#6,d2
		bra	get_wd1
get_wd		moveq	#2,d2
		bra	get_wd1
get_lwd		moveq	#4,d2
get_wd1		lea	4(sp),a1
get_wd4		moveq	#io_fstrg,d0
		trap	#3
		tst.l	d0
		bne	get_wd2
		rts

d_ins_error	addq.l	#2,sp
d_ins_error2	addq.l	#4,sp
d_ins_error1
		lea	ins_mess,a0
		bsr	error
		bra	fatal2

get_wd2
		subq.w	#6,d2		was it later? . .
		beq	d_ins_error	----> +6 to sp
		bra	d_ins_error2	----> +4 to sp
;lk_3a		 bsr	 do_pos
;		 move.l	 d1,(a1)
lk_end

;		 addq.l	 #4,sp

* now the position of the n INS markerss at zeroes and of the extension
* marker at zeroes+inc_pos.
* We search the extension area for the name of the n INS files, check them
* and load them into the INS places.
*
* In each case the file position is set just after the marker.
* To find the correct extension we read in 6 bytes. The first four
* give the relative position of the next file, or -1 to signal the end.
* The next two bytes is 1 for the required extension.
* When an extension is found, the name of the INS file is two bytes from
* the end of the "1".


		subq.l	#2,sp		space for 6 bytes info from file
		move.w	zeroes+ins_num,d6	n-1
		move.l	zeroes+inc_pos,d1	pointer to EXTENSION info
		moveq	#fs_posab,d0
		trap	#3
d_ins9		move.w	zeroes+ins_num,d7	n-1
		lea	zeroes,a4
* Here D7 = n-1 (n = number of INS files)
*      A4 = pointers to _INS places in object code

d_ins1		bsr	get_six		get 6 bytes
		move.l	(sp),d1		to next file
		ble	d_ins_error	---->
		cmpi.w	#1,4(sp)
		beq	d_ins_found

d_insa		bsr	do_pos1		go forward D1.L - 6 bytes
		bra	d_ins1

d_ins_found	movea.l	d1,a5		keep offset to next insert
		bsr	do_pos		get current position in D1
		adda.l	d1,a5		set the address of . .
		subq.l	#6,a5		. . next insert to A5
		bsr	get_lwd		get length of INS filename . .
		move.w	2(sp),d2		    . . to D2.W
		lea	zeroes+ins_fln,a1
		move.w	d2,(a1)+		set length for OPEN
		bsr	get_wd4		get filename to zeroes+ins_fln


*
* Now compare names (without regard to case)
* We put the name in INS place to zeroes + ins_name.
* We put (truncated to 10 bytes) the name from the filename
* to zeroes + ins_nam+2, with the count in zeroes + ins_nam.
* This count is also put in zeroes + ins_name-2.
*
* The comparison is by UT_CSTR
*
d_ins8		move.l	(a4)+,d1		next INS position
		beq	d_ins10		got to next INS position
		addq.l	#2,d1		. . set
		movea.l	obj_chan,a0
		moveq	#fs_posab,d0
		trap	#3
		moveq	#10,d2
		lea	zeroes+ins_name,a1
		bsr	get_wd4		get name from INS place
		moveq	#"_",d4
		lea	zeroes+ins_fln-2,a2
		adda.w	zeroes+ins_fln,a2	-> end - 4
		move.l	a2,d5		keep place in D5.L
		move.l	d5,d2
		lea	zeroes+ins_fln+3,a0
		sub.l	a0,d2
d_ins2		cmp.b	-(a2),d4
		dbeq	d2,d_ins2 	look for "_"
		bne	d_ins_error	---->
		addq.l	#1,a2
		sub.l	a2,d5		length
		cmpi.l	#10,d5
		ble	d_ins5
		moveq	#10,d5		restrict length to 10
d_ins5		lea	zeroes+ins_nam,a0	place for restricted name
		move.w	d5,(a0)+		first the length . .
		lea	zeroes+ins_name-2,a1
		move.w	d5,(a1)		. . also to the INS name
		bra	d_ins6
d_ins3		move.b	(a2)+,(a0)+
d_ins6		dbf	d5,d_ins3
		lea	zeroes+ins_nam,a0	reset A0
		suba.l	a6,a0
		suba.l	a6,a1
		moveq	#1,d0		comparison without regard to case
		movea.w	ut_cstr,a2
		jsr	(a2)
		tst.l	d0
		beq	d_ins4		names agree
d_ins10		dbf	d7,d_ins8 	try the next INS
		bra	d_ins_error	---->

d_ins4
		lea	zeroes+ins_fln,a0	point to filename
		moveq	#1,d3		open_in
		moveq	#io_open,d0
		moveq	#-1,d1		myself
		trap	#2
		lea	zeroes+ins_hdr,a1	for header
		move.l	a0,-4(a1) 	keep ID of INS file
		moveq	#-1,d3		timeout
		moveq	#64,d2		size of buffer
		moveq	#fs_headr,d0
		trap	#3
		move.l	zeroes+ins_hdr,d1	length of file
		moveq	#-1,d2		myself
		moveq	#mt_alchp,d0
		trap	#1
		tst.l	d0
		bne	d_ins_error	---->
		lea	zeroes+ins_spac,a1
		move.l	a0,(a1)		keep ALCHP'd address
		movea.l	a0,a1
		move.l	zeroes+ins_hdr,d2	length of file
		moveq	#-1,d3		timeout
		movea.l	zeroes+ins_id,a0	ID
		moveq	#fs_load,d0
		trap	#3
		moveq	#io_close,d0
		trap	#2		close INS file
		movea.l	obj_chan,a0
		moveq	#-10,d1		to wind back 10 bytes
		moveq	#fs_posre,d0
		trap	#3
		move.l	zeroes+ins_hdr,d2
		moveq	#-1,d3
		movea.l	zeroes+ins_spac,a1
		moveq	#io_sstrg,d0
		trap	#3

* We have set one INS file. We must set the remainder.
* D7 had n-1 and A5 is the current position in EXTENSIONs

		movea.l	zeroes+ins_spac,a0	return space . .
		moveq	#mt_rechp,d0	. . to heap
		trap	#1
		movea.l	obj_chan,a0
		clr.l	-4(a4)		clear A position
		move.l	a5,d1		reset to next . .
		moveq	#fs_posab,d0	. . EXTENSION INS
		trap	#3
;		 bsr	 get_six
;		 move.l	 (sp),d1
		dbf	d6,d_ins9 	next INS filename
		addq.l	#6,sp		tidy stack



**************************************************
*      End of code for _INS files	         *
**************************************************

no_ins		move.b	screen_flag,d0
		beq	do_final_mess
		movea.l	error_scr_chan,a0	  Clear the message window
		moveq	#-1,d3
		moveq	#sd.clear,d0
		trap	#3
		moveq	#err_scr_x,d1		Position the cursor
		moveq	#err_scr_y,d2		d3,a0 are correct
		moveq	#sd.pixp,d0
		trap	#3
*
do_final_mess	move.w	num_lines,d0		Only calculate lines per minute
		cmpi.w	#50,d0			if >50 lines, otherwise
		bgt.s	do_lpm_calc	performance seems low.
		lea	done_mess3,a1
		bsr	final_mess
		bsr	rep_new_line
		bra	close_all
*
do_lpm_calc	lea	done_mess1,a1	    Report successful completion
		bsr	final_mess		to screen (and report file)
*
		moveq	#mt.rclck,d0		Read the clock
		trap	#1
		move.w	num_lines,d0
		sub.l	start_time,d1		Calculate elapsed time
		bne.s	time_not_zero
		moveq	#1,d1			Fiddle if less than 1 second
time_not_zero	cmpi.l	#32767,d1 Do lines per minute calculation
		bgt.s	long_time differently if high ( >11 mins)
		mulu	#60,d0			Lines per min = lines*60/time
		bra.s	show_lpm
long_time 	divu	#60,d1			Lines per min = lines/(time/60)
*
*					D0	D2
show_lpm:
		SWAP	D0		b | a
		MOVE.L	D0,D2			b | a
		EXT.L	D0		0 | a
		DIVU	D1,D0		r | a'
		SWAP	D0		a'| r
		MOVE.W	D0,D2			b | r
		SWAP	D2			r | b
		DIVU	D1,D2			r'|ans
		MOVE.W	D2,D0		a'|ans
		LEA	10+IO_BUF,A0
		MOVE.L	A0,D2		for length
		BSR	LTOD		set ASCII in io_buf @ A0
		SUB.L	A0,D2		length
		MOVEA.L	A0,A1		-> ASCII string
		moveq	#-1,d3
		moveq	#io.sstrg,d0
		move.b	report_flag,d1
		beq.s	lpm_to_scr
		movea.l	err_chan,a0
		trap	#3
lpm_to_scr	move.b	screen_flag,d0
		beq.s	end_lpm
		lea	10+io_buf,a1
		SUBA.W	D2,A1
		movea.l	error_scr_chan,a0
		moveq	#io.sstrg,d0
		trap	#3
*
end_lpm		lea	done_mess2,a1   And the rest of the message
		bsr	rest_of_mess
		bsr	rep_new_line
*
close_all
*
*		 move.b	 back_flag,d0
*		 beq.s	 not_resident
*
* Print "CODED" or "FAULT" to background window
*
*		 moveq	 #back_paper,d1	 Set strip colour
*		 moveq	 #-1,d3
*		 movea.l	 line_chan,a0
*		 moveq	 #sd.setst,d0
*		 trap	 #3
*
*		 move.w	 #good_back_ink,d1	 and ink colour
*		 lea	 coded_mess,a2
*		 move.w	 error_flag,d0
*		 beq.s	 use_good_ink
*		 lea	 fault_mess,a2
*		 moveq	 #bad_back_ink,d1	 d3,a0 are correct
*use_good_ink	 moveq	 #sd.setin,d0
*		 trap	 #3		 a2 is preserved
*
*		 move.w	 #back_x,d1	 Set cursor position
*		 move.w	 #back_y,d2
*		 moveq	 #sd.pixp,d0
*		 trap	 #3		 a2 still preserved
*
*		 movea.l	 a2,a1		 Print background message
*		 moveq	 #5,d2
*		 moveq	 #io.sstrg,d0
*		 trap	 #3
*
*not_resident


		movea.l	obj_chan,a0
		moveq	#io.close,d0
		trap	#2
		movea.l	int_id,a0 	Close int code file
		moveq	#io.close,d0
		trap	#2
*
		ifne	del_int_file
		movea.l	op_file_addr,a0
		move.l	a0,d1
		cmpi.l	#$1000,d1
		ble	not_r1
		moveq	#-1,d1
		moveq	#io.delet,d0
		trap	#2
not_r1
		endc
*						** 2.10
		movea.l	op_file_addr,a0	  Hide the '_temp' once and for all
		move.l	a0,d0
		cmpi.l	#$1000,d0
		ble	not_r2
		subq.w	#5,(a0)		for use by EXECUTE ??
*
not_r2		movea.l	err_chan,a0	  Close output channels
		moveq	#io.close,d0
		trap	#2
*		 moveq	 #io.close,d0
*		 trap	 #2
*
* Now de-allocate any buffer space used for the intermediate code stream
*
		move.l	param_ad,a6	** 2.15
		move.l	a6,d0
		beq	suicide2
*					Save the error count in the parameters
		move.l	int_code_base(a6),d0
		beq	no_heap_space
		move.l	d0,a0
		moveq	#mt.rechp,d0
		trap	#1			No error returns
		clr.l	int_code_base(a6)	** 2.13
no_heap_space
*
* Block moved ** 2.13
*
		move.w	error_flag,d0	The error count
		bgt.s	save_errors
		blt.s	make_positive
		moveq	#-1,d0		No errors, so save negative number
		bra.s	save_errors
make_positive	moveq	#1,d0
save_errors	move.w	d0,(a6)
*
*
* Now either suicide or loop until error count=0 depending on resident flag
*
;		 move.b	 back_flag,d0
;		 beq	 suicide2
*
*
* Clear the compilation addresses in the template index
*
;		 movea.l	 lib_address,a0
;		 move.l	 -4(a0),d0 d0 := index size (in bytes)
;		 lsr.w	 #3,d0			 ... in entries
;		 subq.l	 #1,d0		 because using DBRA below
;		 addq.l	 #6,a0		 a0 --> first compilation address
;		 moveq	 #-1,d1		 -1 indicates template not saved
;clear_next_one	 move.w	 d1,(a0)
;		 addq.l	 #8,a0		 a0 --> next
;		 dbra	 d0,clear_next_one
*
*		 lea	 vital_regs,a0   Restore register values
*		 movem.l	 (a0),a4-a7
;		 movem.l	 vital_regs,a4-7
*
* Clear the compilation addresses in the internal p jump templates
*
;		 lea	 cg_lib_p+6,a0
;		 move.w	 d1,(a0)		 d1 set to -1 above
;		 addq.l	 #lib_rec_size,a0
;		 move.w	 d1,(a0)
;		 addq.l	 #lib_rec_size,a0
;		 move.w	 d1,(a0)
;		 addq.l	 #lib_rec_size,a0
;		 move.w	 d1,(a0)
*
;		 lea	 line,a0		       Initialise various variables
;		 move.l	 d1,(a0)+
;		 move.l	 d1,(a0)+
;		 move.l	 d1,(a0)+
;		 move.l	 d1,(a0)+
;		 move.l	 d1,(a0)+
;		 lea	 max_2byte_dest,a0
;		 move.l	 #$FFFE,d2
;		 subi.l	 #overhead,d2
;		 move.l	 d2,(a0)+
;		 move.b	 d0,(a0)+  Progress flag
;		 move.b	 d1,(a0)+  Screen flag
*		 move.l	 d0,(a0)+  Flags (4 bytes)
;		 move.w	 d0,(a0)+
;		 move.b	 d0,(a0)+
;		 addq.l	 #+1,a0	 Leave pe_flag set
;		 move.l	 d0,(a0)+  from_file, error count
;		 move.l	 d1,(a0)+  Intermediate code channel ID
;		 move.w	 d0,(a0)+  Line count
*
;		 bra	 restart	       And restart
*
suicide2		move.b	pe_flag,d7
		bne	suicide		Not PE
suicide4		lea	con,a0		to open a CON channel
		moveq	#myself,d1
		moveq	#0,d3		ordinary open
		moveq	#io.open,d0
		trap	#2
		tst.l	d0
		bne	suicide	---->	Really Fatal
		move.w	#200,d3		timeout
		moveq	#io_fbyte,d0
		trap	#3
		moveq	#io.close,d0
		trap	#2
suicide		movea.l	line_chan,a0
		moveq	#io.close,d0
		trap	#2
		movea.l	error_scr_chan,a0
		moveq	#io.close,d0
		trap	#2
		moveq	#0,d3
suicide1		moveq	#mt.frjob,d0
		moveq	#-1,d1
		trap	#1
*
to_me		bra.s	to_me		Just in case !!!
*
suicide3		movea.l	error_scr_chan,a0
		lea	firs_mess,a1
		move.w	(a1)+,d2
		moveq	#-1,d3
		moveq	#io.sstrg,d0
		trap	#3
		bra	suicide4
*
*firs_mess	 string	 <No file to generate - Bye>
		hed1    <'No file to generate - Bye'>,firs_mess
*
LTOD		LIB	WIN1_LIB_LTOD_BIN	Puts long + word -> ASCII
*
ink		moveq	#sd.setin,d0
tp_3		trap	#3
		tst.l	d0
		bne	tp_error
		rts
tp_error		addq.l	#4,sp
		bra	fatal1
*
* Sets a window.
* On entry A2 -> size/position block: D1/2 to border colour and size
*	(wdef1 sets a zero border)
*
* It is expected that A2 points to a contiguous set of window blocks
* On exit A2 points to the next one.
*
wdef1		moveq	#0,d1
		moveq	#0,d2
wdef		movea.l	a2,a1	set up window block
		addq.l	#8,a2	-> the next one
		tp3	wdef
cls		tp3	clear
paper		tp3	setpa
strip		tp3	setst
csize		moveq	#0,d2	y-size
		tp3	setsz
over		tp3	setmd
cursor		tp3	pixp
sstrg		move.w	(a1)+,d2	length
sstrg1		moveq	#io.sstrg,d0
		bra	tp_3
*
*win		 string	 <scr_512x100a0x0>
		hed1	<'scr_512x100a0x0'>,win
*		 ds.w	 0
*
*error_win	 string	 <scr_437x13a46x33>
*		 ds.w	 0
		 hed1	 <'scr_437x13a46x33'>,error_win
*
*con		 string	 <con>
		hed1	<'con'>,con
*
phead1		dc.w	phe-*-2
		dc.b	"  1987 The Turbo Team                         "
		dc.b	" 2002 George Gwilt V"
phe		ds.b	0
		ds.w	0	just in case
*phead2		 string	 <TURBO>
*phead3		 string	 <Pass: 3>
*phead4		 string	 <Line: 0>
*phead5		 string	 <Errors: 0>
*phead6		 string	 <Warnings: 0>
*
		hed1	<'TURBO'>,phead2
		hed1	<'Pass: 3'>,phead3
		hed1	<'Line: 0'>,phead4
		hed1	<'Errors: 0'>,phead5
		hed1	<'Warnings: 0'>,phead6

swin		dc.w	512,100,0,0	Whole window
		dc.w	440,15,48,34	The . .
		dc.w	440,15,45,32	. . copyright . .
		dc.w	432,10,49,35	. . window
		dc.w	400,25,38,34	for "TURBO"
		dc.w	80,15,48,11	For . .
		dc.w	80,15,45,9	. . "Pass: . .
		dc.w	72,10,49,12	. . 0"
		dc.w	96,15,136,11	For . .
		dc.w	96,15,134,9	. . "Lines: . .
		dc.w	88,10,137,12	. . 0"
		dc.w	112,15,240,11	For . .
		dc.w	112,15,237,9	. . "Errors: . .
		dc.w	104,10,241,12	. . 0"
		dc.w	128,15,360,11	For . .
		dc.w	128,15,357,9	. . "Warnings: . .
		dc.w	120,10,361,12	. . 0"
		dc.w	512,100,0,0	= win
*
* sound parameters for error noise
noise		dc.b	$0A	Command
		dc.b	$08	No. of parameter bytes
		dc.l	$AAAA		No. of bits per byte
		dc.b	0		Pitch 1
		dc.b	30		Pitch 2
		dc.b	70,0		Interval
		dc.b	252,8		Duration
		dc.b	$F0	Step + wrap
		dc.b	0		Random + fuzzy
		dc.w	$0100		No reply
*
*	Variables
*
line		dc.w	0	Basic line number being compiled
lab_inc		dc.w	init_lab_inc	To be added to symbol table end pass 0
entry_ad		dc.w	0	To calc offset to executable code
lab_address	dc.l	0	Temporarily holds label address in pass 1
num_par_bytes	dc.l	0	Holds number of parameter bytes (was .w )
bytes_got 	dc.w	0	Holds number of bytes fetched for strings
obj_chan		dc.l	-1	Channel ID for object code
err_chan		dc.l	-1	Error message channel ID
int_start 	dc.l	-1	Start address of intermediate code
line_chan 	dc.l	-1	Channel ID for line number display
error_scr_chan	dc.l	-1	Channel ID of screen message & error window
lib_address	dc.l	-1	Locates the template library
size_sym_tab	dc.l	-1	No. of records in symbol table
op_file_addr	dc.l	2	Absolute address of output file name
code_size 	dc.l	0	Size of generated code for phase check
max_2byte_dest	dc.l	$FFFE-overhead	For p to p jumps, the maximum
*					address in range of base
progress_flag	dc.b	0	= -1 for pass, line no, error count to screen
screen_flag	dc.b	-1	= -1 for messages to screen
ins_flag		dc.b	0	= -1 if REMark%%<ins file>
report_flag	dc.b	0	= -1 for a report file
small_code	dc.b	0	= -1 for <64K compiled code
pe_flag		dc.b	0	=0 for PE, else not 0
*
from_file 	dc.w	0	= -1 for int code from file
error_flag	dc.w	0	A count of the errors
int_id		dc.l	-1	Int code file id
num_lines 	dc.w	0	Count of number of lines
start_time	dc.l	0	Clock value for lines per minute calculation
task_name_addr	dc.l	0	Address of task name
zeroes		dcb.l	64,0	A block of 256 bytes preset to
*				zero for byte allocation, to
*				save 0's instead of random
*				garbage
vital_regs	ds.l	4	Space for 4 registers, for restart
io_buf		ds.b	16		Buffer for conversions
int_buf		ds.b	size_int_buf	File int code buffer
sys_base		ds.l	3	Space for true sys_vars, sys_top
*				& communication area
old_pos		ds.l	1	For improver - position of input
old_pos2		ds.l	1	    "    a second position
curr_pos		ds.l	1	    "    a third position
hide_a4		ds.l	1	To keep a4 while improving
*

ins_fl		equ	zeroes+90
		ident	< Internal jump library >
*
* Needed to implement the less than 64K version of Turbo.
* Because this is incredibly complicated and an awful lot of work,
* I shall be very annoyed if it does not save a significant number of bytes.
* The idea is to use these jump templates if the <64K option is selected,
* they are copied from the Supercharge template library
*
cg_lib_index	lib_rec 235,s242,e242,pars	Goto
		lib_rec 239,s239,e239,pars	If_false
		lib_rec 242,s242,e242,pars	Jump
		lib_rec 245,s245,e245,pars	If_true
cg_lib_p		lib_rec 1235,s1242,e1242,pars Goto_p
		lib_rec 1239,s1239,e1239,pars If_true_p
		lib_rec 1242,s1242,e1242,pars Jump_p
		lib_rec 1245,s1245,e1245,pars If_true_p
*
* Goto and Jump
*
s242		ljmp
e242
		par_words 1
		par_spec	1,21,2		par 1, type 21, offset 2
		end_par_spec
*
s239		tst.w	(a1)		If_false ** 2.08
		addq.l	#6,a1
		bne.s	e239+6
e239
		par_words 1
		par_spec	1,24,0		par 1, type 24
		end_par_spec
*
s245		tst.w	(a1)		If_true ** 2.08
		addq.l	#6,a1
		beq.s	e245+6
e245
		par_words 1
		par_spec	1,24,0		par 1, type 24
		end_par_spec
*
s1242		move.w	(a5)+,d7		Goto_p and Jump_p
		lea	(a6,d7.w),a5
e1242
		par_words 1
		par_spec	1,4,0		par 1 type 4
		end_par_spec
*
s1239		tst.w	(a1)		If_false_p ** 2.08
		bne.s	if_false1
		move.w	(a5)+,d7
		lea	(a6,d7.w),a5
		bra.s	if_false2
		tst.w	(a1)		** 2.08
		bne.s	if_false1
		bra.s	if_false2
if_false1 	addq.l	#2,a5
if_false2 	addq.l	#6,a1
e1239
		par_words 1
		par_spec	1,4,0
		end_par_spec
*
s1245		tst.w	(a1)		If_true_p ** 2.08
		beq.s	if_true1
		move.w	(a5)+,d7
		lea	(a6,d7.w),a5
		bra.s	if_true2
		tst.w	(a1)		** 2.08
		beq.s	if_true1
		bra.s	if_true2
if_true1		addq.l	#2,a5
if_true2		addq.l	#6,a1
e1245
		par_words 1
		par_spec	1,4,0
		end_par_spec
*
*
		ident	< Start of library >
*
		cnop	0,4 Ensure LONG boundary
library_area
vect_tab_ad
*
* Expects the template library to start with
*		dc.w	vect_tab_ad Relative to base
*		dc.w	nat_to_p	Relative to base
*		dc.w	channel_table Relative to base
*		dc.l	lib_size	In bytes
*
		end
