       if gdg = 0
	in win2_turbo_wrk_fnproc_inc
	else
	in win1_lib_fnproc_asm
	endif
	IF REMLIB=1
SMSQ	SET 0
	ENDIF

*  Full  Turbo Toolkit.
*   Copyright The Turbo Team 1990.
*  Modified by Mark Knight 1997, 1998, 1999.
*  Modified by David Gilham 1997, 1998,    1999.
*  Added code by george  gwilt to improve
*  search_memory David Gilham June 1999
*
*  Notes on how to assemble this file
*
*  Note following file should be assembled
*  with gwass by defining smsq to be 1 or 0
*  in an appropriate including file
*  modification for qmac should be trivial
*
*  No Longer Trivial as I have added
*  for the extensions definition block
*  some Gwass specific macros
*  written by George Gwilt
*  which are included above
*
*
*  Changes since v3h27 of toolkit
*
*  version 3.28
*  March 2001
*  George Gwilt  has changed the behaviour of CHARGE slightly
*  Added TURBO_V keyword.
*
*  version 3.29
*  March 2001  -  June 2001
*  made sure Charge when deleting file has
*  valid job id in d1
*  as per jochen Merz's manual
*  being very paranoid	there
*  Removed unneeded andi.w #$ff
*  as the set priority trap call
*  only uses the bottom byte.
*  Also changed  some move.b #0
*  and move.w #0 to clr.b and clr.w
*  but not in the microdrive handling routines.
*  Now do check for QXL hardware in sys vars
*  in SMSQ/E version.  I do not know if
*  this will work under smsq	or is safe
*  but I will await reports.
*  The routines for microdrive sector and sector header handling
*  now check if sv.ident is original qdos sv.ident
*  and not the SMSQ/E or atari or Thor sv.ident etc
*  they also check for the hardware byte to see if they are
*  running on a qxl. If sv.ident is as per original and they
*  are not running on a QXL they proceed as normal, otherwise
*  they return a not implemented  error.
*  query is there way to check you are running on a
*  ql emulator for the amiga?
*  I  guess you cannot cover all bases eg qlay or uqlx
*  or the emulators for the mac but I doubt that peooble using
*  those systems will use software which uses these extensions
*  the only one I can think of at the moment is supermedia manager.
*  The code to access microdrive has thus now been removed from
*  the smsq/e version of the toolkit and the  routines
*  in the SMSQ/E version now do an immediate error return
*  of not implemented. Is there a way independant of smsq/e
*  of checking whether you are running on an Aurora machine.
*  if so an Error return of not implemented might be appropriate.
*
* v3.30 August 2001
*  Slightly better check for smsq on qxl
* after sugggestion by george gwilt hopefully this is the last word
* on the subject.
* Still need a surefire check in microdrive routines to
* check whether hardware supports miscrodrive ie qdos on aurora
* doesn't have microdrives even though the device driver is installed
* Any one using these keywords on non standard hardware better beware.
* Also changed startup to send to sbasic#0 after a suggestion by george
* gwilt this is for the real tinkerers with sbasics multibasics etc
* who wat to see what version of the toolkit they have loaded.
* Maybe they have changed the configuration of the Toolkit and want to
* experinent.
*
* v3.31 Oct 2001
*
* Fixed  bug with reference to Get% , Getf,Get$
* pointed out by Bruno Coavity in September 2001 Quanta
*
* Now module safe mesage display only if loaded under job 0
* and running under SMSQ or SMSQ/E . This only applies to The smsq
* version of the toolkit not the generic qdos version of the toolkit.
*
* Made the Edit family of functions a bit more stable
* ie switched to supervisor mode for some data movements etc
* code contributed by George Gwilt  slightly modified by DCG
*
* Fixed a problem which could crash machine if superbasic #0 is closed
* and commandline is called. the original code was returning in supervisor mode.
*
*
* Did a bit more code tweaking mainly affecting generic qdos version
* Chopped a few more bytes off the code.
*
*
* Did yet more more code tweaking based mainly on yet more contributions by George Gwilt
* mainly branch removal etc , I think cycle shaving is more important than
* byte shaving. Also stability of the code under the interpreter is most important
* , we do not want a crashing machine due to the intepreter moving about,
* hence some of  the forays into supervisor mode etc.
*
* George Gwilt has done some work in making  Execute and Charge a bit  more stable.
*
* v3a32 Dec 01 GG
*
* Tried to correct alteration to CHARGE
*
* v3c32 Jan 02 GG
*
* Added "slb" to TYPE_IN to select Job 0 and set its kyboard queue if PE
* present.
*
* v3g32 George has redone command_line to make it work a bit better
*	TYPE_IN now works as per documentation. He also added BASIC_ADR
*	function.
*  v3.32 equivalent to version 3g32
*
*  v3a33 added turbo_dummyp, turbo_dummyf,turbo_dummy% and turbo_dummy$
*	 for use with basic_addr as suggested by Mark Knight
*
*
* v3b33 fixed minor bug in device_status which could result in file being overwritten
*	code suggested by George Gwilt.
*
*
* v 3c33	Generated new version for inclusion  into turbo compiled tasks
*	  compiled with  Turbo 4.16 or later.
*	  and maybe liberated tasks if anyone cares to try.
*	  Please note the new version is not loadable from basic
*	  and is only for inclusion in a task via rems
*	  I have tried to make the new version as small
*	  as possible but there is still some work to be done
*	  In this area espspecial in remove charge code.
*	  I have remove keywords whih are turbo directives
*	  and also those which turbo generates special
*	  code for.
*	  I have therefore	added a new conditional comilation variable
*	  REMLIB.
*	  I have	also shuffled Nametable to front of binary
*	  for ease of rem including under new scheme
*	  I have stripped out charge from binary to be included in compiled
*	  tasks as it will not work and hence uses up wasted space.
*	  It still needs a bit more stripping to included in compiled
*	  tasks  as the code is quite interconnected George?
*	  Also changed tdummy routines to point to notimp
*	  instead of dedicated equivalent code
*	  hence chopped off a few more bytes.
*	  The apprppriate  offsets being 6 and 10 respectivly.
*	  v3.33 identical to v3c33
*	  This one is to be thrown to the wolves
*	  I will still look for further code shavings
*	  especialy in the REM version.
*
* v 3.34	Changed PIPE_0 at end to PIPE
*	  which fixed a rare bug under later SMSQ/E's  pipedrivers
*	  fixed a bug  notified by Rich Mellor
*	  Removed TrBo Watermarking.
*	  Reason	possible incompatibilies with future versions of SMSQ/E
*	  which might use the area for their own purposes.
*	  Added PC_FREEMEM Function to give free memory in machine
*	  in both compiled and interpreted tasks gives same value
*	  as TK2's FREE_MEM. Also if in interpreted basic
*	  redirected calls of FREE_MEMORY to PC_FREEMEM.
*	  Peeking at system variables can be problematic
*	  especialy if SMSQ/E changes the ground under your feet.
*	  Ie the peek doesn't give a corect value for  free system
*	  memory under later SMSQ/E's.
*	  Using the  trap call is more sensible and a function
*	  which returns the free_memory in the system  under
*	  both compiled and interpreted basic should be useful.
*	  I do not want people to rely on Toolkit II free_mem
*	  even though most QL users have it.
*
* v 3.35	  Altered DEVICE_STATUS to allow for the peculiar SMSQ/E
*	  trick of turning an OPEN into an OPEN_IN if the medium
*	  is write protected.
*
* v 3.36	  added TURBO_objstk for configuring user stack size
*
* v 3.37	  added TURBO_ref for optionally passing strings by reference.
*
* v 3.38	  added TURBO_list and TURBO_sound
*
* v 3.39	  COMMAND_LINE altered for SBASIC
*
* v 3.40	  COMMAND_LINE realtered for SBASIC
*
* v 3.41	  Config block added
*
* v 3.42	  TURBO_DUMMY added
*
* v 3.43	  TURBO_CH added
*
* v 3.44	  Config block entries properly entered

iop.pick	equ	$7C
iop.pinf	equ	$70
bv_bfbas	equ	0
bv_rip	equ	$58

	ERR
	LOW_EA
VER	EQU	?'3.44'
      IF	REMLIB=1
	DC.W	$4AFB
VerMesg DC.B	VER
      END_IF
strt	bra	start
Defines
      PROC_START
      pf_name	  notimp,TURBO_DUMMYP
      pf_name	  PokeFlot,POKE_F
      IF	  REMLIB=0
      PF_NAME	  NoErrors,TURBO_list
      PF_NAME	  NoErrors,TURBO_sound
      PF_NAME	  NoErrors,TURBO_ref
      PF_NAME	  NoErrors,TURBO_objstk
      PF_NAME	  NoErrors,TURBO_buffersz
      pf_name	  NoErrors,IMPLICIT%
      pf_name	  NoErrors,IMPLICIT$
      pf_name	  NoErrors,EXTERNAL
      pf_name	  NoErrors,GLOBAL
      pf_name	  NoErrors,DATA_AREA
      pf_name	  NoErrors,REFERENCE
      pf_name	  NoErrors,WHEN_ERROR
      pf_name	  NoErrors,END_WHEN
      pf_name	  NoErrors,RETRY_HERE
      pf_name	  Snooze,SNOOZE
      pf_name	  Snooze,CATNAP
      pf_name	  NoErrors,THROW_AWAY
      pf_name	  Charge,CHARGE
      pf_name	  MoveMem,MOVE_MEMORY
      IF	  SMSQ=0
      pf_name	  PokeStr,POKE$
      END_IF
      END_IF
      pf_name	  Set_Chan,SET_CHANNEL
      pf_name	  DefaultDv,DEFAULT_DEVICE
      pf_name	  Connect,CONNECT
      pf_name	  Execute,EXECUTE
      pf_name	  ExecuteW,EXECUTE_W
      pf_name	  ExecuteA,EXECUTE_A
      PF_name	  LinkLoad,LINK_LOAD
      PF_NAME	  LinkLdWt,LINK_LOAD_W
      PF_NAME	  LinkLdAb,LINK_LOAD_A
      PF_NAME	  ComdLine,COMMAND_LINE
      PF_NAME	  DeAlloct,DEALLOCATE
      PF_NAME	  Type_In,TYPE_IN
      pf_NAME	  SetPosn,SET_POSITION
      pf_name	  CursorOn,CURSOR_ON
      pf_name	  CursOff,CURSOR_OFF
      pf_name	  SetPrior,SET_PRIORITY
      pf_name	  SuspTask,SUSPEND_TASK
      pf_name	  RelsTask,RELEASE_TASK
      pf_name	  RemvTask,REMOVE_TASK
      pf_name	  ListTasks,LIST_TASKS
      pf_name	  EndCmd,END_CMD
      pf_name	  SetFont,SET_FONT
      IF	  REMLIB=0
      pf_name	  NoErrors,IMPLICITL
      pf_name	  NoErrors,IMPLICITB
      pf_name	  NoErrors,IMPLICITC
      PF_NAME	  NoErrors,IMPLICITF
      PF_NAME	  NoErrors,IMPLICITD
      PF_NAME	  NoErrors,IMPLICITV
      PF_NAME	  NoErrors,DEBUG
      PF_NAME	  NoErrors,DEBUG_LEVEL
      PF_NAME	  NoErrors,TURBO_objfil
      PF_NAME	  NoErrors,TURBO_objdat
      PF_NAME	  NoErrors,TURBO_repfil
      PF_NAME	  NoErrors,TURBO_taskn
      PF_NAME	  NoErrors,TURBO_diags
      PF_NAME	  NoErrors,TURBO_struct
      PF_NAME	  NoErrors,TURBO_model
      PF_NAME	  NoErrors,TURBO_optim
      PF_NAME	  NoErrors,TURBO_windo
      PF_NAME	  NoErrors,TURBO_locstr
      PF_NAME	  NoErrors,MANIFEST
      END_IF
      PF_NAME	  GmdvInfo,GMINFO
      PF_NAME	  GmdvSect,GET_MSEC
      PF_NAME	  PmdvSect,PUT_MSEC
      PF_NAME	  GetHeadr,GetHEAD
      PF_NAME	  SetHeadr,SetHEAD
      PROC_END
      FN_START
      IF REMLIB=0
      PF_NAME	     FreeMem,TURBO_P
      PF_NAME	     FreeMem,TURBO_F
      PF_NAME	     OptnCmdStr,OPTION_CMD$
      PF_NAME	     Erlin,ERLIN%
      PF_NAME	     Ernum,ERNUM%
      PF_NAME	     IsCompld,COMPILED
      END_IF
      PF_NAME	     PeekFlt,PEEK_F
      IF	  REMLIB=0
      IF	  SMSQ=0
      PF_NAME	     PeekStr,PEEK$
      END_IF
      END_IF
      PF_NAME	     IntgrStr,INTEGER$
      PF_NAME	     FloatStr,FLOAT$
      PF_NAME	     StrngStr,STRING$
      PF_NAME	     Tk_Ver,TK_VER$
      PF_NAME	     FreeMem,FREE_MEMORY
      PF_NAME	     ChanId,CHANNEL_ID
      PF_NAME	     DataSpc,DATASPACE
      PF_NAME	     SearchMem,SEARCH_MEMORY
      PF_NAME	     Allocatn,ALLOCATION
      PF_NAME	     BasicByt,BASIC_B%
      PF_NAME	     BasicWrd,BASIC_W%
      PF_NAME	     BasicLng,BASIC_L
      PF_NAME	     BasicFlt,BASIC_F
      PF_NAME	     BasicPtr,BASIC_POINTER
      PF_NAME	     BasicNam,BASIC_NAME$
      PF_NAME	     BasicTyp,BASIC_TYPE%
      PF_NAME	     BasicIdx,BASIC_INDEX%
      PF_NAME	     EditStrg,EDIT$
      PF_NAME	     EditFlt,EDITF
      PF_NAME	     EditInt,EDIT%
      PF_NAME	     DevStatus,DEVICE_STATUS
      PF_NAME	     DevSpace,DEVICE_SPACE
      PF_NAME	     GetInt,GET%
      PF_NAME	     GetFloat,GETF
      PF_NAME	     GetStr,GET$
      PF_NAME	     InputStr,INPUT$
      PF_NAME	     Positn,POSITION
      PF_NAME	     StrngInt,STRING%
      PF_NAME	     StrngFlt,STRINGF
      PF_NAME	     Sys_Vars,SYS_VARS
      PF_NAME	     Fwindow,FWINDOW%
      PF_NAME	     Longstr,LONGINTEGER$
      PF_NAME	     Strlong,LONGINTEGER
      IF	     REMLIB=0
      PF_NAME	     GWWD,TURBO_V
      PF_NAME	     GWWD,TURBO_CH
      END_IF
      PF_NAME	     BasicAdr,BASIC_ADR
      PF_NAME	     notimp,TURBO_DUMMY
      PF_NAME	     notimp,TURBO_DUMMYF
      PF_NAME	     notimp,TURBO_DUMMY%
      PF_NAME	     notimp,TURBO_DUMMY$
      PF_NAME	     MYFreemem,PC_FREEMEM
      FN_END

      FILETYPE	  0
Start
      moveq	  #0,d0
      trap	  #1		  QDOS TRAP #1 - D0=$00 : MT.INF
      IF	  REMLIB=0
      IF	  SMSQ=1
      cmpi.l	  #'SMSQ',(a0)	  very crude test for running under SMSQ/E
      beq.s	  doit		  might fail under some versions of SMSQ
*
* SMSQ sets sv_ident to same as normal QDOS
* this check squeezes out the thors of the world
*
	cmpi.l	#$d2540000,(a0)
	bne.s	start_bad * paranoid
* Following code contributed by George Gwilt
	moveq	#$1f,d1	* New
	and.b	$a7(a0),d1	* New
	cmpi.b	#$1c,d1	* New
*     cmpi.b	  #$1c,$a7(a0)	  are we on a QXL
	beq.s	doit		might as well try it out
*     query do all versions of SMSQ set the machine type byte
start_bad moveq #-19,d0
	rts
doit
	END_IF
	END_IF

*********************** Added for v 3.41  and amended v 3.44

* Set parameters from Config Block
	moveq	#0,d0
	move.b	chra0,d0		abort key
	move.b	cdea1,d1		with ALT? . .
	neg.b	d1
	beq	doit1		. . no
	rol.w	#8,d0		move up abort key . .
	move.b	d1,d0		and add $FF
doit1	lea	LAB1744,a2
	move.w	d0,(a2)	Set the answer

	lea	b_end,a0	point to end of answer
	move.l	a0,d2		keep this in D2
	move.l	WRDA1,d0	set the pipe length to d0
	bsr	ltod		convert to ASCII
	sub.l	a0,d2		length of ASCII in D2
	lea	PIPE_END,a2
	suba.l	d2,a2		place ASCII starts
	bra	doit3
doit2	move.b	(a0)+,(a2)+
doit3	dbf	d2,doit2

	lea	LAB1746,a0	v 3.44
	move.w	WRDA0,(a0)	   "


*********************** End of v 3.41 addition

	movea.l a0,a4
	tst.l	$ac(a4)	SV.PRGD
      IF	  REMLIB=0
	bne.s	AddNames
      ELSE
	bne.s	InitDone
      END_IF
	moveq	#$6c,d1
	moveq	#0,d2
	moveq	#$18,d0
	trap	#1		QDOS TRAP #1 - D0=$18 : MT.ALCHP
	tst.l	d0
	bne.s	InitDone
	move.l	a0,$ac(a4)	SV.PRGD
	movea.l a0,a2
	moveq	#5,d0
	move.w	d0,(a2)+
	subq.w	#1,d0
	lea	DfltName,a3
CopyName	move.b	(a3)+,(a2)+
	dbf	d0,CopyName
	lea	$24(a0),a0
	move.l	a0,$b0(a4)	SV.DATD
	lea	$24(a0),a0
	move.l	a0,$b4(a4)	SV.DSTD
      IF	 REMLIB=1
InitDone
	moveq	#0,d0
	rts
      END_IF
      IF	 REMLIB=0
AddNames	lea	Defines,a1
	movea.w $0110,a2		BP.INIT
	jsr	(a2)		VECTOR utility $110 : BP.INIT
      IF	  SMSQ=0
	moveq	#0,d0		MT.INF
	trap	#1		QDOS TRAP #1 - D0=$00 : MT.INF
	cmpi.l	#'1.10',d2	is it JS or later?
	bcc.s	message	if so	no need to patch call DCG
	lea	CallName,a1
	trap	#0
	bsr	LAB0A98
	bmi	LAB09FA
	lea	LAB03FA,a2
	move.l	a2,-6(a0)
	andi.w	#-$2701,sr	clear S210
      END_IF

message
	 IF   SMSQ=1
	moveq	#0,d0
	trap	#1
	tst.l	d1
	beq.s	message1
	 END_IF
	lea	StartMsg,a1
	movea.l $30(a6),a0	;  (bv_chbas = $30)
	movea.l 0(a0,a6.l),a0	;  ID of channel #0 (possibly SBASIC)
	movea.w UT_MTEXT,a2
	jsr	(a2)
	 IF SMSQ=1
	bra.s	susme
*
* the Following    code writes a string to QDOs channel 0 using a not well
* documented feature of    the vector $CA ie UT.ERR0, (UT.WERMY) In which if
* address of a string with bit 31 set is in d0 the string is written to channel
* 0 but  only if it is open see pennel for details.
*
* DCG
*
* note Now removed in version 3.30 after a suggestion George Gwilt
* I am not sure what the behavioour will be if loaded as a module.
* I await reports.
* Note now added back in for SMSQ version but not generic qdos version
* but only for Job 0
*
message1
	lea	StartMsg,a1
	move.l	a1,d0
	bset	#31,d0
	movea.w $ca,a1
	jsr	(a1)
      END_IF
susme	moveq	#$50,d3
	bra	LAB0B88
InitDone	rts
StartMsg	dc.w	50
	dc.b	'TURBO TOOLKIT Version '
VerMesg
	dc.b	VER,$0a,' 2003 The TURBO Team ',$0a
      END_IF
LAB00B2 movem.l a1-a2,-(a7)
	moveq	#0,d0
	trap	#1		QDOS TRAP #1 - D0=$00 : MT.INF
	lea	$0160(a0),a2
LAB00BE movea.l (a2),a2
	movea.l a2,a1
	bsr.s	LAB00E0
	movea.l 4(a2),a1
	bsr.s	LAB00E0
	moveq	#$15,d0
	lea	LAB1728,a0
LAB00D0 cmpm.b	(a1)+,(a0)+
	bne.s	LAB00BE
	dbf	d0,LAB00D0
	movea.l a1,a0
	movem.l (a7)+,a1-a2
	rts
LAB00E0 moveq	#0,d0
	trap	#1		QDOS TRAP #1 - D0=$00 : MT.INF
	cmpa.l	a0,a1
	bls.s	LAB00F0
	cmpa.l	$20(a0),a1	SV.RAMT
	bhi.s	LAB00F0
	rts
LAB00F0 addq.l	#4,a7
	movem.l (a7)+,a1-a2
	moveq	#-7,d0		ERR.NF
	addq.l	#4,a7
	rts
Erlin	move.w	$c6(a6),d5	BV.ERLIN
	bra.s	RetnWord
Ernum	move.w	$c4(a6),d5
RetnWord	moveq	#2,d6
	bsr	LAB1052
	subq.l	#2,a1
	move.w	d5,0(a1,a6.l)
	bra	LAB10AE
DataSpc move.l	$58(a6),d7	BV.RIP
	bsr	LAB1000
	movea.l a1,a0
*      bsr.s	   LAB013C
	bsr	LAB06D6
	bne.s	LAB012A
	move.l	6(a6,a2.l),d5
	bra.s	LAB0132
LAB012A tst.l	d0
	bne.s	LAB0130
	moveq	#-2,d0		ERR.NJ
LAB0130 move.l	d0,d5
LAB0132 moveq	#2,d0
	trap	#2		QDOS TRAP #2 - D0=$02 : IO.CLOSE
	movea.l d7,a1
	bra	LAB114E
* LAB013C bsr	LAB06D6
*     rts
SearchMem move.l	$58(a6),d7	BV.RIP
	lea	$18(a3),a0	SV.TRNFR
	cmpa.l	a0,a5
	bne	LAB01B6
	subq.l	#8,a5
	bsr	Ftchlngs
	movea.l 0(a1,a6.l),a0
	move.l	4(a1,a6.l),d5
	ble	LAB01B6
	movea.l a5,a3
	addq.l	#8,a5
	bsr	Ftchstrs
	move.l	d5,d3
	move.w	0(a1,a6.l),d2
	ble	LAB01B6
	ext.l	d2
	sub.l	d2,d3
	bcs	LAB01BA
	subq.l	#2,d2
	bmi	LAB01A2
	lea	2(a1,a6.l),a3
;
; qSEARCH_ASM
; 8th March 1999
;
; An addition to Turbo's SEARCH_MEM
;
; George Gwilt
;
; On entry:
;
; d3.L = count of characters to    be searched (less string length	 )
; D2.W = string    length - 2 ( >= 0 )
; (a1,a6.l) -> string to be searched for
; a0 ->  start of search area
; a3 ->  start of string (after the count)
;
BV_TKBAS	EQU	8
;
SearchMem2:
	CMPI.W	#6,D2
	BLE	SearchMem1	if length < 8, use normal method
	MOVE.L	(A6),A2	buffer base
	MOVE.L	BV_TKBAS(A6),d1 buffer top
	SUB.L	A2,d1		buffer length
	CMPI.L	#512,d1
	BLT.S	SearchMem1	can't use buffer!
	MOVE.W	D2,D0
	addq.l	#1,d2		l - 1
	LEA	1(a0,D2.W),a0	point to lth character in memory
	MOVE.B	(a3,D2.W),d1	last character in string
	MOVE.W	D2,D5
	SWAP	D2
	MOVE.W	D5,D2		l-1 | l-1
	MOVE.W	#127,D5
;
; Fill skip table with l - 1
;
FILL	MOVE.L	D2,(A2,A6.L)
	ADDQ.L	#4,A2
	DBF	D5,FILL
	MOVEA.L (A6),A2	reset A2
;
; Set rest of skip table for all characters except the last
;
	movea.l a3,a1		keep start of string
FILL1	MOVEQ	#0,D5
	MOVE.B	(a3)+,D5		next character in string
	ADD.W	D5,D5
	ADDA.W	D5,A2		point to its place in the skip table
	MOVE.W	D0,(A2,A6.L)	set skip -> l-r-1
	SUBA.W	D5,A2
	DBF	D0,FILL1
;
; Now do the search
;
;   CNOP	  0,8
SEA2	MOVEQ	#0,D5
	MOVE.B	(a0)+,D5		next character
	CMP.B	d1,D5		could it be string? . .
	BNE.S	SEA1		. . no
	MOVE.W	D2,D0		l - 1
	SUBQ.L	#1,D0		l - 2
	LEA	-1(a0),a3 point to last character
	SUBA.W	D2,a3		point to possible start
	MOVEA.L A1,A4		start of string
SEARCH	CMP.B	(a3)+,(A4)+
	DBNE	D0,SEARCH
	BEQ.S	FOUND
SEA1	ADD.W	D5,D5
	ADDA.W	D5,A2
	MOVE.W	(A2,A6.L),D0	skip amount
	SUBA.W	D5,A2
	LEA	(a0,D0.W),a0	skip
	EXT.L	D0
	SUB.L	D0,d3		adjust . .
	SUBQ.L	#1,d3		. . count
	BGE.S	SEA2		not finished yet
;
	bra.s	LAB01BA
;
FOUND	SUBA.W	D2,a0		set a0 to start of . .
	SUBQ.L	#1,a0		. . string in memory
	MOVE.L	a0,d5		set answer -> d5.l
	BRA.S	LAB0198
;
SearchMem1
	move.b	(a3)+,d1
LAB017E cmp.b	(a0)+,d1
LAB0180 dbeq	d3,LAB017E
	bne.s	LAB01BE
	movea.l a3,a1
	movea.l a0,a2
	move.w	d2,d4
LAB018C cmpm.b	(a2)+,(a1)+
	dbne	d4,LAB018C
	bne.s	LAB0180
	move.l	a0,d5
	subq.l	#1,d5
LAB0198 move.l	d7,$58(a6)	BV.RIP
	movea.l d7,a1
	bra	LAB114E
LAB01A2 lea	2(a1,a6.l),a3
	move.b	(a3)+,d1
LAB01A8 cmp.b	(a0)+,d1
	dbeq	d3,LAB01A8
	bne.s	LAB01C8
	move.l	a0,d5
	subq.l	#1,d5
	bra.s	LAB0198
LAB01B6 moveq	#-$0f,d0		ERR.BP
	rts
LAB01BA moveq	#0,d5
	bra.s	LAB0198
LAB01BE addq.w	#1,d3
	tst.l	d3
	beq.s	LAB01BA
	subq.l	#1,d3
	bra.s	LAB017E
LAB01C8 addq.w	#1,d3
	tst.l	d3
	beq.s	LAB01BA
	subq.l	#1,d3
	bra.s	LAB01A8
      IF REMLIB=0
MoveMem move.b	1(a3,a6.l),d7
	asr.b	#4,d7
	bsr	Ftchlngs
	subq.w	#3,d3
	bne.s	LAB01B6
	move.l	0(a1,a6.l),d0
	movea.l 4(a1,a6.l),a0
	movea.l 8(a1,a6.l),a2
	cmpi.b	#5,d7
	bne.s	LAB01FA
	move.l	d0,d7
	move.l	a2,d0
	movea.l a0,a2
	movea.l d7,a0
LAB01FA cmpa.l	#$00020000,a2
	bcc.s	LAB0206
	moveq	#-$14,d0		ERR.RO
LAB0204 rts
LAB0206 tst.l	d0
	bmi.s	LAB0220
	tst.w	d0
	beq.s	LAB0218
	subq.w	#1,d0
LAB0210 move.b	(a0)+,(a2)+
	dbf	d0,LAB0210
	addq.w	#1,d0
LAB0218 tst.l	d0
	beq.s	LAB0204
	subq.l	#1,d0
	bra.s	LAB0210
LAB0220 neg.l	d0

	adda.l	d0,a0
	adda.l	d0,a2
	tst.w	d0
	beq.s	LAB0234
	subq.w	#1,d0
LAB022C move.b	-(a0),-(a2)
	dbf	d0,LAB022C
	addq.w	#1,d0
LAB0234 tst.l	d0
	beq.s	LAB0204
	subq.l	#1,d0
	bra.s	LAB022C
      END_IF
*
* Following modifications made to ALLOCATION and DEALLOCATE: First a
* watermark of "TrBo" is added on ALLOCATION.  On DEALLOCATE checks are  made
* for odd addresses,negative addresses,  and   for the watermark,errors are signalled if odd
* address ,negative address or no  watermark.  It also clears watermark.  Watermarking scheme
* based on DIY toolkit but watermark used here is "TrBo"
*
* DCG
*
*
* Now have removed Watermarking scheme because of possible problems
* with SMSQ/E using the 4 byte area for its own purposes.
* DCG
*
*

Allocatn	bsr	Ftchlngs
	moveq	#-1,d2
	subq.w	#1,d3
	bmi.s	LAB0276
	move.l	0(a1,a6.l),d1
	addq.l	#4,a1
	tst.w	d3
	beq.s	LAB0262
	subq.w	#2,d3
	bne.s	LAB0276
	swap	d2
	move.w	6(a1,a6.l),d2
	swap	d2
	move.w	2(a1,a6.l),d2
	addq.l	#8,a1
LAB0262 move.l	a1,$58(a6)	BV.RIP
	moveq	#$18,d0
	trap	#1		QDOS TRAP #1 - D0=$18 : MT.ALCHP
	tst.l	d0
	beq.s	LAB0270
	move.l	d0,d5
	bra	LFPrtn		return on error
LAB0270
*      move.l	   #'TrBo',-4(a0)  write watermark
	move.l	a0,d5
	bra	LFPrtn
LAB0276 moveq	#-$0f,d0		ERR.BP
	rts
DeAlloct	bsr	Ftchlngs
	subq.w	#1,d3
	bne.s	LAB0276
	move.l	0(a1,a6.l),d0
	bmi.s	LAB0276	negative address   ? DCG
	btst	#0,d0		odd address ?
	bne.s	LAB0276	if so errorDCG
	move.l	d0,a0
*      cmpi.l	   #'TrBo',-4(a0)  test for watermark
*      bne.s	   LAB0276   no? then error DCG
*      clr.l	   -4(a0)    clear watermark prevents	   deallocating
*				  same area twice! DCG
	moveq	#$19,d0
	trap	#1		QDOS TRAP #1 - D0=$19 : MT.RECHP
	rts
*
* TYPE_IN Changed to be a bit faster and some bugs removed. Now only one
* queue the current queue at time of call is typed into. Based on code by
* Rich Mellor DCG
*
* Altered  7th December 2001 to be A6 safe
*
Type_In bsr	LAB1000
*      lea   0(a1,a6.l),a5
*      move.w	   (a5)+,d5
* Above is theoretically dangerous since A6 might have altered!! *
*
* Also note that SMSQ/E doesn't like this - it doesn't have a Keyboard Queue
*
	lea	2(a1),a5
	move.w	-2(a5,a6.l),d5
	beq	NoErrors
*	 bsr	 slb		 Sets keyqueue for #0 if possible
	movea.w $e0,a4		IO.QIN
LAB029E moveq	#5,d3
	moveq	#-1,d1
	suba.l	a1,a1
	moveq	#8,d0
	trap	#1		QDOS TRAP #1 - D0=$08 : MT.SUSJB
	move.l	d1,d7
LAB02AA moveq	#0,d0
	trap	#1		QDOS TRAP #1 - D0=$00 : MT.INF
	movea.l $4c(a0),a2	SV.KEYQ
*GetB	 move.b  (a5),d1		 this line moved here from prev label
*
* See comments above
*
GetB	move.b	(a5,a6.l),d1	Safer (if it works)
*				  otherwise TYPE_IN won't work DCG
	tst.l	d7
	beq.s	LAB02C6
	trap	#0		TRAP #0 : Enter supervisor mode
	ori.w	#$0700,sr set 210
	jsr	(a4)
	andi.w	#-$2701,sr	clear S210
	bra.s	LAB02C8
LAB02C6 jsr	(a4)
LAB02C8 tst.l	d0
	bne.s	LAB029E
	addq.l	#1,a5
	subq.w	#1,d5
	bne.s	GetB
	rts
*
* Following code for COMMAND_LINE scavenged from Rich Mellors
* "turbofix_asm" for Minerva. Adapted to look at channel#0 of job 0 only.
* Code to do full Interp search for SMSQ/Eand merging code for Minerva into
* this toolkit would bloat it too much and might be unreliable in checking QDOS
* versions (and be unneeded in most cases).
*
* Seperate files will hopefully be provided for SMSQ/E and Minverva based on
* Rich's code. By the way reopening #0 on a JS seems to work OK.
*
* The code will probably fail if given channel objects to sd.extop or is not
* a console channel.
*
* I do not use $10(a0) in sys.vars because under SMSQ/E it is only a dummy
* containing global name table and associated pointers and does not contain the
* appropriate pointers to channels. DCG
*
* Two stage process now used: first should now work under pre SMSQ second
* under SMSQ. This should work under  most systems. For optimum usage under
* pointer env the job should have no open windows especialy under PEX. If
* PEX is installed sd_extop should be disabled by using PXOFF or
* s=is_ptrap(9,0) if the job has any open windows. DCG
*
ComdLine


*
* This picks Job 0 and makes its keyboard queue current.
* A channel is opened for iop.pinf and iop.pick and finally closed.
* If anything else goes wrong, the current keyboard
* is left unchanged.
*
* New for SBASIC

	cmpa.l	a3,a5		Any parameters? . .
	bne	CL1		. . yes

* End of new for SBASIC

	bsr	get_chan
	bne	slb1	---->
	movea.l a0,a2		Keep ID in A2
	bsr	pinf		Test for PE
	bmi	slb4		Not PE
	moveq	#0,d1		Job 0 to be picked
	moveq	#0,d2		Do not wake the job
	moveq	#-1,d3		Timeout for ever
	moveq	#iop.pick,d0
	trap	#3
	tst.l	d0
	bne	slb2	---->
	moveq	#0,d7		For channel #0
slb4	bsr	nextop1	Set SV_KEYQ
slb2	movea.l a2,a0		Retrieve ID
	moveq	#io_close,d0
	trap	#2
slb1	rts
*
* A0 should be a valid SCR/CON ID
* On exit d6 = $30 if PE else 0
*	Condition code negative if non PE
*
pinf	moveq	#0,d6
	moveq	#-1,d3		Timeout
	moveq	#iop.pinf,d0
	trap	#3
	tst.l	d0
	bne	pinf1		not PE
	moveq	#$30,d6	extra length of channel block
pinf1	rts
*
* nextop sets the keyboard queue for channel ID A0 as current
* entry nextop1 uses channel #0 in place of A0
* If the channel is closed the current value of SV_KEYQ is unchanged
*
nextop	move.w	a0,d7		Number of channel from ID
	lsl.w	#2,d7
nextop1 moveq	#mt_inf,d0
	trap	#1
	movea.l sv_chbas(a0),a1 Channel list base
	add.l	(a1,d7.w),d6	Address of Channel (+$30 if PE)
	bmi	nextop2 ---->	Channel not open
	andi.l	#$ff00ffff,d2	Version
	cmpi.l	#$31003130,d2
	blt	nextop3	< v1.10 has kbd 4 bytes earlier
	addq.l	#4,d6
nextop3 add.l	#$64,d6	Address of Input queue
	move.l	d6,sv_keyq(a0)	Make it current
nextop2 rts

get_chan	lea	con,a0
	moveq	#-1,d1		this job
	moveq	#0,d3
	moveq	#io_open,d0
	trap	#2
	tst.l	d0
	rts
con	dc.w	3
	dc.b	"con"

* SBASIC addition to COMMAND_LINE

CL1
	lea	8(a3),a0
	cmpa.l	a0,a5
	bne	ParamBad	---->	More than 1 parameter
	bsr	Ftchlngs		Get long integers
	moveq	#mt_inf,d0
	trap	#1
	movea.l a0,a5		Keep SYS_VARS in A5
	cmpi.l	#'SMSQ',(a0)	SMSQ? . .
	bne	ParamBad	---->	. . no!!
	move.l	(a1,a6.l),d0	ID of SBASIC (Job or channel)
	addq.l	#4,$58(a6)	BV_RIP

	moveq	#0,d7		Mark 1st try of JOB ID
	move.l	d0,d5		Keep parameter ID in D5
	bra	CL3

CL4	movea.l sv_chbas(a5),a1
	lsl.w	#2,d0
	move.l	(a1,d0.w),d1	Channel block
	bmi	ParamBad	---->	Channel not open
	movea.l d1,a0
	swap	d0		Tag in D0.W
	cmp.w	ch_tag(a0),d0	Correct tag? . .
	bne	ParamBad	---->	. . no
	move.l	ch_owner(a0),d5 Job ID
CL3	movea.l sv_jbbas(a5),a1 Job base
	move.l	d5,d0
	lsl.w	#2,d0
	move.l	(a1,d0.w),d1	-> Job header
	bmi	Trychan	1st time try for channel ID
;	 bmi	 ParamBad   ---->	 No Job
	movea.l d1,a0
	swap	d0		Tag in D0.W
	cmp.w	jb_tag(a0),d0	Correct tag? . .
	bne	Trychan	1st time try channel ID
;	 bne	 ParamBad  ---->	 . . no
	movea.l jb_a6(a0),a4	Job's A6 to A4
	cmpi.l	#'SBAS',-4(a4)	Daughter Basic? . .
	bne	Trychan	1st time try channel ID
;	 bne	 ParamBad  ---->	 . . no
	bsr	get_chan
	bne	ParamBad	---->
	movea.l a0,a2		keep ID in A2
	moveq	#iop.pick,d0
	move.l	d5,d1		Job ID
	moveq	#0,d2		don't wake
	moveq	#-1,d3		timeout
	trap	#3
	move.l	d0,d7		error code to D7
	bsr	slb2		close channel
	move.l	d7,d0
	bne	ParamBad	---->	error exit
	move.l	$30(a4),d1	BV_CHBAS
	move.l	(a4,d1.l),d4	Channel #0 ID
	bmi	what_chan ----> #0 not open!
	movea.l sv_chbas(a5),a1 -> list of system channels
	lsl.w	#2,d4
	move.l	(a1,d4.w),d0	address of channel block
	bmi	what_chan ---->
	movea.l d0,a0
	swap	d4
	cmp.w	ch_tag(a0),d4
	bne	what_chan ---->
	lea	$98(a0),a0	-> keyboard queue
	move.l	a0,sv_keyq(a5)	set keyboard queue
	moveq	#0,d0
CL2	rts

Trychan tst.l	d7		1st time? . .
	bne	Parambad	---->	. . no
	move.l	d5,d0		Replace the parameter ID
	moveq	#-1,d7		Mark 2nd time
	bra	CL4		Try channel ID now

* End of SBASIC addition to COMMAND_LINE



	if 0=1

      IF	  SMSQ=0
      trap	     #0
      ori.w	  #0700,sr
      moveq	  #0,d0
      trap	  #1
      movea.l	  a0,a4
      movea.l	  $10(a0),a0	  This works under JS and Minerva
      lea   $68(a0),a0	  but not under SMSQ/E DCG
      move.l	  $30(a0),d0
      move.l	  0(a0,d0.l),a0
      andi.w	  #$d8ff,sr
      moveq	  #9,d0
      moveq	  #-1,d3
      lea   extop,a2
      trap	  #3
      cmpi.w	  #-6,d0
      bne.s	  All_OK
      END_IF
      trap	  #0
      ori.w	  #$0700,sr
      IF	  SMSQ=1
      moveq	  #0,d0
      trap	  #1
      movea.l	  a0,a4
      END_IF
      move.l	  $68(a4),a0	  This works under SMSQ/E but not under Minerva/JS
      move.l	  (a0),a0   find job 0 DCG
      lea   $80(a0),a0	      ?????????????
      lea   $68(a0),a0	      ?????????????
      move.l	  $30(a0),d0
      move.l	  0(a0,d0.l),d3   open ?
      bmi.s	  supAll_OK	     if not zero return someone's closed
*				  Superbasic #0!
*				  small problem fixed
*				  now correctly drops to user mode
*				  if superbasic #0 closed
*
      andi.w	#$d8ff,sr
      move.l	d3,a0
      bra.s	LAB02EA
supall_ok
      andi	#$d8ff,sr
      bra   ALL_OK

	endif
*
* Note that CURSOR_ON does not set the current key queue to the selected
* channel if "!" or "to" follows the channel number
*
CursorOn	moveq	#$0e,d7
	cmpa.l	a3,a5
	beq.s	LAB02E6
	btst	#6,1(a6,a3.l)	  Is the sep. ! or TO? . .
	bne.s	LAB0322	. . yes
LAB02E6 bsr.s	LAB0322
	bne.s	LAB0336
	bsr	pinf
;	 bmi	 LAB02EA
	bsr	nextop
;	 bra	 All_OK
;LAB02EA	       moveq	   #9,d0
;      moveq	   #-1,d3    must be infinite timeout DCG
;      lea   extop,a2
;      trap	   #3		   QDOS TRAP #3 - D0=$09	 : SD.EXTOP
;      bra.s	   All_OK
;extop	       move.l	   $4c(a6),d0  SV_KEYQ
;      beq.s	   All_OK
;      movea.l	   d0,a2
;      lea   $68(a0),a1    Roughly the end of the channel block
;      move.w	   #$0150,d4
;LAB0306	       cmpa.l	   a0,a2
;      bls.s	   LAB030E
;      cmpa.l	   a1,a2
;      bls.s	   LAB0318
;LAB030E	       movea.l	   (a2),a2
;      cmp.l	   a2,d0
;      dbeq	   d4,LAB0306
;      bra.s	   All_OK
;LAB0318	       move.l	   a2,$4c(a6)  SV_KEYQ
All_OK	moveq	#0,d0
	rts
CursOff moveq	#$0f,d7
LAB0322 bsr	FtchChan
	bne.s	LAB0336
	cmpa.l	a3,a5
	bne	LAB0410
	move.l	d7,d0
LAB0330 moveq	#-1,d3
	trap	#3
	tst.l	d0
LAB0336 rts
Tk_Ver	bsr	LAB1050
	suba.l	d6,a1
	move.w	#4,0(a1,a6.l)
	move.l	VerMesg,2(a1,a6.l)
	bra.s	LAB0384
FloatStr	movea.w $0114,a2		CA.GTFP
	jsr	(a2)		VECTOR utility $114 : CA.GTFP
	bne.s	LAB0336
	moveq	#6,d5
	bra.s	LAB0372
StrngStr	bsr	Ftchstrs
	move.w	0(a1,a6.l),d5
	addq.w	#2,d5
	cmpi.w	#$7ffc,d5
	bls.s	LAB0372
LAB0368 moveq	#-4,d0		ERR.OR
	rts
*
* converts Long    to string representation of Internal format usage
* str=LONGINTEGER$(long) developed from    Mark Knight's code of same
* functionality
*
* DCG +  MK
*
LongStr bsr.s	Ftchlngs
	moveq	#4,d5
	bra.s	LAB0372
IntgrStr	bsr	Ftchints
	moveq	#2,d5
LAB0372 subq.w	#1,d3
	bne	LAB0410
	moveq	#2,d6
	bsr	Allocstk
	suba.l	d6,a1
	move.w	d5,0(a1,a6.l)
LAB0384 bra	Retstr
SetFont bsr	FtchChan
	bne.s	LAB0336
	bsr.s	Ftchlngs
	suba.l	a2,a2
	subq.w	#1,d3
	beq.s	LAB03A0
	subq.w	#1,d3
	bne.s	LAB0410
	movea.l 4(a1,a6.l),a2
LAB03A0 movea.l 0(a1,a6.l),a1
	moveq	#$25,d0
	bra	LAB0330
SetPosn bsr	FtchChan
	bne.s	Finished
	move.l	a0,d7
	bsr.s	Ftchlngs
	subq.w	#1,d3
	bne.s	LAB0410
	moveq	#-1,d3
	moveq	#$42,d0
	move.l	0(a1,a6.l),d1
	trap	#3		QDOS TRAP #3 - D0=$42 : FS.POSAB
LAB03C0 cmpi.w	#-$0a,d0
	beq.s	NoErrors
	cmpi.w	#-1,d0
	bne.s	Finished
NoErrors	moveq	#0,d0
Finished	rts
Ftchlngs	movea.w $0118,a2		CA.GTLIN
	jsr	(a2)		VECTOR utility $118 : CA.GTLIN
	bne	LAB0C22
	rts
Positn	bsr	FtchChan
	bne.s	Finished
	cmpa.l	a3,a5
	bne.s	LAB0410
	moveq	#$43,d0
	moveq	#0,d1
	moveq	#0,d3
	trap	#3		QDOS TRAP #3 - D0=$43 : FS.POSRE
	bsr.s	LAB03C0
	tst.l	d0
	bne.s	Finished
	move.l	d1,d5
	bra	LFPrtn
      IF	  SMSQ=0
LAB03FA bsr.s	Ftchlngs
	lsl.l	#2,d3
	beq.s	LAB0410
	add.l	d3,$58(a6)	BV.RIP
	move.l	0(a1,a6.l),-(a7)
	movem.l 4(a1,a6.l),d1-d7/a0-a5
	rts
      END_IF
sup_bad andi	#$d8ff,sr
LAB0410 moveq	#-$0f,d0		ERR.BP
	rts
EditInt bsr.s	LAB0476
LAB0416 tst.l	d0
	bne.s	LAB0454
	movea.w $0102,a2		CN.DTOI
	moveq	#3,d3
	bsr.s	LAB0434
	bra.s	LAB0416
EditFlt bsr.s	LAB0476
LAB0426 tst.l	d0
	bne.s	LAB0454
	movea.w $0100,a2		CN.DTOF
	moveq	#2,d3
	bsr.s	LAB0434
	bra.s	LAB0426
LAB0434 exg	d5,a0
	move.l	d7,-(a7)
	move.l	a0,d7
	ext.l	d1
	add.l	d1,d7
	jsr	(a2)
	exg	d5,a0
	move.w	d6,d1
	tst.l	d0
	bne.s	LAB0456
	cmp.l	d5,d7
	bne.s	LAB0456
	addq.l	#8,a7
	move.l	d3,d4
	move.l	a1,$58(a6)	BV.RIP
LAB0454 rts
LAB0456 move.l	d7,d5
	ext.l	d1
	sub.l	d1,d5
	move.l	(a7)+,d7
	bra	LAB0544
EditStrg	bsr.s	LAB0476
	tst.l	d0
	bne.s	LAB0454
	subq.l	#2,a1
	move.w	d1,d6
	movea.l (a6),a0
	lea	8(a6,a0.l),a0
	bra	LAB0F36
LAB0476 bsr	FtchChan
	bne.s	LAB0454
	move.l	a5,d7
	lea	8(a3),a5		SV.CHPFR
	move.l	a0,d5
	bsr	Ftchstrs
	cmp.l	a5,d7
	bne.s	LAB0492
	move.w	LAB1746(pc),d7
	bra.s	LAB04A6
LAB0492 movea.l a5,a3
	movea.l d7,a5
	bsr	Ftchints
	subq.w	#1,d3
	bne	LAB0410
	move.w	0(a1,a6.l),d7
	addq.l	#2,a1
LAB04A6 addq.w	#1,d7
	move.l	8(a6),d0		BV.TKBAS
	subq.l	#8,d0
	sub.l	(a6),d0
	cmp.w	d0,d7
	bcs.s	LAB04B8
	moveq	#-5,d0		ERR.BO
	rts
LAB04B8 move.w	0(a1,a6.l),d2
	trap	#0
	lea	2(a1,a6.l),a0
	movea.l (a6),a2
	addq.l	#8,a2
	movea.l a2,a1
	move.w	d2,d3
	beq.s	LAB04DC
	cmp.w	d7,d3
	bcc	sup_bad
	subq.w	#1,d3
LAB04D2 move.b	(a0)+,0(a6,a2.l)
	addq.l	#1,a2
	dbf	d3,LAB04D2
LAB04DC move.l	a0,d4
	sub.l	a6,d4
	andi	#$d8ff,sr
	addq.l	#1,d4
	bclr	#0,d4
	moveq	#-1,d3
	movea.l d5,a0
	move.l	a1,d5
	movea.l (a6),a1
	moveq	#$0b,d0
	trap	#4
	trap	#3		QDOS TRAP #3 - D0=$0B : SD.CHENQ
	tst.l	d0
	bne.s	LAB0568
LAB04F6 movea.l (a6),a1
	move.w	4(a6,a1.l),d1
	swap	d2
	move.w	6(a6,a1.l),d2
	moveq	#$10,d0
	trap	#3		QDOS TRAP #3 - D0=$10 : SD.POS
	swap	d2
	movea.l d5,a1
	moveq	#7,d0
	trap	#4
	trap	#3		QDOS TRAP #3 - D0=$07 : IO.SSTRG
	tst.l	d0
	bne.s	LAB0568
	moveq	#$20,d1
	moveq	#5,d0
	trap	#3		QDOS TRAP #3 - D0=$05 : IO.SBYTE
	moveq	#$13,d0
	trap	#3		QDOS TRAP #3 - D0=$13 : SD.PCOL
	move.w	d2,d1
	swap	d1
	move.w	d2,d1
	movea.l (a6),a1
	lea	8(a1,d1.w),a1
	move.w	d7,d2
	moveq	#4,d0
	trap	#4
	trap	#3		QDOS TRAP #3 - D0=$04 : IO.EDLIN
	tst.l	d0
	bpl.s	LAB056A
	cmpi.w	#-1,d0
	beq.s	LAB0560
	cmpi.w	#-5,d0
	bne.s	LAB0568
	subq.w	#1,d1
LAB0544 move.w	d1,d2
	moveq	#-1,d3
	move.b	cdea0,d1
	beq.s	LAB04F6
	move.l	d5,-(a7)
	move.l	d7,-(a7)
	lea	LAB16A6,a3
	moveq	#$11,d0
	trap	#1		QDOS TRAP #1 - D0=$11 : MT.IPCOM
	move.l	(a7)+,d7
	move.l	(a7)+,d5
	bra.s	LAB04F6
LAB0560 moveq	#$0f,d0
	bsr	LAB0330
	moveq	#-1,d0		ERR.NC
LAB0568 rts
LAB056A subq.w	#1,d1
	subq.l	#1,a1
	cmpi.b	#$0a,0(a6,a1.l)
	bne.s	LAB0544
	movea.l d4,a1
*      suba.l	   a6,a1
	move.w	d1,d6
	rts
LAB057E move.l	a5,d5
	lea	8(a3),a5		SV.CHPFR
	movea.w $0112,a2		CA.GTINT
	jsr	(a2)		VECTOR utility $112 : CA.GTINT
	bne	LAB0C22
	movea.l a5,a3
	movea.l d5,a5
	move.w	0(a1,a6.l),d0
	mulu	#$28,d0
	add.l	$30(a6),d0	BV.CHBAS
	cmp.l	$34(a6),d0	BV.CHP
	bge.s	LAB05AE
	movea.l d0,a2
	move.l	0(a6,a2.l),d5
	movea.l d5,a0
	rts
LAB05AE addq.l	#4,a7
LAB05B0 moveq	#-6,d0		ERR.NO
	rts

DefaultDv tst.b 0(a6,a3.l)
	bne.s	LAB05D2
	move.w	2(a6,a3.l),d0
	lsl.w	#3,d0
	movea.l $18(a6),a2	BV.NTBAS
	adda.w	d0,a2
	move.w	2(a6,a2.l),d0
	movea.l $20(a6),a4	BV.NLBAS
	adda.w	d0,a4
	bra.s	LAB05DA
LAB05D2 bsr	LAB1000
	movea.l a1,a4
	addq.l	#1,a4
LAB05DA moveq	#0,d7
	move.b	0(a4,a6.l),d7
	addq.l	#1,a4
	cmpi.b	#$20,d7
	bhi	ParamBad
	moveq	#0,d0
	trap	#1		QDOS TRAP #1 - D0=$00  : MT.INF
	movea.l $ac(a0),a2	SV.PRGD
	movea.l a2,a0
	move.w	d7,(a2)+
	beq.s	LAB0610
	subq.w	#1,d7
LAB05FA move.b	0(a4,a6.l),(a2)+
	addq.l	#1,a4
	dbf	d7,LAB05FA
	moveq	#$5f,d7
	cmp.b	-1(a4,a6.l),d7
	beq.s	LAB0610
	move.b	d7,(a2)+
	addq.w	#1,(a0)
LAB0610 moveq	#0,d0
	rts
* testing

LAB0614
	moveq	#1,d3		For OPEN_IN
Charge_2	movea.l (a6),a2	Charge has set D3.L = 2
	bsr	LAB071E
	cmpa.l	a3,a5
	beq	LAB0C22
	move.l	a5,d5
	lea	8(a3),a5
	tst.b	0(a6,a3.l)	Filemame from Name List? . .
	beq.s	LAB0640 . . yes
	movem.l a1/d3,-(a7)
	movea.w $0116,a2		CA.GTSTR
	jsr	(a2)		VECTOR utility $116 : CA.GTSTR
	lea	1(a1),a0
	movem.l (a7)+,a1/d3
	bne	LAB0C22
	bra.s	LAB0656
LAB0640 move.w	2(a6,a3.l),d0
	bmi	Charge_1		Not a real parameter - so *
	lsl.w	#3,d0
	movea.l $18(a6),a2	BV.NTBAS
	adda.w	d0,a2
	move.w	2(a6,a2.l),d0
	movea.l $20(a6),a0	BV.NLBAS
	adda.w	d0,a0
LAB0656 move.l	(a6),d2
	move.l	a0,-(a7)
	move.l	d5,-(a7)
	bsr.s	LAB06AA	Set filename to buffer
	movea.l a0,a2
	bsr	LAB06FA	Opens file or sets errcode (-12 -> -7)
LAB0656_1 move.l	(a7)+,d5
	moveq	#-7,d2
	move.l	d0,d1
	bmi.s	LAB0672	Close file if open
	moveq	#2,d0
	trap	#2		QDOS TRAP #2 - D0=$  : IO.CLOSE
	cmpi.b	#2,d3		Charge? . .
	beq	Charge_4		. . yes (To delete the closed file)
LAB0672 cmp.l	d2,d1
	bne.s	LAB06CC	PROGD$ not needed (D2.L <> -12 or -7)
	move.l	(a6),d2
	movea.l (a7)+,a0
	bsr.s	LAB067E
	bra.s	LAB06D0
LAB067E movea.l a0,a3
	moveq	#0,d0
	trap	#1		QDOS TRAP #1 - D0=$00  : MT.INF
	movea.l $ac(a0),a2	SV.PRGD
	movea.l a3,a0
	move.w	(a2)+,d0
	beq.s	LAB06AA
	move.l	(a6),d2
	moveq	#0,d1
	move.b	0(a0,a6.l),d1
	add.w	d0,d1
	cmpi.w	#$3e,d1
	bhi.s	LAB06AA
	subq.w	#1,d0
LAB06A0 move.b	(a2)+,2(a6,d2.l)
	addq.l	#1,d2
	dbf	d0,LAB06A0
LAB06AA moveq	#0,d0
	move.b	0(a0,a6.l),d0
	subq.w	#1,d0
	bmi.s	LAB06C2
LAB06B4 move.b	1(a0,a6.l),2(a6,d2.l)
	addq.l	#1,a0
	addq.l	#1,d2
	dbf	d0,LAB06B4
LAB06C2 movea.l (a6),a0
	sub.l	a0,d2
	move.w	d2,0(a6,a0.l)
	rts
LAB06CC addq.l	#4,a7
	movea.l a2,a0
LAB06D0 movea.l a5,a3
	movea.l d5,a5
	rts
LAB06D6 moveq	#1,d3
	bsr.s	LAB06FA
	bne.s	LAB0712
	movea.l (a6),a1
	moveq	#$0e,d2
	moveq	#-1,d3
	moveq	#$47,d0
	trap	#4
	trap	#3		QDOS TRAP #3 - D0=$47 : FS.HEADR
	movea.l d5,a1
	tst.l	d0
	bne.s	LAB0712
	movea.l (a6),a2
	move.b	5(a6,a2.l),d1
	subq.b	#1,d1
	rts
LAB06F8 moveq	#2,d3
LAB06FA move.l	a1,d5
	moveq	#-1,d1
	move.l	a0,d0
	bclr	#0,d0		clear the "don't want TRAP #4" bit
	movea.l d0,a0		replace the spruced up A0
	bne	LAB06FA_2 no TRAP #4 needed
	trap	#4
LAB06FA_2
*      movea.l	   d0,a0
*
* NOTE: The above instruction has been moved earlier because it allows
*	CHARGE to work with a JS ROM and no Pointer - only TK2 and
*	Turbo TK loaded. In its original position the open throws up
*	an error. I've no idea why. And it does not happen on a Q40
*	with SMSQ/E.	7th December 2001
*
	moveq	#io_open,d0
	trap	#2		QDOS TRAP #2 - D0=$01 : IO.OPEN
LAB06FA_1 movea.l	d5,a1
	cmpi.w	#-$0c,d0
	bne.s	LAB070E
	moveq	#-7,d0		ERR.NF
LAB070E tst.l	d0
	rts
*     testing
LAB0712 addq.l	#4,a7
	rts
ExecuteW	moveq	#-1,d7
	bra.s	ExeComm
ExecuteA	moveq	#1,d7
	bra.s	ExeComm
LAB071E move.b	1(a6,a3.l),d0
	bclr	#7,d0
	lsr.b	#4,d0
	move.b	d0,$7f(a6,a2.l)
	rts
Execute moveq	#0,d7
ExeComm movea.l (a6),a2
	move.b	d7,$45(a6,a2.l)
	moveq	#-1,d7
	move.l	d7,$56(a6,a2.l)
	cmpa.l	a3,a5
	bne.s	LAB0762
	bsr	LAB00B2
	move.w	(a0)+,d0
	addq.w	#1,d0
	bne	ParamBad
	addq.l	#8,a0
	move.w	(a0)+,d0
	addq.w	#1,d0
	bclr	#0,d0
	adda.w	d0,a0
	addq.l	#1,a0		make A0 odd for "no TRAP #4"
*      suba.l	   a6,a0
	clr.b	$7f(a6,a2.l)
	bra	LAB07F0
LAB0762 bsr.s	LAB079A
	move.l	d0,d7
	beq.s	LAB0776
	movea.l (a6),a2
	move.l	$56(a6,a2.l),d1
	bmi.s	LAB0776
	bsr	LAB095E
	move.l	d7,d0
LAB0776 rts
Connect lea	$10(a3),a4	SV.BASIC
	cmpa.l	a4,a5
	bne	ParamBad
	bsr	LAB057E
	move.l	a0,d3
	bmi	ParamBad
	lea	LAB1754,a0
	addq.l	#1,a0		make A0 odd
*      suba.l	   a6,a0
	bsr	LAB06FA
	bne.s	LAB0776
	bra.s	LAB07D4
LAB079A tst.b	1(a6,a3.l)
	bpl.s	LAB07EC
	bsr	LAB057E
	moveq	#2,d0
	trap	#2		QDOS TRAP #2 - D0=$02 : IO.CLOSE
	lea	LAB1748,a0
	addq.l	#1,a0		make A0 odd
*     suba.l	  a6,a0
	bsr	LAB06F8
	bne.s	LAB0776
	move.l	a0,0(a6,a2.l)
	move.l	a0,d3
	lea	LAB1754,a0
	addq.l	#1,a0		make A0 odd
*     suba.l	  a6,a0
	bsr	LAB06FA
	bne.s	LAB07EA
	tst.b	1(a3,a6.l)
	bpl.s	LAB080A
	lea	8(a3),a2
	cmpa.l	a2,a5
	bne.s	LAB080A
LAB07D4 move.l	a0,d7
	bsr	LAB057E
	moveq	#2,d0
	trap	#2		QDOS TRAP #2 - D0=$02 : IO.CLOSE
	move.l	d7,0(a6,a2.l)
	move.w	#$50,$22(a6,a2.l)
	moveq	#0,d0
LAB07EA rts
LAB07EC bsr	LAB0614
LAB07F0 bsr	LAB06D6
	bne.s	LAB080A
	movea.l (a6),a2
	st	$46(a6,a2.l)
	bra.s	LAB0870
LAB07FE movea.l d5,a0
	move.l	d0,d5
	moveq	#2,d0
	trap	#2		QDOS TRAP #2 - D0=$02 : IO.CLOSE
	move.l	d5,d0
	rts
LAB080A movea.l (a6),a2
	move.l	a0,$46(a6,a2.l)
	bsr	LAB0614
LAB0814 bsr	LAB06D6
	bne	ParamBad
	bra.s	LAB0870
LAB081E movea.l (a6),a2
	move.l	$56(a6,a2.l),d1
	move.l	6(a6,a2.l),d3
	move.l	0(a6,a2.l),d2
	move.l	a0,d5
	move.l	a1,d4
	suba.l	a1,a1
	moveq	#1,d0
	trap	#1		QDOS TRAP #1 - D0=$01 : MT.CJOB
	movea.l a0,a1
	tst.l	d0
	bne.s	LAB086C
	move.l	a0,$40(a6,a2.l)
	tst.b	$56(a6,a2.l)
	bpl.s	LAB084A
	move.l	d1,$56(a6,a2.l)
LAB084A move.l	d1,$52(a6,a2.l)
	adda.l	d2,a0
	adda.l	d3,a0
	clr.w	-(a0)
	move.l	a0,$4e(a6,a2.l)
	movea.l d5,a0
	moveq	#-1,d3
	moveq	#$48,d0
	trap	#3		QDOS TRAP #3 - D0=$48 : FS.LOAD
	tst.l	d0
	bne.s	LAB086C
	moveq	#2,d0
	trap	#2		QDOS TRAP #2 - D0=$02 : IO.CLOSE
	movea.l d4,a1
	rts
LAB086C addq.l	#4,a7
	bra.s	LAB07FE
LAB0870 bsr.s	LAB081E
	moveq	#$20,d0
LAB0874 move.b	d0,$44(a6,a2.l)
LAB0878 move.b	$7f(a6,a2.l),d0
	subq.b	#2,d0
	bne.s	LAB08BC
	bsr	LAB071E
	move.l	a5,d5
	lea	8(a3),a5
	bsr	Ftchstrs
	movea.l a5,a3
	movea.l d5,a5
	movea.l (a6),a2
	movea.l $4e(a6,a2.l),a0
	move.w	0(a1,a6.l),d0
	addq.w	#1,d0
	bclr	#0,d0
	ext.l	d0
	suba.l	d0,a0
	move.l	a0,$4e(a6,a2.l)
	lsr.w	#1,d0
LAB08AC move.w	0(a1,a6.l),(a0)+
	addq.l	#2,a1
	dbf	d0,LAB08AC
	move.l	a1,$58(a6)	BV.RIP
	bra.s	LAB0878
LAB08BC subq.b	#2,d0
	bne.s	LAB08E2
	bsr	LAB071E
	move.l	a5,d5
	lea	8(a3),a5
	bsr	Ftchints
	movea.l a5,a3
	movea.l d5,a5
	move.w	0(a1,a6.l),d0
	movea.l (a6),a2
	bra.s	LAB0874
LAB08E2 suba.l	a0,a0
	subq.l	#1,a0
	cmpa.l	a3,a5
	beq.s	LAB093C
	tst.b	1(a6,a3.l)
	bpl.s	LAB08FA
	bsr	LAB057E
	bmi	LAB05B0
	bra.s	LAB0936
LAB08FA bsr	LAB0614
	move.l	a0,d7
	bsr	LAB06F8
	bpl.s	LAB0936
	lea	LAB1748,a0
	addq.l	#1,a0		make A0 odd
*      suba.l	   a6,a0
	bsr	LAB06F8
	bne	LAB0776
	move.l	a0,d5
	bsr.s	LAB0982
	move.l	d5,d3
	lea	LAB1754,a0
	addq.l	#1,a0		make A0 odd
*      suba.l	   a6,a0
	bsr	LAB06FA
	bne	LAB0776
	movea.l (a6),a2
	move.l	a0,$46(a6,a2.l)
	movea.l d7,a0
	bra	LAB0814
LAB0936 cmpa.l	a3,a5
	bne	ParamBad
LAB093C bsr.s	LAB0982
LAB0940 movea.l (a6),a2
	move.b	$45(a6,a2.l),d7
	beq.s	LAB09AE
LAB0948 move.l	$56(a2,a6.l),d1
	tst.b	d7
	bmi.s	LAB0968
	moveq	#0,d0
	trap	#1		QDOS TRAP #1 - D0=$00 : MT.INF

	move.w	LAB1744,d0	either FFch or 00ch   Altered - May 2013
	bpl	LAB0965				"
	rol.w	#8,d0		set to chFF		"

LAB0965 cmp.w	$8a(a0),d0	SV.ARBUF
	bne.s	LAB0968
LAB095E moveq	#5,d0
	moveq	#-1,d3
	trap	#1		QDOS TRAP #1 - D0=$05 : MT.FRJOB
LAB0964 moveq	#-1,d0		ERR.NC
	rts
LAB0968 move.l	$56(a2,a6.l),d1
	moveq	#2,d0
	moveq	#0,d2
	trap	#1		QDOS TRAP #1 - D0=$02 : MT.JINF
	tst.l	d0
	bne.s	LAB09AE
	suba.l	a1,a1
	moveq	#$0a,d3
	moveq	#-1,d1
	moveq	#8,d0
	trap	#1		QDOS TRAP #1 - D0=$08 : MT.SUSJB
	bra.s	LAB0948
*
* Execute Family of functions
* Following code enables c68 compiled programs
* to be at least executed with a simple call of
* execute c68compiledprogram;' command string '
* previously if no channels were passed
* the code set it up as if two channels had been passed
* and the c68 compiled programs misbehaved.
* Now if No channels are passed this is indicated
* if one channel is passed The old code ie indicating
* that two channels have been passed is used
* this is for backward compatibility and should
* hopefully have no adverse effects on c68 compiled programs
* and others ie qliberated programs in pipelines
* possible problems will occur at the ends of the pipelines
* but I myself would use Toolkit II's exec family if it seems
* more appropriate but even those have their limitations and
* differences. May be some one could improve on my slight bodges
* and write a new set of extensions which could replace / supplement
* the execute exetentsions or the Toolkit II extensions
* Maybe someone already has. DCG.
* Meantime this bodge is better than nothing.
* It checks for illegal qdos channels by testing top bit of D0
* and if A0 is equal to -1.
* I myself suggest no further changes in the toolkit in this area
* other than code tuning.
* I also suggest that no further changes be made in the Turbo runtime in this
* area other than code tuning.
* Reasons Backward compatibility with older Turbo compiled software.
* DCG
*
LAB0982 movea.l (a6),a2
	move.l	a3,d1
	movea.l $4e(a6,a2.l),a3
	move.l	$46(a6,a2.l),d0
	bge.s	oldcode_push	DCG A Bit of code tuning done in 3i27
*     btst	  #31,d0		does d0 contain valid channel
*     beq.s	  oldcode_push		     if so oldcode
	cmp.l	#-1,a0		does a0 contain valid channel
	bne.s	oldcode_push	if so oldcode
	clr.w	-(a3)		3.29 replacement for following code line
;     move.w	  #0,-(a3)		no channels passed indicated
	bra.s	oldend_push
oldcode_push
	move.l	d0,-(a3)
	move.l	a0,-(a3)
	move.w	#2,-(a3)
oldend_push
	movea.l $40(a6,a2.l),a0
	move.l	a3,-$0c(a0)
	movea.l d1,a3
	move.l	$52(a6,a2.l),d1
	move.b	$44(a6,a2.l),d2
	moveq	#0,d3
	moveq	#$0a,d0
	trap	#1		QDOS TRAP #1 - D0=$0A : MT.ACTIV
LAB09AE moveq	#0,d0
LAB09B0 rts
BasicByt	moveq	#0,d5
	bra.s	LAB09C0
BasicWrd	moveq	#1,d5
	bra.s	LAB09C0
BasicLng	moveq	#-1,d5
	bra.s	LAB09C0
BasicPtr	moveq	#-2,d5
LAB09C0 bsr	Ftchlngs
	subq.w	#1,d3
	bne	ParamBad
	move.l	0(a1,a6.l),d3
	addq.l	#4,a1
	move.l	a1,$58(a6)	BV.RIP
	bsr	LAB0A52
	trap	#0		TRAP #0 : Enter supervisor mode
	ori.w	#$0700,sr set 210
	tst.l	d5
	beq.s	LAB09EA
	btst	#0,d3
	bne	LAB09F8
	tst.l	d5
	bmi.s	LAB0A12
LAB09EA subq.l	#2,a1
	beq.s	LAB0A00
	move.w	0(a0,d3.l),0(a1,a6.l)
	bra.s	LAB0A0A
LAB09F6 addq.l	#4,a7
LAB09F8 moveq	#-$0f,d0		ERR.BP
LAB09FA andi.w	#-$2701,sr	clear S210
	rts
LAB0A00 clr.b	0(a1,a6.l)
	move.b	0(a0,d3.l),1(a1,a6.l)
LAB0A0A andi.w	#-$2701,sr	clear S210
	bra	LAB10AE
LAB0A12 move.l	0(a0,d3.l),d0
	addq.l	#1,d5
	bmi.s	LAB0A1C
	suba.l	a0,a0
LAB0A1C lea	0(a0,d0.l),a0
BA2	andi.w	#-$2701,sr	clear S210
	move.l	a0,d5
	bra	LFPrtn
BasicAdr	moveq	#1,d5		Mark Address
	bra	BN1
BA1	move.b	(a2,d3.w),d0
	suba.l	a0,a0		Provisional zero answer
	subq.b	#8,d0
	beq	BA3		OK
	subq.b	#1,d0
	bne	BA2		Return zero - not machine code fn/proc
BA3	movea.l 4(a2,d3.w),a0	Address of routine
	bra	BA2
BasicNam	moveq	#0,d5		Mark Name
BN1	bsr	Ftchints
	subq.w	#1,d3
	bne	ParamBad
	move.w	0(a1,a6.l),d3
	trap	#0		TRAP #0 : Enter supervisor mode
	ori.w	#$0700,sr set 210
	bsr.s	LAB0A60
	subq.l	#1,d5
	beq	BA1
	bsr.s	LAB0A78
	move.b	(a0)+,d6
	bpl.s	LAB0A48
	moveq	#0,d6
LAB0A48 andi.w	#-$2701,sr	clear S210
	ext.w	d6
	bra	LAB0F36
LAB0A52 moveq	#0,d0
	trap	#1		QDOS TRAP #1 - D0=$00 : MT.INF
*
* The following 2 instructions are altered in SMSQ/E when this
* is LREPSRd from master basic. The changed code takes the base
* of variables as $1E8 from the start of Job 0's address.
* The change suggested below takes the base as A6 as stored in
* Job 0's header. Both give the same address but you certainly
* can't rely on $1E8 being the same from one SMSQ/E version to
* another.
*
*      movea.l	   $10(a0),a0	   SV.BASIC
*      lea   $68(a0),a0
	movea.l sv_jbbas(a0),a0 Job List
	movea.l (a0),a0	Address of Job 0
	movea.l jb_a6(a0),a0	Job 0's A6
	rts
LAB0A60 bsr.s	LAB0A52	A0 -> basic variables
	movea.l $18(a0),a2	BV_NTBAS (corrected meaning)
	adda.l	a0,a2
	lsl.w	#3,d3
	lea	0(a2,d3.w),a3
	suba.l	a0,a3
	cmpa.l	$1c(a0),a3	BV_NTP (corrected meaning)
	bpl	LAB09F6	** changes Jan 02 need longer jump **
	rts
LAB0A78 movea.l $20(a0),a3	BV_NLBAS (corrected meaning)
	adda.l	a0,a3
	move.w	2(a2,d3.w),d3
	lea	0(a3,d3.w),a0
	rts
BasicIdx	bsr	LAB1000
	trap	#0		TRAP #0 : Enter supervisor mode
	bsr.s	LAB0A9A
	move.w	d1,0(a1,a6.l)
	bra	LAB0A0A
LAB0A98 suba.l	a6,a1
LAB0A9A ori.w	#$0700,sr set210 (leave supervisor mode).
	lea	2(a1,a6.l),a5
	bsr.s	LAB0A52
	move.b	(a5)+,d1
	movea.l $20(a0),a3
	adda.l	a0,a3
	movea.l $24(a0),a4
	adda.l	a0,a4
	move.b	(a4),d7
	clr.b	(a4)
	move.w	0(a1,a6.l),d0
	beq.s	LAB0ADA
	lea	1(a1,d0.w),a1
	move.l	a1,d4
	bclr	#0,d4
	movea.l d4,a1
	move.w	d0,d4
	subq.w	#2,d4
	move.b	(a3)+,d3
LAB0ACE ext.w	d3
	cmp.b	d0,d3
	beq.s	LAB0ADE
LAB0AD4 adda.w	d3,a3
	move.b	(a3)+,d3
	bne.s	LAB0ACE
LAB0ADA moveq	#-$0c,d1
	bra.s	LAB0B28
LAB0ADE cmp.b	(a3),d1
	bne.s	LAB0AD4
	lea	1(a3),a2
	movea.l a5,a0
	move.w	d4,d5
	bmi.s	LAB0AF6
LAB0AEC cmpm.b	(a0)+,(a2)+
	dbne	d5,LAB0AEC
	bne	LAB0AD4
LAB0AF6 bsr	LAB0A52
	movea.l a0,a2
	suba.l	a2,a3
	suba.l	$20(a2),a3
	move.w	a3,d4
	subq.w	#1,d4
	movea.l $18(a2),a0
	move.l	$1c(a2),d1
	sub.l	a0,d1
	asr.l	#3,d1
	move.w	d1,d5
	lea	2(a2,a0.l),a0
LAB0B18 cmp.w	(a0),d4
	addq.l	#8,a0
	dbeq	d5,LAB0B18
	beq.s	LAB0B26
	moveq	#-7,d1
	bra.s	LAB0B28
LAB0B26 sub.w	d5,d1
LAB0B28 move.b	d7,(a4)
	move.w	d1,d0
	ext.l	d0
	rts
BasicTyp	bsr	Ftchints
	subq.w	#1,d3
	bne	ParamBad
	move.w	0(a1,a6.l),d3
	trap	#0		TRAP #0 : Enter supervisor mode
	ori.w	#$0700,sr set 210
	bsr	LAB0A60
	move.b	1(a2,d3.w),d0
	andi.b	#7,d0
	beq.s	LAB0B62
	cmpi.b	#3,d0
	bne.s	LAB0B5A
	addq.b	#1,d0
LAB0B5A move.w	d0,0(a1,a6.l)
	bra	LAB0A0A
LAB0B62 bsr	LAB0A78
	move.b	(a0),d0
	ext.w	d0
	add.w	d0,d3
	move.b	0(a3,d3.w),d1
	cmpi.b	#$25,d1
	bne.s	LAB0B7A
	moveq	#4,d0
	bra.s	LAB0B5A
LAB0B7A moveq	#1,d0
	cmpi.b	#$24,d1
	beq.s	LAB0B5A
	addq.w	#1,d0
	bra.s	LAB0B5A
      if REMLIB=0
Snooze	moveq	#-1,d3
LAB0B88 moveq	#-1,d1
	bra.s	LAB0BAA
      END_IF
SuspTask	bsr.s	Ftchints
	subq.w	#1,d3
	bne.s	LAB0B98
	moveq	#-1,d1
	bra.s	LAB0BA6
LAB0B98 subq.w	#2,d3
	bne	ParamBad
	move.l	0(a1,a6.l),d1
	swap	d1
	addq.l	#4,a1
LAB0BA6 move.w	0(a1,a6.l),d3
LAB0BAA suba.l	a1,a1
	moveq	#8,d0
	bra.s	LAB0BF0
SetPrior	bsr.s	Ftchints
	subq.w	#1,d3
	bne.s	LAB0BBA
	moveq	#-1,d1
	bra.s	LAB0BC6
LAB0BBA subq.w	#2,d3
	bne.s	ParamBad
	move.l	0(a1,a6.l),d1
	swap	d1
	addq.l	#4,a1
LAB0BC6 move.w	0(a1,a6.l),d2
LAB0BD6 moveq	#$0b,d0
	bra.s	LAB0BF0
RelsTask	moveq	#9,d7
	bra.s	LAB0BE0
RemvTask	moveq	#5,d7
LAB0BE0 bsr.s	Ftchints
	subq.w	#2,d3
	bne.s	ParamBad
	move.l	0(a1,a6.l),d1
	swap	d1
	moveq	#-1,d3
	move.l	d7,d0
LAB0BF0 trap	#1
	rts
LAB0BF4 lea	-$10(a5),a5
	cmpa.l	a3,a5
	bne.s	LAB0C22
	addq.l	#8,a5
	bsr	Ftchlngs
	addq.l	#8,a3
	addq.l	#8,a5
	rts
Ftchstrs	movea.w $0116,a2		CA.GTSTR
	bra.s	LAB0C12
Ftchints	move.w	$0112,a2		CA.GTINT
LAB0C12 moveq	#$0f,d6
	and.b	-7(a6,a5.l),d6
	jsr	(a2)		VECTOR utility $112 : CA.GTINT
	move.b	d6,-7(a6,a5.l)
	tst.l	d0
	beq.s	LAB0C28
LAB0C22 addq.l	#4,a7
ParamBad	moveq	#-$0f,d0		ERR.BP
LAB0C28 rts
LinkLdWt	moveq	#-1,d7
	bra.s	LinkComm
LinkLdAb	moveq	#1,d7
	bra.s	LinkComm
LinkLoad	moveq	#0,d7
LinkComm	movea.l (a6),a2
	move.l	a1,$4a(a6,a2.l)
	move.b	d7,$45(a6,a2.l)
	moveq	#-1,d7
	move.l	d7,$56(a6,a2.l)
	bsr	LAB0E32
	bne	LAB0EFC
	movea.l $40(a6,a2.l),a0
	move.l	a0,$46(a6,a2.l)
	move.l	d0,$34(a0)
	move.l	a0,$5e(a6,a2.l)
	move.w	d0,$5a(a6,a2.l)
LAB0C60 cmpa.l	a3,a5
	ble.s	LAB0C72
	bsr	LAB0E32
	bne	LAB0EFC
	bsr	LAB0E7A
	bra.s	LAB0C60
LAB0C72 move.l	$46(a6,a2.l),d7
	beq.s	LAB0C9A
LAB0C78 movea.l d7,a0
	move.w	$32(a0),d0
	cmpi.w	#-1,d0
	bne.s	LAB0C8A
	bsr	LAB0E90
	bra.s	LAB0C78
LAB0C8A cmp.w	$5a(a6,a2.l),d0
	blt.s	LAB0C94
	move.w	d0,$5a(a6,a2.l)
LAB0C94 move.l	$34(a0),d7
	bne.s	LAB0C78
LAB0C9A moveq	#0,d1
	move.w	$5a(a6,a2.l),d1
	move.l	d1,d7
	lsl.l	#2,d1
	addq.l	#4,d1
	move.l	$56(a6,a2.l),d2
	moveq	#$18,d0
	trap	#1		QDOS TRAP #1 - D0=$18 : MT.ALCHP
	tst.l	d0
	bne	LAB0EFC
	movea.l a0,a1
LAB0CB6 move.l	d0,(a1)+
	dbf	d7,LAB0CB6
	movea.l (a6),a2
	move.w	$5a(a6,a2.l),d7
	lsl.w	#2,d7
	move.w	d7,2(a0)
	move.l	$46(a6,a2.l),d7
	beq.s	LAB0CF0
LAB0CCE movea.l d7,a1
	move.w	$32(a1),d0
	beq.s	LAB0CEA
	lsl.l	#2,d0
	move.l	0(a0,d0.w),d1
	bne	LAB0F14
	move.l	a1,0(a0,d0.w)
	move.l	$56(a6,a2.l),$38(a1)
LAB0CEA move.l	$34(a1),d7
	bne.s	LAB0CCE
LAB0CF0 move.l	$46(a6,a2.l),d6
LAB0CF4 beq	LAB0E2A
	movea.l d6,a1
	move.w	$32(a1),d7
	move.l	a1,$46(a6,a2.l)
LAB0D02 move.b	$3c(a1),d0
	bne.s	LAB0D16
	movem.l a0-a1,-(a7)
	bsr	LAB0E90
	movem.l (a7)+,a0-a1
	bra.s	LAB0D02
LAB0D16 movea.l $2e(a1),a1
LAB0D1A move.w	(a1)+,d0
	cmpi.w	#-1,d0
	bne.s	LAB0D36
	movea.l $46(a6,a2.l),a3
	move.l	$34(a3),d6
	move.l	a0,$34(a3)
	move.b	d0,$3d(a3)
	tst.l	d6
	bra.s	LAB0CF4
LAB0D36 cmp.w	d7,d0
	beq	LAB0DC0
	move.l	a1,$62(a6,a2.l)
	lsl.w	#2,d0
	cmp.w	2(a0),d0
	bgt	LAB0F18
	move.l	0(a0,d0.w),d1
	beq	LAB0F18
	movea.l d1,a3
	move.l	a3,$4e(a6,a2.l)
	movem.l d0/a0-a1,-(a7)
LAB0D5C move.b	$3c(a3),d0
	bne.s	LAB0D68
	bsr	LAB0E90
	bra.s	LAB0D5C
LAB0D68 movem.l (a7)+,d0/a0-a1
	movea.l $2e(a3),a3
	lsr.w	#2,d0
LAB0D72 move.w	(a3)+,d1
	cmpi.w	#-1,d1
	beq	LAB0E98
	cmp.w	d1,d0
	beq.s	LAB0D8A
	exg	a3,a1
	bsr	LAB0E0E
	exg	a3,a1
	bra.s	LAB0D72
LAB0D8A movem.l d0/a1/a3,-(a7)
	move.b	(a1)+,d0
	cmp.b	(a3)+,d0
	bne.s	LAB0DAE
	bra.s	LAB0D9C
LAB0D96 move.b	(a1)+,d1
	cmp.b	(a3)+,d1
	bne.s	LAB0DAE
LAB0D9C dbf	d0,LAB0D96
	moveq	#0,d2
	movem.l (a7)+,d0/a1/a3
	bsr.s	LAB0E1A
	exg	a3,a1
	bsr.s	LAB0E1A
	bra.s	LAB0DB8
LAB0DAE movem.l (a7)+,d0/a1/a3
	moveq	#-1,d2
	exg	a3,a1
	bsr.s	LAB0E0E
LAB0DB8 exg	a3,a1
	tst.w	d2
	beq.s	LAB0DC8
	bra.s	LAB0D72
LAB0DC0 bsr.s	LAB0E0E
	bra	LAB0D1A
LAB0DC8 movem.l a0/a4,-(a7)
	moveq	#0,d1
LAB0DCE addq.l	#1,d1
	move.w	(a1)+,d2
	beq.s	LAB0DFC
	move.w	(a3)+,d3
	cmp.w	d2,d3
	bne	LAB0EA8
	move.l	#$7ff8,d2
	movea.w (a3)+,a4
	adda.l	d2,a4
	adda.l	$4e(a6,a2.l),a4
	movea.w (a1)+,a0
	btst	#6,d3
	bne.s	LAB0DCE
	adda.l	d2,a0
	adda.l	$46(a6,a2.l),a0
	move.l	(a4),(a0)
	bra.s	LAB0DCE
LAB0DFC btst	#6,1(a3)
	bne	LAB0EA8
	movem.l (a7)+,a0/a4
	bra	LAB0D1A
LAB0E0E bsr.s	LAB0E1A
	subq.l	#2,a1
LAB0E12 addq.l	#2,a1
	move.w	(a1)+,d1
	bne.s	LAB0E12
	rts
LAB0E1A moveq	#0,d1
	move.b	(a1)+,d1
	add.l	a1,d1
	addq.l	#1,d1
	bclr	#0,d1
	movea.l d1,a1
	rts
LAB0E2A movea.l $4a(a6,a2.l),a1
	bra	LAB0940
LAB0E32 bsr	LAB0614
	bsr	LAB06D6
	bne.s	BadParam
	bsr	LAB081E
	movea.l $4a(a6,a2.l),a1
	moveq	#$20,d2
	move.b	$7f(a6,a2.l),d0
	subq.b	#4,d0
	bne.s	LAB0E68
	move.l	a5,d5
	lea	8(a3),a5		SV.CHPFR
	bsr	Ftchints
	movea.l a5,a3
	movea.l d5,a5
	move.w	0(a1,a6.l),d2
	movea.l (a6),a2
LAB0E68 move.l	$52(a6,a2.l),d1
	moveq	#0,d3
	moveq	#$0a,d0
	trap	#1		QDOS TRAP #1 - D0=$0A : MT.ACTIV
	tst.l	d0
	beq.s	Exit
BadParam	moveq	#-$0f,d0		ERR.BP
Exit	rts
LAB0E7A movea.l $5e(a6,a2.l),a1
	movea.l $40(a6,a2.l),a0
	move.l	a0,$34(a1)
	move.l	d0,$34(a0)
	move.l	a0,$5e(a6,a2.l)
	rts
LAB0E90 moveq	#-1,d1
	moveq	#5,d3
	bra	LAB0BAA
LAB0E98 moveq	#1,d1
	bra.s	LAB0EAA
LAB0E9C moveq	#-1,d3
	moveq	#5,d0
	trap	#3		QDOS TRAP #3 - D0=$05 : IO.SBYTE
	rts
LAB0EA4 bra	DispBasic
LAB0EA8 addq.l	#8,a7
LAB0EAA movem.w d0-d1/d7,-(a7)
	suba.l	a0,a0
	lea	LAB16FE,a1
	bsr.s	LAB0EA4
	move.w	4(a7),d1
	movea.w $ce,a3		UT.MINT
	jsr	(a3)		VECTOR utility $0CE : UT.MINT
	lea	LAB1710,a1
	bsr.s	LAB0EA4
	move.w	(a7),d1
	movea.w $ce,a3		UT.MINT
	jsr	(a3)		VECTOR utility $0CE : UT.MINT
	lea	LAB1716,a1
	bsr.s	LAB0EA4
	movem.w (a7)+,d0-d1/d7
	movea.w $ce,a3		UT.MINT
	jsr	(a3)		VECTOR utility $0CE : UT.MINT
	movea.l (a6),a2
	movea.l $62(a6,a2.l),a3
	move.b	(a3)+,d4
	ble.s	LAB0EF6
	lea	LAB1722,a1
	bsr.s	LAB0EA4
LAB0EEE move.b	(a3)+,d1
	bsr.s	LAB0E9C
	subq.b	#1,d4
	bne.s	LAB0EEE
LAB0EF6 moveq	#$0a,d1
	bsr.s	LAB0E9C
	moveq	#0,d0
LAB0EFC move.l	d0,-(a7)
	movea.l (a6),a2
	move.l	$56(a6,a2.l),d1
	moveq	#0,d3
	moveq	#5,d0
	trap	#1		QDOS TRAP #1 - D0=$05 : MT.FRJOB
LAB0F0A movea.l (a6),a2
	movea.l $4a(a6,a2.l),a1
	move.l	(a7)+,d0
	rts
LAB0F14 moveq	#-8,d0		ERR.EX
	bra.s	LAB0EFC
LAB0F18 moveq	#-7,d0		ERR.NF
	bra.s	LAB0EFC
      IF	  REMLIB=0
      IF	  SMSQ=0
PeekStr bsr	LAB0BF4
	bsr	Ftchints
	move.w	0(a1,a6.l),d6
	cmpi.w	#$7ffc,d6
	bhi	LAB0368
	movea.l 2(a1,a6.l),a0
	addq.l	#4,a1
      END_IF
      END_IF
LAB0F36 ext.l	d6
	bsr	Allocstk
	suba.l	d6,a1
	btst	#0,d6
	beq.s	LAB0F46
	subq.l	#1,a1
LAB0F46 trap	#0		DCG make sure no	 movement while copying
	lea	0(a1,a6.l),a2
	move.w	d6,(a2)+
	subq.w	#1,d6
	bmi.s	UserMode
LAB0F50 move.b	(a0)+,(a2)+
	dbf	d6,LAB0F50
UserMode	andi.w	#-$2701,sr	clear S210 user mode
LAB0F56 bra	Retstr
      IF	  REMLIB =0
      IF	  SMSQ=0
PokeStr bsr	LAB0BF4
	move.l	0(a1,a6.l),d7
	bsr	Ftchstrs
	move.w	0(a1,a6.l),d6
	beq.s	LAB0F7A
	lea	2(a1,a6.l),a0
	movea.l d7,a2
	subq.w	#1,d6
LAB0F74 move.b	(a0)+,(a2)+
	dbf	d6,LAB0F74
LAB0F7A rts
      END_IF
      END_IF
EndCmd	move.l	$84(a6),d0	BV.COMCH
	beq.s	LAB0F88
	movea.l d0,a0
	moveq	#2,d0
	trap	#2		QDOS TRAP #2 - D0=$02 : IO.CLOSE
LAB0F88 rts
      IF	  REMLIB=0
OptnCmdStr
	moveq	#2,d6
	bsr	LAB1052
	subq.l	#2,a1
	clr.w	0(a1,a6.l)
	bra	Retstr
      END_IF
ChanId	bsr.s	FtchChan
	bne.s	LAB0F88
	cmpa.l	a3,a5
	bne	ParamBad
	move.l	a0,d5
	bra	LFPrtn
Set_Chan	bsr	Ftchlngs
	subq.w	#2,d3
	bne	ParamBad
	move.l	0(a1,a6.l),d1
	move.l	4(a1,a6.l),d2
	mulu	#$28,d1
	add.l	$30(a6),d1	BV.CHBAS
	cmp.l	$34(a6),d1	BV.CHP
	bge	LAB107C
	movea.l 0(a6,d1.l),a0
	move.l	d2,0(a6,d1.l)
	moveq	#2,d0
	trap	#2		QDOS TRAP #2 - D0=$02 : IO.CLOSE
	bra.s	LAB1040
FtchChan cmpa.l a5,a3
	beq.s	LAB0FE2
	tst.b	1(a3,a6.l)
	bmi.s	LAB0FE6
LAB0FE2 moveq	#1,d1
	bra.s	LAB102A
LAB0FE6 move.l	a5,d5
	lea	8(a3),a5		SV.CHPFR
	bsr	Ftchints
	movea.l a5,a3
	movea.l d5,a5
	bra.s	LAB1020
* LAB0FF6 bsr	Ftchstrs
*      rts
* LAB0FFC bra	LAB0C22
* please note checks removed after call to ftchstrs as ftchstrs like ftchints  does its own
* error traping and if there is any error it doesnt return. DCG
*
LAB1000
*      bsr.s	   LAB0FF6
	bsr	Ftchstrs
	subq.w	#1,d3
*      bne.s	   LAB0FFC
	bne	LAB0C22
	rts
* LAB0BPER	 addq.l  #4,a7
*	       moveq	 #-$0f,d0 ERR.BP
*	       rts

LAB100A
*     bsr.s	  LAB0FF6
	bsr	Ftchstrs
	subq.w	#1,d3
*     bne.s	  LAB0FFC
	bne	LAB0C22
	cmp.w	0(a1,a6.l),d7
*     bne.s	  LAB0FFC
	bne	LAB0C22
	addq.l	#2,a1
	rts
LAB101C subq.w	#1,d3
*      bne.s	   LAB0FFC
	bne	LAB0C22
LAB1020 move.w	0(a1,a6.l),d1
	addq.l	#2,a1
	move.l	a1,$58(a6)	BV.RIP
LAB102A mulu	#$28,d1
	add.l	$30(a6),d1	BV.CHBAS
	cmp.l	$34(a6),d1	BV.CHP
	bge.s	LAB107C
	move.l	0(a6,d1.l),d0
	bmi.s	LAB107C
	movea.l d0,a0
LAB1040 moveq	#0,d0
	rts
StrngFlt	moveq	#6,d7
	bsr.s	LAB100A
	bra.s	LAB10C4
StrngInt	moveq	#2,d7
	bsr.s	LAB100A
	bra.s	LAB10AE
LAB1050 moveq	#6,d6
LAB1052 movea.l $58(a6),a1	BV.RIP
      if REMLIB=0
Allocstk	bsr	Tstcmpld
	bne.s	LAB106E
	move.l	d6,d1
	move.l	a1,$58(a6)	BV.RIP
	movea.w $011a,a2		BV.CHRIX
	jsr	(a2)		VECTOR utility $11A : BV.CHRIX
	movea.l $58(a6),a1	BV.RIP
	rts
     else
Allocstk
     END_IF
LAB106E lea	-2(a1),a3
	suba.l	d6,a3
	cmpa.l	(a6),a3
	bpl.s	LAB1080
	moveq	#-3,d0		ERR.OM
	bra.s	LAB107E
LAB107C moveq	#-6,d0		ERR.NO
LAB107E addq.l	#4,a7
LAB1080 rts
* LAB1082 bra.s LAB101C
LAB1084 suba.l	d6,a1
	btst	#0,d6
	beq.s	LAB1090
	subq.l	#1,a1
LAB1090 moveq	#3,d0
	move.l	d6,d2
	moveq	#-1,d3
	trap	#4		make a1 relative
	trap	#3		QDOS TRAP #3 - D0=$03 : IO.FSTRG
	suba.l	d6,a1
	tst.l	d0
	rts
GetInt	bsr	Ftchints
*     bsr   LAB1082
	bsr	LAB101C
	moveq	#2,d6
	bsr.s	LAB1084
	bne.s	LAB10D0
LAB10AE moveq	#3,d4
	bra	StakDone
GetFloat	bsr	Ftchints
*      bsr     LAB1082
	bsr	LAB101C
	bsr	LAB1050
	bsr.s	LAB1084
	bne.s	LAB10D0
LAB10C4 cmpi.b	#$10,0(a1,a6.l)
	bmi	LAB117A
	moveq	#-$12,d0		ERR.OV
LAB10D0 rts
InputStr	bsr	Ftchints
	subq.w	#1,d3
	beq.s	LAB10DE
*     bsr.s	  LAB1082
	bsr	LAB101C
	bra.s	LAB10FC
LAB10DE moveq	#1,d1
	bsr	LAB102A
	bra.s	LAB10FC
DevSpace	bsr	Ftchints
	bsr	LAB101C
	bsr	LAB1372
	bne.s	LAB10D0
	bra.s	LFPrtn
GetStr	bsr.s	GetInt
	tst.l	d0
	bne.s	LAB10D0
LAB10FC move.w	0(a1,a6.l),d6
	bmi	ParamBad
	ext.l	d6
	beq.s	Retstr
	addq.l	#2,a1
	addq.l	#2,d6
	bsr	Allocstk
	subq.l	#2,d6
	bsr	LAB1084
	bne.s	LAB10D0
	subq.l	#2,a1
	move.w	d6,0(a1,a6.l)
Retstr	moveq	#1,d4
	bra.s	StakDone
      IF	 REMLIB=0
IsCompld	moveq	#1,d5
	bsr	Tstcmpld
	bne.s	LFPrtn
	subq.l	#1,d5
	bra.s	LFPrtn
      END_IF
Sys_Vars	moveq	#0,d0
	trap	#1		QDOS TRAP #1 - D0=$00 : MT.INF
	move.l	a0,d5
	bra.s	LFPrtn
*
* Following code is the legal way to find out
* how much Free memory is in the Machine
* It finds largest contiguous free  transient program area
* using the appropriate Trap call
* DCG
MYfreemem
*     movem.l	  d2-d3/a0-a3,-(sp)
	moveq	#6,d0
	trap	#1
*     movem.l	  (sp)+,d2-d3/a0-a3
	move.l	 d1,d5
	bra.s	 LFPrtn
FreeMem moveq	#0,d0
	trap	#1		QDOS TRAP #1 - D0=$00 : MT.INF
      IF	  REMLIB=0
	bsr	Tstcmpld
*     bne.s	  LAB1142
	beq.s	MYfreemem
*     bra.s	   LAB1142
*
*    following code commented out was the old way
*    but	later  SMSQ/E's changed the rules
*    relying on system variables is not always
*    forward compatible  DCG
*     move.l	  $10(a0),d5	  SV.BASIC
*     sub.l	  $0c(a0),d5	  ;SV.FREE
*     bra.s	  LFPrtn
      END_IF

LAB1142 lea	-$50(a1),a0
	suba.l	(a6),a0
	move.l	a0,d5
*
* Note the toolkit uses the routine which I have called   LFPrtn for all its
* returning of floating Point values D5 contains the long to convert.  LFPrtn
* does any needed stack tidying.
*
*  DCG
*
LFPrtn	bsr	LAB1050
LAB114E move.l	d5,d4
	beq.s	LAB1170
	move.w	#$081f,d4
	move.l	d5,d3
	add.l	d3,d3
	bvs.s	LAB1170
	subq.w	#1,d4
	move.l	d3,d5
	moveq	#$10,d2
LAB1162 move.l	d5,d3
	asl.l	d2,d3
	bvs.s	LAB116C
	move.l	d3,d5
	sub.w	d2,d4
LAB116C asr.l	#1,d2
	bne.s	LAB1162
LAB1170 subq.l	#6,a1
	move.l	d5,2(a1,a6.l)
LAB1176 move.w	d4,0(a1,a6.l)
LAB117A moveq	#2,d4
StakDone	move.l	a1,$58(a6)    BV.RIP
	moveq	#0,d0
	rts
BasicFlt	moveq	#-1,d5
	bra.s	LAB1192
PeekFlt moveq	#0,d5
LAB1192 bsr	Ftchlngs
	subq.w	#1,d3
LAB1198 bne	ParamBad
	move.l	0(a1,a6.l),d3
	btst	#0,d3
	bne.s	LAB1198
	tst.l	d5
	beq.s	LAB11BA
	trap	#0		TRAP #0 : Enter supervisor mode
	ori.w	#$0700,sr set 210
	bsr	LAB0A52
	add.l	a0,d3
	andi.w	#-$2701,sr	clear S210
LAB11BA movea.l d3,a0
	move.w	(a0)+,d4
	move.l	(a0),0(a1,a6.l)
	subq.l	#2,a1
	andi.w	#$0fff,d4
	bra.s	LAB1176
LAB11CA moveq	#-6,d0		ERR.NO
LAB11CC rts
ListTasks moveq #1,d7
	cmpa.l	a3,a5
	beq.s	LAB11E0
	movea.w $0112,a2		CA.GTINT
	jsr	(a2)		VECTOR utility $112 : CA.GTINT
	bne.s	LAB11CC
	move.w	0(a1,a6.l),d7
LAB11E0 mulu	#$28,d7
	add.l	$30(a6),d7	BV.CHBAS
	cmp.l	$34(a6),d7	BV.CHP
	bge.s	LAB11CA
	move.l	0(a6,d7.l),d0
	blt.s	LAB11CA
	movea.l d0,a0
	moveq	#0,d1
	move.l	a0,d7
LAB11FA move.l	d1,d6
	moveq	#0,d2
	moveq	#2,d0
	trap	#1		QDOS TRAP #1 - D0=$02 : MT.JINF
	tst.l	d0
	bne.s	LAB11CC
	move.l	d1,d4
	move.l	d3,d5
	tst.l	d6
	bne.s	LAB1214
	lea	LAB16EA,a0
	bra.s	LAB1220
LAB1214 addq.l	#6,a0
	cmpi.w	#$4afb,(a0)+
	beq.s	LAB1220
	lea	LAB16E0,a0
LAB1220 movea.l a0,a1
	movea.l d7,a0
	bsr.s	DispBasic
	bsr.s	LAB1250
	move.w	d6,d1
	bsr.s	LAB124E
	swap	d6
	move.w	d6,d1
	bsr.s	LAB124E
	move.b	d5,d1
	ext.w	d1
	bsr.s	LAB125A
	tst.l	d5
	bpl.s	LAB1242
	lea	LAB16FA,a1
	bra.s	LAB1246
LAB1242 lea	LAB16F6,a1
LAB1246 bsr.s	DispBasic
	move.l	d4,d1
	bne.s	LAB11FA
	rts
LAB124E bsr.s	LAB125A
LAB1250 lea	LAB16F2,a1
DispBasic movea.w	$d0,a2		UT.MTXT
	jmp	(a2)		VECTOR utility $0D0 : UT.MTXT
LAB125A movea.w $ce,a2		UT.MINT
	jmp	(a2)		VECTOR utility $0CE : UT.MINT
DevStatus move.l	$58(a6),d7	BV.RIP
	lea	8(a3),a4		* Only One parameter ?
	cmpa.l	a4,a5
	beq.s	LAB127C * YES
	exg	a5,a4
	bsr	Ftchints
	movea.l a5,a3
	movea.l a4,a5
	movea.w 0(a1,a6.l),a4
	cmpa.w	#3,a4		* code sugested by george gwilt
	bge	Parambad		* just for safties sake prevents overwriting file
	bra.s	LAB1280
LAB127C suba.l	a4,a4
	addq.l	#2,a4
LAB1280 bsr	LAB1000
	movea.l a1,a0
	move.l	a0,d6
	move.w	0(a0,a6.l),d4
	addq.w	#1,d4
	bclr	d3,d4
	ext.l	d4
	move.w	a4,d3
	bpl.s	LAB1298
	moveq	#1,d3
LAB1298 bsr.s	LAB12AA
	move.l	d0,d5
	move.w	a4,d1
	bmi	LAB12CA
	beq	LAB12B4
	subq.w	#2,d1
	bne.s	LAB12C0
	tst.l	d5
	bra	LAB1306
*************************************
* Changes here are to:
*    Check that when type 0 open is requested
*    we get type 0. If it turns out that IO_OPEN
*    has used type 1 we signal WRITE PROTECTED
************************************

;LAB12AA	 moveq	 #-1,d1
;	 moveq	 #1,d0
;	 trap	 #4
;	 trap	 #2		 QDOS TRAP #2 - D0=$01 : IO.OPEN
;	 rts
DS_REG	REG	D2/A1

LAB12AA MOVEM.L DS_REG,-(A7)
	MOVEA.L A0,A1		Keep the name pointer for OPEN
	MOVEQ	#MT_INF,D0
	TRAP	#1
	MOVEA.L SV_CHBAS(A0),A0 Keep channel pointer in . .
	EXG	A0,A1		. . A1

	moveq	#-1,d1		This JOB
	moveq	#io_open,d0
	trap	#4
	trap	#2		open the file

	TST.L	D0		Error? . .
	BNE	DS_NORM	. . yes, so act normally
	TST.W	D3		Did we want OPEN (type 0)? . .
	BNE	DS_NORM	. . no - so act normally
	MOVE.L	A0,D2		Find the channel block . .
	LSL.W	#2,D2
	MOVE.L	(A1,D2.W),D1	. . Address of channel block
	BMI	DS_NC		Hmmm! The channel has gone ---->
	MOVEA.L D1,A1		Check  . .
	SWAP	D2
	CMP.W	$10(A1),D2	. . Tag
	BNE	DS_NC		Hmmm! The channel has gone ---->
	CMP.B	$1C(A1),D3	Was access code 0 (as it should be)? . .
	BEQ	DS_NORM	. . yes - OK
	MOVEQ	#IO_CLOSE,D0	Close the channel . .
	TRAP	#2
	MOVEQ	#-20,D0	. . and mark WRITE PROTECTED
DS_NORM MOVEM.L (A7)+,DS_REG

	rts

DS_NC	MOVEQ	#-6,D0
	BRA	DS_NORM

LAB12B4 tst.l	d5
	bmi.s	LAB1320
	bsr	LAB1328
	move.l	d0,d5
	bmi	LAB12C4
	bne.s	LAB12E8
LAB12C0 bsr	LAB1372
LAB12C4 moveq	#2,d0
	trap	#2		QDOS TRAP #2 - D0=$02 : IO.CLOSE
	bra.s	LAB1320
LAB12CA tst.l	d5
	bmi.s	LAB12F8
	moveq	#2,d0
	trap	#2		QDOS TRAP #2 - D0=$02 : IO.CLOSE
	movea.l d6,a0
	moveq	#0,d3
	bsr	LAB12AA
	move.l	d0,d5
	bpl.s	LAB12E0
	moveq	#-$14,d5
	bra.s	LAB12F8
LAB12E0 bsr.s	LAB1328
	tst.l	d0
	beq.s	LAB12F0
	bmi.s	LAB12F2
LAB12E8 moveq	#-1,d1
	bsr	LAB1384
	bra.s	LAB12F4
LAB12F0 moveq	#-8,d0		ERR.EX
LAB12F2 move.l	d0,d5
LAB12F4 moveq	#2,d0
	trap	#2		QDOS TRAP #2 - D0=$02 : IO.CLOSE
LAB12F8 cmpi.w	#-7,d0
	bne.s	LAB1320
	movea.l d6,a0
	moveq	#2,d3
	bsr	LAB12AA
	move.l	d0,d5
LAB1306 bpl.s	LAB1310
	moveq	#-$0b,d0		ERR.DF
	cmp.l	d0,d5
	beq.s	LAB1316
	bra.s	LAB1320
LAB1310 bsr.s	LAB1372
	moveq	#2,d0
	trap	#2		QDOS TRAP #2 - D0=$02 : IO.CLOSE
LAB1316 movea.l d6,a0
	moveq	#4,d0
	moveq	#-1,d1
	trap	#4
	trap	#2		QDOS TRAP #2 - D0=$04 : IO.DELET
LAB1320 move.l	d7,$58(a6)	BV.RIP
	bra	LFPrtn
LAB1328 bsr.s	LAB136A
	beq.s	LAB135C
	moveq	#-$0f,d1
	cmp.l	d0,d1
	bne.s	LAB1334
LAB1332 moveq	#1,d0
LAB1334 moveq	#-$0a,d1
	cmp.l	d0,d1
	bne.s	LAB1382
	moveq	#2,d0
	trap	#2		QDOS TRAP #2 - D0=$02 : IO.CLOSE
	movea.l d6,a0
	moveq	#-1,d1		must have valid job ID in D1 for IO.DELET
*				or some Minervae fall over DCG
	moveq	#4,d0
	trap	#4
	trap	#2		QDOS TRAP #2 - D0=$04 : IO.DELET
	moveq	#-$0c,d1
	cmp.l	d1,d0
	beq.s	LAB1332
	tst.l	d0
	bne.s	LAB1382
	movea.l d6,a0
	moveq	#0,d0
	moveq	#2,d3
	bsr	LAB12AA
	bra.s	LAB138E
LAB135C moveq	#1,d0
	bsr.s	LAB136E
	move.b	d1,d2
	bsr.s	LAB136A
	move.b	d2,d1
	moveq	#5,d0
	bra.s	LAB136E
LAB136A moveq	#0,d1
	moveq	#$42,d0
LAB136E bra	LAB0330


LAB1372 bsr	findspace
	bne.s	OLDWAY
	rts
OLDWAY
	movea.l (a6),a1
	trap	#4
	moveq	#$45,d0
	bsr.s	LAB136E
	beq.s	LAB1384
	moveq	#-$0f,d1
	cmp.l	d1,d0
	beq.s	LAB1384
LAB1382 rts
LAB1384 swap	d1
	moveq	#0,d5
	move.w	d1,d5
	lsl.l	#8,d5
	add.l	d5,d5
LAB138E moveq	#0,d0
	rts
*
*     Find  free space on device
*     input channel in a0
*     output free space in d5
*     uses IOF.XINF
*     If errors uses original code
*     PS what is behaviour IOF.XINF on original THOR
*     hard disk drivers.
*     DCG
*
findspace
	movem.l d3-d4/a1,-(a7)
	move.l	(a6),a1 * use buffer
	moveq	#$4f,d0
	moveq	#-1,d3
	trap	#4
	trap	#3
	tst.l	d0
	bne.s	noxinf
	lea	$1e(a1),a1	* pointer to size of allocation blocks
	move.l	6(a6,a1.l),d4	* number of allocation units long
	move.w	0(a6,a1.l),d5	* size of allocation unit word
*
*
* Following might seem redundant but the definition of IOF.XINF
* structures implies you can have
* a long words worth of allocation units
* possibly implying a maximum harddrive partition of 2^47 bytes
* I am not considering fixing this possible bug
* as I think it would be difficult to fix
* without major changes to interface code
* and would be very unlikly to occur in practice
* I know I am being paranoid but
* reporting a size of 2^31-256 bytes
* in such cases  is my best effort.
* the code is not fool proof.
* Any improvemnts welcome.
* DCG
*
	move.w	d5,d3
	mulu	d4,d5
	blt.s	vlarge
	swap	d4
	tst.w	d4
	beq.s	xnormal * no need for fancy footwork	DCG
	mulu	d4,d3
	swap	d3
	tst.w	d3		* top word set	DCG
	bne.s	vlarge		* if so report very large space free
	clr.w	d3
	add.l	d3,d5
	bvs.s	vlarge
	bgt.s	xnormal
vlarge	move.l	#$7fffff00,d5	* large number of bytes
xnormal moveq	 #0,d0
noxinf
	movem.l (a7)+,d3-d4/a1
	rts
Not_found
	moveq	#-7,d0
	rts
     IF	REMLIB=0
Charge	moveq	#0,d0
	trap	#1		QDOS TRAP #1 - D0=$00 : MT.INF
	tst.l	d1
	beq.s	LAB139E
	moveq	#-2,d0		ERR.NJ
	rts
LAB139E movea.l (a6),a2
	lea	$6a(a2),a2
	clr.w	0(a2,a6.l)	Mark no parameter for PARSER
	lea	8(a3),a4
	cmpa.l	a4,a5
	bhi	ParamBad	---->
	bne.s	LAB13DA	No parameters
	moveq	#2,d3		Set d3 to OPEN_NEW
	bsr	Charge_2		Just after LAB0614
	move.w	(a0,a6.l),d2	Set length of file
	moveq	#$11,d1
	cmp.w	d1,d2
	bls.s	LAB13C4
	move.w	d1,d2
	move.w	d2,0(a0,a6.l)
LAB13C4 movea.l (a6),a2
	lea	$6a(a2),a2	Set parameter for PARSER
	addq.w	#1,d2
LAB13CC move.b	0(a0,a6.l),0(a2,a6.l)
	addq.l	#1,a0
	addq.l	#1,a2
	dbf	d2,LAB13CC
LAB13DA
*
* New - 5th December 2001
*
* This piece of code gets the channel IDs for PARSER_TASK and
* CODEGEN_TASK directly instead of relying on existing code to
* find these (by setting up "name table" entries in the Basic
* Buffer). Since PROGD$ has to be added, instead of trying to open
* PARSER_ and CODEGEN_TASK on their own, we add PROGD$ right from
* the start. When this has been done we jump into the middle of the
* Execute program at LAB07F0.
*
	moveq	#1,d7		For ExecuteA
	lea	LAB16B6,a3	"PARSER_TASK"
	bsr	Par_cod Sets a0 -> ID for PROGD$& prog

*

*	 moveq	 #mt_inf,d0
*	 trap	 #1
*	 movea.l	 #$ac(a0),a0	 PROGD$
*	 move.w  (a0)+,d0
*	beq	Not_found ---->
*	addq.l	#1,a0		-> 1 byte length
*	 move.l  (a6),d2		 pointer -> Basic Buffer
*	 bsr	 LAB06AA		 copy PROGD$ to Buffer
*	 lea	 LAB16B6,a0	 "PARSER_TASK"
*	 addq.l  #1,a0		 -> 1 byte length
*	 bsr	 LAB06AA		 copy "PARSER_TASK" to Buffer
*	 movea.l	 (a6),a0		 -> name
*	 movea.l	 a3,a5		 to allow errors to return to Basic
*	 moveq	 #0,d7
*	 move.b  d7,$45(a6,a0.l)
*	 moveq	 #-1,d7
*	 move.l  d7,$56(a6,a0.l)
*	 bsr	 LAB07F0		 go to the middle of ExecuteA
*      lea   LAB16B6,a0
*	 lea	 LAB16B6,a1
*	 bsr	 Str_Buf	 sets a1	 -> "PARSER_TASK" rel to	 a6
*      suba.l	   a6,a0
*      movea.l	   (a6),a2
*      lea   $5a(a2),a3
*      move.w	   #$0221,$5a(a2,a6.l)
*      move.w	   #$0101,$62(a2,a6.l)
*      lea   $6a(a2),a5
*      suba.l	   $28(a6),a0	   BV.VVBAS
*      move.l	   a0,$5e(a2,a6.l)

*      lea   $6a(a2),a1
*      bsr   ExecuteA
	tst.l	d0
	bne	LAB09B0
	bsr	LAB00B2
	movea.l a0,a2
	tst.w	(a2)
	bne	LAB09AE
	moveq	#0,d7
	lea	LAB16C4,a3	"CODEGEN_TASK"
	bsr	Par_cod
*      movea.l	   (a6),a2
*      lea   $5a(a2),a3
*      move.w	   #$0101,0(a3,a6.l)
*      lea   $62(a2),a5
*      lea   LAB16C4,a1
*      bsr Str_Buf0  sets a1		-> "CODEGEN_TASK" rel to a6
*      suba.l	   a6,a1
*      bsr   ExeComm
	lea	LAB16D2,a1	"CLEAR"
	trap	#0		TRAP #0 : Enter supervisor mode
	bsr	LAB0A98
	bmi	LAB09FA
	movea.l -6(a0),a2
	andi.w	#-$2701,sr	clear S210
	jmp	(a2)
*
* Par_cod was added in December 2001 to help render CHARGE A6 safe
*
* At entry A3 -> "PARSER_TASK" or "CODEGEN_TASK"
*	 D7 =  1		 or 0
*
Par_cod moveq	#mt_inf,d0
	trap	#1
	movea.l $AC(a0),a0
	move.w	(a0)+,d0
	movea.l a3,a5		Provisionally no pars
	beq	Par_code	---->	No PROGD$
	move.l	(a6),d2	Pointer to Buffer
	bsr	Str_Buf3		Put PROGD$ to Buffer . .
	add.l	a0,d2		d2 -> end of PROGD$ - 2
	lea	$6a(a0),a1	Set A1 for LAB0878
	movea.l a3,a0
	bsr	Str_Buf	. . and add PARSER.. or CODEGEN..
	tst.l	d7
	beq	Par_cod1		CODEGEN
	tst.w	$6A(a0,a6.l)	Is there a parameter? . .
	beq	Par_cod1		. . no
	lea	$62(a0),a3	Set up fake . .
	lea	$6A(a0),a5	. . parameter pointers
	move.b	#2,$7F(a0,a6.l) Force a parameter string for PARSER
	move.w	#$0101,$62(a0,a6.l) No separator & a string parameter
Par_cod1	move.b	d7,$45(a0,a6.l)
	moveq	#-1,d7
	move.l	d7,$56(a0,a6.l)
	bra	LAB07F0	Complete ExecuteA or Execute
*
Par_code	addq.l	#4,a7
	moveq	#-7,d0
	rts

*
: Following string	code by George Gwilt
;
; Sets the string @ A1 -> BasicBuffer + length of PROGD$
;
*Str_Buf0  moveq	 #mt_inf,d0
*	 trap	 #1
*	 movea.l	 $ac(a0),a0
*	 move.l  (a6),d2
*	 moveq	 #-1,d0
*Str_Buf6  move.w	 (a0)+,d0
*	 bra	 Str_Buf4
*Str_Buf5  move.b	 (a0)+,2(a6,d2.l)
*	 addq.l  #1,d2
*Str_Buf4  dbf	 d0,Str_Buf5
*	 movea.l	 a1,a0
*	 bclr	 #16,d0
*	 bne	 Str_Buf6
*	 movea.l	 (a6),a1
*	 sub.l	 a1,d2
*	 move.w  d2,(a1,a6.l)
*	 rts

;
; Sets the string @ A1 -> Basic Buffer : Leaves A1 -> string rel to A6
; Uses D0 & A2
;
*Str_Buf
*	 movea.l	 (a6),a2
*	 move.w  (a0)+,d0  string length
*	 move.w  d0,(a2,a6.l)
*	 addq.l  #2,a2
*	 bra	 Str_Buf1
*Str_Buf2  move.b	 (a1)+,(a2,a6.l)
*	 addq.l  #1,a2
*Str_Buf1  dbf	 d0,Str_Buf2
*	 movea.l	 (a6),a0
*	 rts
;
Str_Buf
	move.w	(a0)+,d0		length
Str_Buf3	subq.w	#1,d0
	bmi	Str_Buf1
Str_Buf2	move.b	(a0)+,2(a6,d2.l)
	addq.l	#1,d2
	dbf	d0,Str_Buf2
Str_Buf1	movea.l (a6),a0
	sub.l	a0,d2
	move.w	d2,(a0,a6.l)
	rts
	END_IF
Charge_1
	movea.l (a6),a0
	move.l	#$012A00,(a0,a6.l)	Set * as parameter string
	moveq	#1,d2		length
	rts
;
; Delete the file opened for CHARGE
;
Charge_4	movem.l d1/d2/a2,-(sp)
	movea.l a2,a0
	moveq	#-1,d1	    DCG to make sure d1 has a valid job id
;			    see reference to IOA.DELF in Jochen MERZ's manual
;			    being paranoid here
	moveq	#io_delet,d0
	trap	#4
	trap	#2
	movem.l (sp)+,d1/d2/a2
	bra	LAB0672
;
       IF SMSQ=1
GmdvInfo
GmdvSect
PmdvSect
notimp
	moveq	#-19,d0
	rts
	ELSE
chksmsq
	movem.l d0-d2/a0,-(a7)
	moveq	#0,d0
	trap	#1
	cmpi.b	#$1c,$a7(a0)
	beq.s	badchk
	cmpi.l	#$d2540000,(a0)
	bne.s	badchk
	moveq	#$1f,d1	  * New
	and.b	$a7(a0),d1    * New
	cmpi.b	#$1c,d1	  * New
	beq.s	badchk
	moveq	#0,d0
	bra.s	chexit
badchk	moveq	#1,d0
chexit	movem.l (a7)+,d0-d2/a0
	rts
notimp	moveq	#-19,d0
	rts

GmdvInfo
	bsr	chksmsq
	bne	notimp
	bsr	LAB15A2
	bne	LAB14FC
	trap	#0		TRAP #0 : Enter supervisor mode
	movem.l a1/a6,-(a7)
	bsr	LAB15D4
	movea.l a5,a1
	move.b	#0,2(a1)
	move.b	3(a1),d1
	tst.b	d1
	bne	LAB1540
	bsr	LAB1516
	cmpi.w	#-1,d0
	beq	LAB1502
;      movea.l	   a5,a1
;      adda.l	   #$14,a1
	lea	$14(a5),a1	  equivalent to previous two lines commented out
	movea.l a5,a2
	moveq	#$0c,d1
	clr.l	d2
LAB148C move.b	$24(a1,d2.l),4(a2,d2.l)
	addq.b	#1,d2
	subq.b	#1,d1
	bne.s	LAB148C
	movea.l a5,a1
	move.b	d7,3(a1)
	bra.s	LAB14D4
GmdvSect
	bsr	chksmsq
	bne	notimp
	bsr	LAB15A2
	bne.s	LAB14FC
	trap	#0		TRAP #0 : Enter supervisor mode
	movem.l a1/a6,-(a7)
	bsr	LAB15D4
	bsr.s	LAB150C
	cmpi.w	#-1,d0
	beq.s	LAB1502
	movea.l a5,a1
	addq.l	#4,a1
	movea.w $0124,a2		MD.READ
	jsr	$4000(a2)
	bra.s	LAB1502
LAB14D0 move.b	d2,(a1)+
	move.b	d1,(a1)
LAB14D4 moveq	#0,d0
	trap	#1		QDOS TRAP #1 - D0=$00 : MT.INF
	movea.l a0,a6
	movea.l #$00018020,a3
	bsr	LAB1620
	moveq	#-$19,d0
	and.b	$a0(a6),d0	SV.TMODE
	move.b	d0,-$1e(a3)
	move.b	d0,$a0(a6)	SV.TMODE
	movem.l (a7)+,a1/a6
	andi.w	#$C0FF,sr Changed by DCG -  thanks to Mark Swift.
	moveq	#0,d0
LAB14FC rts
LAB14FE movem.w (a7)+,d0-d1
LAB1502 move.b	#$ff,2(a5)
	bra	LAB14D4
LAB150C move.b	#0,2(a5)
	move.b	3(a5),d1
LAB1516 move.w	#$03e8,d0
LAB151A movem.w d0-d1,-(a7)
;      movea.l	   a5,a1
;      adda.l	   #$14,a1
	lea	$14(a5),a1	 equivalent to previous two lines commented out

LAB1526 movea.w $012a,a2		MD.SECTR
	jsr	$4000(a2)
	bra.s	LAB14FE
* LAB1532 bra.s LAB1526
LAB1534 movem.w (a7)+,d0-d1
	cmp.b	d1,d7
	dbeq	d0,LAB151A
	rts
LAB1540 lea	$14(a5),a1	   equivalent to following two lines commented out
;	       movea.l	   a5,a1
;	       adda.l	   #$14,a1

LAB1548 movea.w $012a,a2		MD.SECTR
	jsr	$4000(a2)
	bra.s	LAB1502
* LAB1554 bra.s LAB1548
LAB1556 movea.l a5,a1
	move.b	d7,3(a1)
	bra	LAB14D4
PmdvSect
	bsr	chksmsq
	bne	notimp
	bsr.s	LAB15A2
	bne.s	LAB14FC
	trap	#0		TRAP #0 : Enter supervisor mode
	movem.l a1/a6,-(a7)
	bsr.s	LAB15D4
	bsr	LAB150C
	cmpi.w	#-1,d0
	beq	LAB1502
	lea	$0206(a5),a1	 equivalent to following two lines commented out
;     movea.l	  a5,a1
;     adda.l	  #$0206,a1
	clr.l	d0
	move.b	-(a1),d0
	asl.w	#8,d0
	or.b	-(a1),d0
	move.w	d0,-(a7)
	movea.l a5,a1
	addq.l	#4,a1
	movea.w $0126,a2		MD.WRITE
	jsr	$4000(a2)
	move.w	(a7)+,d0
	bra	LAB14D4
LAB15A2 move.l	a5,d1
	sub.l	a3,d1
	cmpi.l	#8,d1
	bne.s	LAB15CE
	movea.w $0118,a2		CA.GTLIN
	jsr	(a2)		VECTOR utility $118 : CA.GTLIN
	tst.l	d0
	bne.s	LAB15CE
	cmpi.w	#1,d3
	bne.s	LAB15CE
	movea.l 0(a6,a1.l),a5
	moveq	#0,d0
	bra.s	LAB15D0
LAB15CE moveq	#-$0f,d0		ERR.BP
LAB15D0 tst.l	d0
	rts
LAB15D4 moveq	#0,d0
	trap	#1		QDOS TRAP #1 - D0=$00 : MT.INF
	movea.l a0,a6
LAB15DA move.b	$ee(a6),d0	SV.MDRUN
	bne.s	LAB15DA
	ori.w	#$0700,sr set 210
LAB15E4 subq.w	#1,$a6(a0)	SV.TIMO
	blt.s	LAB15F4
	move.w	#$208b,d0
LAB15EE dbf	d0,LAB15EE
	bra.s	LAB15E4
LAB15F4 clr.w	$a6(a0)	SV.TIMO
	movea.l #$00018020,a3
	moveq	#-$19,d0
	and.b	$a0(a6),d0	SV.TMODE
	ori.b	#$10,d0
	move.b	d0,-$1e(a3)
	move.b	d0,$a0(a6)	SV.TMODE
	movea.l a5,a1
	moveq	#3,d2
	move.w	(a1),d1
	subq.w	#1,d1
	bsr.s	LAB1624
	rts
LAB1620 moveq	#2,d2
	moveq	#7,d1
LAB1624 move.b	d2,(a3)
	moveq	#$3c,d0
	ror.l	d0,d0
	andi.b	#1,d2
	move.b	d2,(a3)
	moveq	#$3c,d0
	ror.l	d0,d0
	moveq	#2,d2
	dbf	d1,LAB1624
	rts
      END_IF
SetHeadr	moveq	#$46,d7
	bra.s	LAB1642
GetHeadr	moveq	#$47,d7
LAB1642 cmpa.l	a3,a5
	beq	ParamBad
	move.l	a5,d5
	lea	8(a3),a5		SV.CHPFR
	movea.w $0112,a2		CA.GTINT
	jsr	(a2)		VECTOR utility $112 : CA.GTINT
	bne.s	LAB16A4
	addq.l	#2,$58(a6)	SV.BTBAS
	move.w	0(a1,a6.l),d0
	movea.l a5,a3
	movea.l d5,a5
	mulu	#$28,d0
	add.l	$30(a6),d0
	cmp.l	$34(a6),d0
	bge	LAB05B0
	move.l	0(a6,d0.l),d5
	bmi	LAB05B0
	movea.w $0118,a2		CA.GTLIN
	jsr	(a2)		VECTOR utility $118 : CA.GTLIN
	bne.s	LAB16A4
	subq.w	#1,d3
	bne	ParamBad
	move.l	0(a1,a6.l),d0
	btst	#0,d0
	bne	ParamBad
	movea.l d5,a0
	movea.l d0,a1
	moveq	#$40,d2
	moveq	#-1,d3
	move.l	d7,d0
	trap	#3
LAB16A4 rts
*
* The following    routine tests whether the calling job is running under a
* SuperBASIC Interpreter or a Compiled JobIt should work under	     most QDOS
* variants and it works    in current versions of SBASIC
*
* Idea gained from dissasembly of SMSQ/E JOB_NAME Procedure and comments in
* source of ENV_BIN assumes A6 points to basic variables No registers are
* corrupted only CCR is    changed
*
* DCG
*
* PS If  someone foolishly changes the appropriate area ie -4(A6) with a	 POKE
* on their heads be it That is also reason for checking   what OS we are running
* under.
*
      IF	  REMLIB=0
Tstcmpld	movem.l d0-d2/a0,-(a7)
	tst.l	$54(a6)
	beq.s	Compiled		for Qliberator DCG
	tst.b	$54(a6)
	bpl.s	Interp
	cmpi.l	#'SBAS',-4(a6)
	bne.s	Compiled
      IF	  SMSQ=0
	moveq	#0,d0
	trap	#1
	cmpi.l	#'SMSQ',(a0)
	bne.s	Compiled
	cmpi.l	#'2.00',d2
	blt.s	Compiled
      END_IF
Interp	moveq	#0,d0
	bra.s	Myexit
Compiled moveq	#1,d0
Myexit	 movem.l	(a7)+,d0-d2/a0
	rts
      END_IF
*
* Following heavily modified version of    Mark Knight's long integer code to
* convert string repres    of internal long format	 to long usage:
* long=LON	GINTEGER(str$) DCG + MK
*
StrLong bsr	Ftchstrs		Fetch strings  DCG
	SUBQ.W	#1,D3		Is there just one parameter?
	BNE.S	Bad_Param If not exactly one string, exit.
	cmpi.w	#4,0(a1,a6.l)	Check if length of string is 4	DCG
	BNE.S	Bad_Param if not exactly four exit
	MOVE.L	2(A1,A6.L),D5	Fetch the 4 bytes.
	ADDQ.L	#6,A1		Clear the stack  } put back in
	MOVE.L	A1,$58(A6)	Adjust maths stack pointer } by MK
	bra	LFPrtn		return value	  DCG
*
* FWINDOW% function.
*  Copyright Mark Knight 1997.
*
* Error=FWINDOW%(#Chan%,Width%,Height%,Across%,Down%).
* Can the window be redefined in this way?Returns error code if not, 0	     if OK
*
* MK
*
* Note changed the system call to CA.GTINT to internal call to Ftchints       which
* only returns if no error occurs.  saves a few	more bytes. DCG
*
Fwindow bsr	Ftchints		Fetch integers if return	no error DCG
	SUBQ.W	#5,D3		5 parameters?
	BNE.S	Bad_Param Wrong number of parameters.
	MOVE.W	0(A1,A6.L),D0	Get BASIC channel number.
	ADDQ.L	#2,A1		Discard channel Parameter.
	MOVE.L	A1,$58(A6)	Set maths stack pointer.
Chan_Sel	MULU	#40,D0		Channel table size.
	ADD.L	$30(A6),D0	Add base offset.
	CMP.L	$34(A6),D0	Check against end of channel table.
	BGE.S	What_Chan Past end of channel table? If so      report.
	MOVE.L	0(A6,D0.L),D0	Fetch channel ID.
	BPL.S	Chan_Open Channel isopen if ID is      positive.
What_Chan MOVEQ #-6,D0		CHANNEL NOT OPEN error.
Bad_Exit	RTS
Bad_Param MOVEQ #-15,D0	BAD PARAMETER error.
	RTS
Chan_Open MOVE.L	D0,A0		A0 is now channel ID.
	MOVE.L	$58(A6),A1	Fetch maths stack pointer.
	MOVE.L	4(A1,A6.L),-(SP)	Put top 4 bytes on system stack.
	MOVE.L	0(A1,A6.L),-(SP)	Put low 4 bytes on system stack.
	MOVE.L	SP,A1		Point A1 at start of buffer for SD.WDEF.
	clr.b	d1		v3.29
	clr.w	d2		v3.29
;     MOVE.B	  #0,D1 Clear border colour indicator.
;     MOVE.W	  #0,D2 Border width zero.
;     MOVE.W	  #-1,D3	  Select infinite timeout.
	moveq	#-1,d3
	MOVEQ.L #$0D,D0	Select SD.WDEF, redefine     window...
	TRAP	#3		...and call it.
	TST.L	D0		Any error?
	BNE.S	RetErr		Return the error.
	ADDQ.L	#8,SP		Unstack the parameters on system stack.
	MOVE.L	$58(A6),A1	Retrieve maths stack pointer.
	BSR.S	Discard	Throw	away parameters on	 maths stack.
	MOVEQ.L #0,D1		Return zero result.
Return_Int
	MOVE.W	D1,0(A1,A6.L)	Putresult in space on maths stack.
	MOVEQ	#3,D4		Indicate typeis INTEGER.
	RTS			Return result to SuperBASIC.
RetErr	ADDQ.L	#8,SP		Unstackthe parameters on system   stack.
	MOVE.L	$58(A6),A1	Refetch maths stack pointer.
	MOVE.L	D0,D1		Put error code in D1.
	BSR.S	Discard	Throw	away parameters on	 maths stack.
	MOVEQ.L #0,D0		Signal no error.
	BRA.S	Return_Int	Return theerror  code instead.
Discard ADDQ.L	#6,A1		Throw away six bytes on maths stack.
	MOVE.L	A1,$58(A6)	Save mathsstack  pointer.
	RTS
*
* POKE_F procedure for SuperBASIC/SBASIC.
* POKE_F Address,AnyNumber
* POKEs  the value AnyNumber into the memory at the specified address as	 6 byte
* QDOS floating    point value.
* Address must be even and positive.
* Do NOT add subroutine    calls or further checks	 to this code as it must be fast
* not small!
* MK
*
PokeFlot	LEA.L	2*8(A3),A0	Two parameters to		check.
	CMPA.L	A0,A5		Are there two?
	BNE.S	Bad_Param If not two exit with BAD	PARAMETER report.
	SUBQ.L	#8,A5		Hide last parameter from QDOS.
	MOVE.W	$118,A0	$118 = CA.GTLIN vector, fetch     LongInt(s).
	JSR	(A0)		Call the routine...
	BNE.S	PokeDone		If any error then report    it.
	MOVE.L	$58(A6),A1	Fetch RI stack pointer.
	MOVE.L	0(A1,A6.L),D7	Fetch the address parameter.
	BMI.S	Bad_Param If negative then  report BAD PARAMETER.
	BTST	#0,D7		Is it even?
	BNE.S	Bad_Param If not even then  report BAD PARAMETER.
	MOVE.L	A5,A3		Point base parameter pointer at old top.
	ADDQ.L	#8,A5		Retrieve lastparameter.
	MOVE.W	$114,A0	$114=CA.GTFP vector, fetch Float(s).
	JSR	(A0)		Call the routine...
	BNE.S	PokeDone		If any error then report    it.
	MOVEA.L D7,A4		Put address in A4 for use as pointer.
	MOVE.L	0(A1,A6.L),(A4)+	Move first longword...
	MOVE.W	4(A1,A6.L),(A4) Move last word.
	MOVEQ.L #0,D0		0 in D0 indicates no error.
PokeDone	 RTS

;
; GWWD reads one string parameter
; discards it and returns 1
; as floating point
; it is a dummy directive routine
; DCG
;
;
	IF REMLIB=0
GWWD	LEA	8(A3),A0
	CMPA.L	A5,A0
	BNE	BAD_PARAM    ---->
	MOVEA.W CA_GTSTR,A2
	JSR	(A2)
	BNE	BAD_PARAM  ---->
	MOVE.W	(A1,A6.L),D0
	ADDQ.W	#3,D0
	BCLR	#0,D0
	EXT.L	D0
	ADD.L	D0,$58(A6)
	moveq	#1,d5
	bra	LFPrtn
	END_IF
* TDUMMY	moveq	#-19,d0
*	 rts

LAB16A6 dc.b	$0a,8,0,0
	dc.b	$aa,$aa,0,$14	; ..
	dc.b	$64,0,$e4,$0c	; d...
	dc.b	$10,0,3
LAB16B5 ds.b	0
	      IF	  REMLIB=0
LAB16B6 dc.w	11
	dc.b	'PARSER_TASK'
LAB16C3 ds.b	0
LAB16C4 dc.w	12
	dc.b	'CODEGEN_TASK'
LAB16D2 dc.w	5
	dc.b	'CLEAR'
LAB16D9 ds.b	0
	      IF	  SMSQ=0
CallName	dc.w	4
	dc.b	'CALL'
	      END_IF
	      END_IF
LAB16E0 dc.w	7
	dc.b	'No name'
LAB16E9 dc.b	0
LAB16EA dc.w	5
	dc.b	'BASIC'
LAB16F1 dc.b	0
LAB16F2 dc.w	2
	dc.b	', '
LAB16F6 dc.l	$00022e0a ; ....
LAB16FA dc.l	$0002730a ; ..s.
LAB16FE dc.w	16
	dc.b	'Module mismatch '
LAB1710 dc.w	4
	dc.b	'E & '
LAB1716 dc.w	10
	dc.b	'G at item '
LAB1722 dc.w	4
	dc.b	' in '
LAB1728 dc.w	20
	dc.b	'D.P.:TURBO:INTER-COM'
;DfltName  dc.b  'flp1_'
;LAB1743	 dc.b	 1		now CDEA0 in Config block
LAB1744 dc.w	$20ff	; .	Set from Config block
LAB1746 dc.w	$28		; .(
LAB1748 dc.w	15
	dc.b	'PIPE_0000000000'	Length filled from Config block
PIPE_END	ds.b	0		Label @ end of name
LAB1754 dc.w	4
	dc.b	'PIPE'
buffer	ds.b	10			A ten byte space for long word conversion
b_end	ds.b	0

LTOD	LIB	WIN1_LIB_LTOD_BIN	Converts positive long word to ASCII

/* Configured Items - Config Level 1
*
* Name	 Description
* WRDA0  Buffer length for EDIT$
* WRDA1  Pipe Length
* CHRA0  Abort Key
* CDEA0  Beep for EDIT
* CDEA1  ALT with abort key?
* STRA0  Default Device
*/

  DC.L	'<<QC','FX>>'
  DC.B	'01'			; Level
  DC.W	0
  DC.W	6
  DC.B	'1.01  '			; Version Number
  DS.W	0

; Integers
  DC.B	10,0
  DC.W	WRDA0-*		; -> Item
  DC.W	0			; -> pre-processing
  DC.W	0			; -> post-processing
  DC.W	D_WRDA0-* 	; -> Description
  DC.W	A_WRDA0-* 	; -> Attribute
  DC.B	12,0
  DC.W	WRDA1-*		; -> Item
  DC.W	0			; -> pre-processing
  DC.W	0			; -> post-processing
  DC.W	D_WRDA1-* 	; -> Description
  DC.W	A_WRDA1-* 	; -> Attribute

; Characters
  DC.B	2,0
  DC.W	CHRA0-*		; -> Item
  DC.W	0			; -> pre-processing
  DC.W	0			; -> post-processing
  DC.W	D_CHRA0-* 	; -> Description
  DC.W	A_CHRA0-* 	; -> Attribute

; Codes
  DC.B	4,0
  DC.W	CDEA0-*		; -> Item
  DC.W	0			; -> pre-processing
  DC.W	0			; -> post-processing
  DC.W	D_CDEA0-* 	; -> Description
  DC.W	A_CDEA0-* 	; -> Attribute
  DC.B	4,0
  DC.W	CDEA1-*		; -> Item
  DC.W	0			; -> pre-processing
  DC.W	0			; -> post-processing
  DC.W	D_CDEA1-* 	; -> Description
  DC.W	A_CDEA1-* 	; -> Attribute

; Strings
  DC.B	0,0
  DC.W	I_STRA0-* 	; -> Item
  DC.W	0			; -> pre-processing
  DC.W	0			; -> post-processing
  DC.W	D_STRA0-* 	; -> Description
  DC.W	A_STRA0-* 	; -> Attribute
  DC.W	-1			; end of item list

; Descriptions
D_WRDA0
  DC.W	23
  DC.B	'Buffer length for EDIT$'
  DS.W	0
D_WRDA1
  DC.W	11
  DC.B	'Pipe Length'
  DS.W	0
D_CHRA0
  DC.W	9
  DC.B	'Abort Key'
  DS.W	0
D_CDEA0
  DC.W	13
  DC.B	'Beep for EDIT'
  DS.W	0
D_CDEA1
  DC.W	19
  DC.B	'ALT with abort key?'
  DS.W	0
D_STRA0
  DC.W	14
  DC.B	'Default Device'
  DS.W	0

; Attributes
A_WRDA0
  DC.W	2,9999
A_WRDA1
  DC.L	1,2147483647
A_CHRA0
  DC.W	$005F
A_CDEA0
  DC.B	0,0
  DC.W	16
  DC.B	'No              '
  DS.W	0
  DC.B	1,0
  DC.W	16
  DC.B	'Yes             '
  DS.W	0
  DC.W	-1
A_CDEA1
  DC.B	0,0
  DC.W	16
  DC.B	'No              '
  DS.W	0
  DC.B	1,0
  DC.W	16
  DC.B	'Yes             '
  DS.W	0
  DC.W	-1
A_STRA0
  DC.W	$0000

; Items
WRDA0
  DC.W	40
WRDA1
  DC.L	200
CHRA0
  DC.B	32
  DS.W	0
CDEA0
  DC.B	1
CDEA1
  DC.B	1
  DS.W	0
I_STRA0
  DC.W	5
STRA0
  DC.W	5
DfltName	DC.B	'ram1_'
  DS.W	0
  DS.B	0
  DS.W	0
	      END
